/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"



void
main(int argc,  char **argv)
{
      int    ret ;
      int    adct_cph, ddct_cph, udct_cph ;
      int    adct_cpt, ddct_cpt, udct_cpt ;
      int    adct_cpc, ddct_cpc, udct_cpc ;
      unsigned char   buff[16386] ; 


      InitEdrTbl() ;

      WORD_DB_Open() ;
      DB_FileOpen() ;
      GROUP_DB_Open() ;


      adct_cph =  ddct_cph =  udct_cph = 0 ;
      adct_cpt =  ddct_cpt =  udct_cpt = 0 ;
      adct_cpc =  ddct_cpc =  udct_cpc = 0 ;

      while( gets(buff) != NULL ){
          if ( buff[0] == '#' || buff[0] == '\0' ) {
            continue ;
	  }
          /*                                       */         
          if ( strncmp( buff, "UPD:\tCPC", 8) == 0 ) {
            ret = Update_CPC_DB( &buff[5] ) ;
            if ( ret >= 0 )
              udct_cpc++ ;
            continue ;
	  }
          if ( strncmp( buff, "UPD:\tCPT", 8) == 0 ) {
            ret = Update_CPT_DB( &buff[5]) ;
            if ( ret >= 0 )
              udct_cpt++ ;
            continue ;
	  }
          if ( strncmp( buff, "UPD:\tCPH", 8) == 0 ) {
            ret = Update_CPH_DB( &buff[5]) ;
            if ( ret >= 0 )
              udct_cph++ ;
            continue ;
	  }
          /*                                       */         
          if ( strncmp( buff, "DEL:\tCPC", 8) == 0 ) {
            ret = Delete_CPC_DB( &buff[5] ) ;
            if ( ret >= 0 )
              ddct_cpc++ ;
            continue ;
	  }
          if ( strncmp( buff, "DEL:\tCPT", 8) == 0 ) {
            ret = Delete_CPT_DB( &buff[5] ) ;
            if ( ret >= 0 )
              ddct_cpt++ ;
            continue ;
	  }
          /*                                      ɲý */         
          if ( strncmp( buff, "ADD:\tCPC", 8) == 0 ) {
            ret = Add_CPC_DB( &buff[5]) ;
            if ( ret >= 0 )
              adct_cpc++ ;
            continue ;
	  }
          if ( strncmp( buff, "ADD:\tCPT", 8) == 0 ) {
            ret = Add_CPT_DB( &buff[5]) ;
            if ( ret >= 0 )
              adct_cpt++ ;
            continue ;
	  }
          if ( strncmp( buff, "ADD:\tCPH", 8) == 0 ) {
            ret = Add_CPH_DB( &buff[5]) ;
            if ( ret >= 0 )
              adct_cph++ ;
            continue ;
	  }
          fprintf(stderr,"ERROR:ϥǡ顼[%s]\n",buff) ;
      }
      fprintf( stderr,"ǰη    UPD: %d   DEL: %d   ADD: %d\n",udct_cpc,ddct_cpc,adct_cpc) ;      
      fprintf( stderr,"ǰ    UPD: %d   DEL: %d   ADD: %d\n",udct_cpt,ddct_cpt,adct_cpt) ;      
      fprintf( stderr,"ǰФ  UPD: %d   DEL: 0   ADD: %d\n",udct_cph,adct_cph) ;      

      GROUP_DB_Close() ;
      DB_FileClose() ;
      WORD_DB_Close() ;
      return ;
}





/**********************************************************
*   ǰФ        ɲϿ
*   USAGE:	        Add_CPH_DB( unsigned char *buff )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*
*   DESCRIPTION:	
*	ǰФɲϿԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Add_CPH_DB( unsigned char *buff )
{
  unsigned char   buff2[8192] ;
  int    ret ;
  char  work[8192], *cary[32] ;
  int Rid ;
  int ii ;
  int len ;

  if ( CHID2CPRecID == NULL )   /*** ConceptID ==> ConceptRecordID ***/
    return -1 ;
  if ( CPHRecId2Val == NULL )   /*** ConceptRecordID ==> record ***/
    return -1 ;

  // printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  len = CreateCphRec( buff, buff2, 16386 ) ;
  //  | Rec-ID | ǰID\0 | ǰФ(E)\0 |
  //  |  (4)   | (n)      | (n)             |

  //   | ǰФ(J)\0 | ǰ(E)\0 | ǰ(J) | \0 |
  //   | (n)             | (n)           | (n)    )    | (n)        |

  Rid = get4byte( buff2 ) ;
  if ( Rid != 0 ) {
    ret = Get_DataLeng( CPHRecId2Val,  buff2, 4) ;
    if ( ret != 0 ) {
      fprintf( stderr, "ERROR(Add_CPH_DB):쥳ֹ[%s]ΤΤϿѤߤǤ\n", buff) ;
      return -1 ;
    }
    SetMaxCPHRID( Rid ) ;
  }
  else {    /* ϿΥ쥳ɣɣĤ */
    if ( ( Rid = GetNewCPHRID() ) == -1 )
      return -1 ;
    *(int *)buff2 = Rid ;
  }

  ret = Get_DataLeng( CHID2CPRecID,  &buff2[4], strlen(  &buff2[4] ) ) ;
  if ( ret != 0 ) {
    fprintf( stderr, "ERROR(Add_CPH_DB):ǰ̻[ %s ]ϴϿƤޤ\n", &buff2[4]) ;
    return -1 ;
  }

  /* ¥쥳ɤϿ */
  ret = Put_IXT( CPHRecId2Val, buff2, 4, buff2, len) ;

  /*** ǥå ***/
  ret = Put_IXT( CHID2CPRecID, &buff2[4], strlen(&buff2[4]), (char *)&Rid, 4 ) ;

  /* Ǽ */
  ret = StartPtsCPH(buff2, len, cary) ;
  ret = PutCPHLOG( "ADD", 'B', Rid, cary[1], cary[2], cary[3], cary[4] ,cary[5] ) ;

  return 1 ;
}



/**********************************************************
*   ǰФ        
*   USAGE:	        Update_CPH_DB( unsigned char *buff )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*
*   DESCRIPTION:	
*	ǰФѹϿԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Update_CPH_DB( unsigned char *buff )
{
  unsigned char   buff2[8192] ;
  int    ret ;
  char  work[8192] ;
  int   Rid ;
  int   len ;


  if ( CHID2CPRecID == NULL )   /*** ConceptID ==> ConceptRecordID ***/
    return -1 ;
  if ( CPHRecId2Val == NULL )   /*** ConceptRecordID ==> record ***/
    return -1 ;

  // printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  len = CreateCphRec( buff, buff2, 16386 ) ;
  //  | Rec-ID | ǰID\0 | ǰФ(E)\0 |
  //  |  (4)   | (n)      | (n)             |

  //   | ǰФ(J)\0 | ǰ(E)\0 | ǰ(J) | \0 |
  //   | (n)             | (n)           | (n)    )    | (n)        |


  ret = Get_IXT( CHID2CPRecID,  &buff2[4], strlen(  &buff2[4] ), work, 1024) ;
  if ( ret == 0 ) {
    fprintf( stderr, "ERROR(Update_CPH_DB):ǰ̻[ %s ]ϿƤޤ\n", &buff2[4]) ;
    return -1 ;
  }
  
  Rid = get4byte( buff2 ) ;
  if ( Rid == 0 ) {    /* ʳǰҥ쥳ɣɣĤγ */
    fprintf( stderr, "ERROR(Update_CPH_DB):оݤΥ쥳ֹꤷƤ\n" ) ;
    fprintf( stderr, "   DATA[%s]\n", buff) ;
    return -1 ;
  }

  ret = Get_IXT( CPHRecId2Val,  &buff2[0], 4, work, 1024) ;
  if ( ret == 0 ) {
    fprintf( stderr, "ERROR(Update_CPH_DB):쥳ɣɣ[ %s ]Υ쥳ɤϿƤޤ\n", &buff2[4]) ;
    return -1 ;
  }
  if ( strcmp( &buff2[4], &work[4] ) != 0 ) {
    fprintf( stderr, "ERROR(Update_CPH_DB):ǰ̻ҼΤѹϤǤޤ󡣡%s=>%s\n", &work[4], &buff2[4]) ;
    return -1 ;
  }
  /* ¥쥳ɤϿ */
  ret = Put_IXT( CPHRecId2Val, buff2, 4, buff2, len) ;

  return 1 ;

}




/**********************************************************
*   ǰη        ɲϿ
*   USAGE:	        Add_CPC_DB( unsigned char *buff )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*
*   DESCRIPTION:	
*	ǰطμʳǰηϡˤɲϿԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Add_CPC_DB( unsigned char *buff )
{
  unsigned char   buff2[16386] ;
  int    ret ;
  char  work[8] ;
  char  *cary[64] ;
  int Rid ;
  int len , ll ;


  if ( CHID2CPRecID == NULL )   /*** ConceptID ==> ConceptRecordID ***/
    return -1 ;
  if ( CPHRecId2Val == NULL )   /*** ConceptRecordID ==> record ***/
    return -1 ;

  if ( CCID2CPRecID == NULL )   /*** ConceptID ==> ClassificationRecordID ***/
    return -1 ;
  if ( CPCRecId2Val == NULL )   /*** ClassificatonRecordID ==> record ***/
    return -1 ;


  //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  len = CreateCpcRec( buff, buff2, 16386 ) ;
  ret = StartPtsCPC( buff2, len, cary) ;
  //  | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
  //  |  (4)   | (n)          | (n)          | (n)        |

  /* ǰ̻ҤϳǰФμϿƤΤǧ */
  ll = Get_DataLeng( CHID2CPRecID,  cary[1], strlen( cary[1] ) ) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Add_CPC_DB):̳ǰ̻[ %s ]ϿƤޤ\n", cary[1]) ;
    return -1 ;
  }
  ll = Get_DataLeng( CHID2CPRecID,  cary[2], strlen( cary[2] ) ) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Add_CPC_DB):̳ǰ̻[ %s ]ϿƤޤ\n", cary[2]) ;
    return -1 ;
  }

  /* ̳ǰ̻ҤηϾ塢ʬवƤ뤫ǧ */
  ll = Get_DataLeng( CCID2CPRecID,  cary[1], strlen( cary[1] ) ) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Add_CPC_DB):̳ǰ̻[ %s ]ϿƤޤ\n", cary[1]) ;
    return -1 ;
  }
  ll = CheckDown( 'B', cary[1], cary[2] ) ; /* ̡᲼̳ǰƱΤ¸ߤƤ뤫ǧ */
  if ( ll >= 0 ) {
    fprintf( stderr,"ERROR: already exist(CPC [%s]=>[%s])\n", cary[1], cary[2]) ;
    return ;
  }

  Rid = get4byte( buff2 ) ;
  if ( Rid != 0 ) {
    ll = Get_DataLeng( CPCRecId2Val,  buff2, 4) ;
    if ( ll != 0 ) {
      fprintf( stderr, "ERROR(Add_CPC_DB):쥳ֹ[%s]ΤΤϿѤߤǤ\n", buff) ;
      return -1 ;
    }
    SetMaxCPCRID( Rid ) ;
  }
  else {    /* ϿΥ쥳ɣɣĤ */
    if ( ( Rid = GetNewCPCRID() ) == -1 )
      return -1 ;
    *(int *)buff2 = Rid ;
  }

  /* ¥쥳ɤϿ */
  ret = Put_IXT( CPCRecId2Val, buff2, 4, buff2, len) ;

  /*** ǥå ***/
  memcpy( work, buff2, 4 ) ;
  /* ̳ǰ쥳ֹ ɲ */
  work[4] = 0x02 ;
  ret = Add_IXT_DATA2( CCID2CPRecID, cary[1], strlen(cary[1]), work, 5) ;
  if ( ret <= 0 ) {
     fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",cary[1],Rid) ;
     return -1  ;
  }
  /* ̳ǰ쥳ֹ ɲ */
  work[4] = 0x01 ;
  ret = Add_IXT_DATA2( CCID2CPRecID, cary[2], strlen(cary[2]), work, 5) ;
  if ( ret <= 0 ) {
    fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",cary[2],Rid) ;
    return -1 ;
  }
  return 1 ;
}



/**********************************************************
*   ǰη        
*   USAGE:	        Update_CPC_DB( unsigned char *buff )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*
*   DESCRIPTION:	
*	ǰطʳǰηϡˤѹϿԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Update_CPC_DB( unsigned char *buff )
{
  unsigned char  old[8192], buff2[8192] ;
  int    ret ;
  char  work[8] ;
  char  *cary[64], *oary[64] ;
  int Rid ;
  int len , ll ;


  if ( CHID2CPRecID == NULL )   /*** ConceptID ==> ConceptRecordID ***/
    return -1 ;
  if ( CPHRecId2Val == NULL )   /*** ConceptRecordID ==> record ***/
    return -1 ;

  if ( CCID2CPRecID == NULL )   /*** ConceptID ==> ClassificationRecordID ***/
    return -1 ;
  if ( CPCRecId2Val == NULL )   /*** ClassificatonRecordID ==> record ***/
    return -1 ;

  //printf("Update_CPC_DB:IN>[%s](%d)\n",buff,strlen(buff)) ;
  len = CreateCpcRec( buff, buff2, 16386 ) ;
  ret = StartPtsCPC( buff2, len, cary) ;
  //  | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
  //  |  (4)   | (n)          | (n)          | (n)        |

  /* ǰ̻ҤϳǰФμϿƤΤǧ */
  ll = Get_DataLeng( CHID2CPRecID,  cary[1], strlen( cary[1] ) ) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Upd_CPC_DB):̳ǰ̻[ %s ]ϿƤޤ\n", cary[1]) ;
    return -1 ;
  }
  ll = Get_DataLeng( CHID2CPRecID,  cary[2], strlen( cary[2] ) ) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Upd_CPC_DB):̳ǰ̻[ %s ]ϿƤޤ\n", cary[2]) ;
    return -1 ;
  }

  /* ̳ǰ̻ҤηϾ塢ʬवƤ뤫ǧ */
  ll = Get_IXT( CCID2CPRecID,  cary[1], strlen( cary[1] ), old, 81192 ) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Upd_CPC_DB):̳ǰ̻[ %s ]ϿƤޤ\n", cary[1]) ;
    return -1 ;
  }

  ll = CheckDown( 'B', cary[1], cary[2] ) ; /* ̡᲼̳ǰƱΤ¸ߤƤ뤫ǧ */
  if ( ll >= 0 ) {
    fprintf( stderr,"ERROR: already exist(CPC [%s]=>[%s])\n", cary[1], cary[2]) ;
    return ;
  }
 
  /* Υǡ򥲥å */
  ll = Get_IXT( CPCRecId2Val,  buff2, 4, old, 81192 ) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Upd_CPC_DB):оݥ쥳[ %s ]ϿƤޤ\n", buff) ;
    return -1 ;
  }
  ret = StartPtsCPC( old, ll, oary) ;

  Rid = get4byte( buff2 ) ;
  if ( Rid == 0 ) {    /* ϿΥ쥳ɣɣĤ */
    fprintf( stderr, "ERROR(Upd_CPC_DB):оݤΥ쥳ֹꤷƤ\n" ) ;
    fprintf( stderr, "   DATA[%s]\n", buff) ;
    return -1 ;
  }

  /* ¥쥳ɤϿ */
  ret = Put_IXT( CPCRecId2Val, buff2, 4, buff2, len) ;

  /*** ǥå ***/
  memcpy( work, buff2, 4 ) ;
  if ( strcmp(cary[1], oary[1]) != 0 ) {    /* ̳ǰ쥳ֹ ɲ */
    work[4] = 0x02 ;
    ret = Rem_IXT_DATA( CCID2CPRecID, oary[1], strlen(oary[1]), work, 5) ;
    ret = Add_IXT_DATA2( CCID2CPRecID, cary[1], strlen(cary[1]), work, 5) ;
    if ( ret <= 0 ) {
      fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",cary[1],Rid) ;
      return -1  ;
    }
  }
  if ( strcmp(cary[2], oary[2]) != 0 ) {    /* ̳ǰ쥳ֹ ɲ */
    work[4] = 0x01 ;
    ret = Rem_IXT_DATA( CCID2CPRecID, oary[2], strlen(oary[2]), work, 5) ;
    ret = Add_IXT_DATA2( CCID2CPRecID, cary[2], strlen(cary[2]), work, 5) ;
    if ( ret <= 0 ) {
      fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",cary[2],Rid) ;
      return -1 ;
    }
  }

  return 1 ;

}





/**********************************************************
*   ǰη        
*   USAGE:	        Delete_CPC_DB( unsigned char *buff )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*
*   DESCRIPTION:	
*	ǰطμʳǰηϡˤɲϿԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Delete_CPC_DB( unsigned char *buff )
{
  char dict[8], rnum[12] ;
  char *cary[64] ;
  unsigned char   buff2[16386] ;
  int    ret ;
  char  work[1024], work1[8] ;
  int Rid ;
  int len ;

  if ( CCID2CPRecID == NULL )   /*** ConceptID ==> ClassificationRecordID ***/
    return -1 ;
  if ( CPCRecId2Val == NULL )   /*** ClassificatonRecordID ==> record ***/
    return -1 ;

  //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  Rid = GetCode2Wid( buff, dict, rnum) ;
  len = Get_IXT( CPCRecId2Val, (char *)&Rid, 4, work, 1024) ;
  if ( len == 0 ) {
    fprintf( stderr, "ERROR(Delete_CPC_DB):μ[ %s ]ϿƤޤ\n",buff) ;
    return -1 ;
  }

  ret = StartPtsCPC( work, len, cary) ;
  //  | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
  //  |  (4)   | (n)          | (n)          | (n)        |


  /* ¥쥳ɤκ */
  ret = Put_IXT( CPCRecId2Val, (char *)&Rid, 4, "", 0) ;

  /*** ǥå ***/
  /* ̳ǰ쥳ֹ  */
  memcpy(work1, work, 4) ;
  work1[4] = 0x02 ;
  ret = Rem_IXT_DATA( CCID2CPRecID, cary[1], strlen(cary[1]) , work1, 5) ;
  /* ̳ǰ쥳ֹ  */
  work1[4] = 0x01 ;
  ret = Rem_IXT_DATA( CCID2CPRecID, cary[2], strlen(cary[2]) , work1, 5) ;

  return 1 ;
}






/**********************************************************
*   ǰ        ɲϿ
*   USAGE:	        Add_CPT_DB( unsigned char *buff )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*
*   DESCRIPTION:	
*	ǰطμʳǰҡˤɲϿԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Add_CPT_DB( unsigned char *buff )
{
  unsigned char   buff2[16386] ;
  int    ret ;
  char  *cary[64] ;
  char   work[1024] ;
  int    Rid ;
  int    len, ll ;

  if ( CHID2CPRecID == NULL )   /*** ConceptID ==> ConceptRecordID ***/
    return -1 ;
  if ( CPHRecId2Val == NULL )   /*** ConceptRecordID ==> record ***/
    return -1 ;


  if ( CTID2CPRecID == NULL )   /*** ConceptID ==> ConceptDescriptionRecordID ***/
    return -1 ;
  if ( CPTRecId2Val == NULL )   /*** ConceptDescriptionRecordID ==> record ***/
    return -1 ;


  //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  len = CreateCptRec( buff, buff2, 16386 ) ;
  ret = StartPtsCPT( buff2, len, cary) ;
  //        | Rec-ID | FLAG | طID | 긵ǰID\0 |
  //        |  (4)   | (1)  | (1)      | (n)            |
  //
  //        | 賵ǰID\0 | \0 |
  //        | (n)            | (n)        |
  //
  //             FLAG:  Ҷʬ    
  //                    FLAG & 0x01 == 0B : Ҷʬ  I
  //                    FLAG & 0x01 == 1B : Ҷʬ  E
  //                    FLAG & 0x02 == 0B :    
  //                    FLAG & 0x02 == 1B :    

  /* ǰ̻ҤϳǰФμϿƤΤǧ */
  ll = Get_IXT( CHID2CPRecID,  cary[3], strlen( cary[3] ), work, 1024) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Add_CPT_DB):濴ǰ̻[ %s ]ϿƤꤻ\n", cary[3]) ;
    return -1 ;
  }
  ll = Get_IXT( CHID2CPRecID,  cary[4], strlen( cary[4] ), work, 1024) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Add_CPT_DB):ꡦǰ̻[ %s ]ϿƤޤ\n", cary[4]) ;
    return -1 ;
  }

  
  Rid = get4byte( buff2 ) ;
  if ( Rid != 0 ) {
    ll = Get_DataLeng( CPTRecId2Val,  buff2, 4) ;
    if ( ll != 0 ) {
      fprintf( stderr, "ERROR(Add_CPT_DB):쥳ֹ[%s]ΤΤϿѤߤǤ\n", buff) ;
      return -1 ;
    }
    SetMaxCPTRID( Rid ) ;
  }
  else {        /* ʳǰҥ쥳ɣɣĤγ */
    if ( ( Rid = GetNewCPTRID() ) == -1 )
      return -1 ;
    *(int *)buff2 = Rid ;
  }

  /* ¥쥳ɤϿ */
  ret = Put_IXT( CPTRecId2Val, buff2, 4, buff2, len) ;

  /*** ǥå ***/
  memcpy( work, buff2, 4 ) ;
  /* 濴ǰ쥳ֹ ɲ */
  work[4] = 0x02 ;
  ret = Add_IXT_DATA2( CTID2CPRecID, cary[3], strlen(cary[3]), work, 5) ;
  if ( ret <= 0 ) {
     fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",cary[3],Rid) ;
     return -1  ;
  }
  /* ꡦǰ쥳ֹ ɲ */
  work[4] = 0x01 ;
  ret = Add_IXT_DATA2( CTID2CPRecID, cary[4], strlen(cary[4]), work, 5) ;
  if ( ret <= 0 ) {
    fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",cary[4],Rid) ;
  return -1 ;
  }

  return 1 ;
}



/**********************************************************
*   ǰ        
*   USAGE:	        Update_CPT_DB( unsigned char *buff )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*
*   DESCRIPTION:	
*	ǰطʳǰҡˤѹϿԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Update_CPT_DB( unsigned char *buff )
{
  unsigned char   buff2[8192] ;
  int    ret ;
  char  *cary[64], *oary[64] ;
  char   work[8192] ;
  int    Rid ;
  int    len, ll ;

  if ( CHID2CPRecID == NULL )   /*** ConceptID ==> ConceptRecordID ***/
    return -1 ;
  if ( CPHRecId2Val == NULL )   /*** ConceptRecordID ==> record ***/
    return -1 ;


  if ( CTID2CPRecID == NULL )   /*** ConceptID ==> ConceptDescriptionRecordID ***/
    return -1 ;
  if ( CPTRecId2Val == NULL )   /*** ConceptDescriptionRecordID ==> record ***/
    return -1 ;


  //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  len = CreateCptRec( buff, buff2, 16386 ) ;
  ret = StartPtsCPT( buff2, len, cary) ;
  //        | Rec-ID | FLAG | طID | 긵ǰID\0 |
  //        |  (4)   | (1)  | (1)      | (n)            |
  //
  //        | 賵ǰID\0 | \0 |
  //        | (n)            | (n)        |
  //
  //             FLAG:  Ҷʬ    
  //                    FLAG & 0x01 == 0B : Ҷʬ  I
  //                    FLAG & 0x01 == 1B : Ҷʬ  E
  //                    FLAG & 0x02 == 0B :    
  //                    FLAG & 0x02 == 1B :    

  /* ǰ̻ҤϳǰФμϿƤΤǧ */
  ll = Get_IXT( CHID2CPRecID,  cary[3], strlen( cary[3] ), work, 1024) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Upd_CPT_DB):濴ǰ̻[ %s ]ϿƤޤ\n", cary[3]) ;
    return -1 ;
  }
  ll = Get_IXT( CHID2CPRecID,  cary[4], strlen( cary[4] ), work, 1024) ;
  if ( ll == 0 ) {
    fprintf( stderr, "ERROR(Upd_CPT_DB):ꡦǰ̻[ %s ]ϿƤޤ\n", cary[4]) ;
    return -1 ;
  }

  Rid = get4byte( buff2 ) ;
  if ( Rid == 0 ) {    /* ʳǰҥ쥳ɣɣĤγ */
    fprintf( stderr, "ERROR(Upd_CPT_DB):оݤΥ쥳ֹꤷƤ\n") ;
    fprintf( stderr, "   DATA[%s]\n", buff) ;
    return -1 ;
  }

  ret = Get_IXT( CPTRecId2Val, buff2, 4, work, 8192) ;
  if ( ret == 0 ) {
    fprintf( stderr, "ERROR(Upd_CPT_DB):оݥ쥳[ %s ]ϿƤޤ\n", buff) ;
    return -1 ;
  }
  ret = StartPtsCPT( work, ret, oary) ;

  /* ¥쥳ɤϿ */
  ret = Put_IXT( CPTRecId2Val, buff2, 4, buff2, len) ;

  /*** ǥå ***/
  memcpy( work, buff2, 4 ) ;
  if ( strcmp( cary[3], oary[3] ) != 0 ) {  /* 濴ǰ쥳ֹ  */
    work[4] = 0x02 ;
    ret = Rem_IXT_DATA( CTID2CPRecID, oary[3], strlen(oary[3]), work, 5) ;
    ret = Add_IXT_DATA2( CTID2CPRecID, cary[3], strlen(cary[3]), work, 5) ;
    if ( ret <= 0 ) {
      fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",cary[3],Rid) ;
      return -1  ;
    }
  }
  if ( strcmp( cary[4], oary[4] ) != 0 ) { /* ꡦǰ쥳ֹ ɲ */
    work[4] = 0x01 ;
    ret = Rem_IXT_DATA( CTID2CPRecID, oary[4], strlen(oary[4]), work, 5) ;
    ret = Add_IXT_DATA2( CTID2CPRecID, cary[4], strlen(cary[4]), work, 5) ;
    if ( ret <= 0 ) {
      fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",cary[4],Rid) ;
      return -1 ;
    }
  }
  return 1 ;
}





/**********************************************************
*   ǰ        
*   USAGE:	        Delete_CPT_DB( unsigned char *buff )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*
*   DESCRIPTION:	
*	ǰطμʳǰҡˤɲϿԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Delete_CPT_DB( unsigned char *buff )
{
  char dict[8], rnum[12] ;
  char *cary[64] ;
  int    ret ;
  char  work[1024], work1[8] ;
  int Rid ;
  int len ;


  if ( CTID2CPRecID == NULL )   /*** ConceptID ==> ConceptDescriptionRecordID ***/
    return -1 ;
  if ( CPTRecId2Val == NULL )   /*** ConceptDescriptionRecordID ==> record ***/
    return -1 ;

  //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  Rid = GetCode2Wid( buff, dict, rnum) ;
  len = Get_IXT( CPTRecId2Val, (char *)&Rid, 4, work, 1024) ;
  if ( len == 0 ) {
    fprintf( stderr, "ERROR(Delete_CPT_DB):μ[ %s ]ϿƤޤ\n",buff) ;
    return -1 ;
  }

  ret = StartPtsCPT( work, len, cary) ;
  //  | Rec-ID | FLAG | طID | 긵ǰID\0 |
  //  |  (4)   | (1)  | (1)      | (n)            |
  //
  //  | 賵ǰID\0 | \0 |
  //  | (n)            | (n)        |


  /* ¥쥳ɤκ */
  ret = Put_IXT( CPTRecId2Val, (char *)&Rid, 4, "", 0) ;

  /*** ǥå ***/
   memcpy( work1, work, 4) ;
  /* 濴ǰ쥳ֹ  */
  work1[4] = 0x02 ;
  ret = Rem_IXT_DATA( CTID2CPRecID, cary[3], strlen(cary[3]) , work1, 5) ;

  /* ꡦǰ쥳ֹ  */
  work1[4] = 0x01 ;
  ret = Rem_IXT_DATA( CTID2CPRecID, cary[4], strlen(cary[4]) , work1, 5) ;

  return 1 ;
}








