/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"



void
main(int argc,  char **argv)
{
      int    ret ;
      int    adct, ddct, udct ;
      unsigned int stat;
      unsigned char   buff[16386] ; 
      char *wdenv, *cp ;
      char file[512] ;
      int len ;
      int dbflag = 0 ;

      if ( argc > 1 ) {
        if ( strcmp( *(argv+1), "-AM" ) == 0 ) 
          dbflag = 1 ;
      }

      InitEdrTbl() ;

      WORD_DB_Open() ;
      DB_FileOpen() ;
      GROUP_DB_Open() ;

      adct = udct = ddct = 0 ;

      while( gets(buff) != NULL ){
          if ( buff[0] == '#' ) {
            continue ;
	  }
         
          if ( strncmp( buff, "UPD:\tJWD", 8) == 0 ) {
            ret = Update_JWD_DB( &buff[5], dbflag ) ;
            if ( ret >= 0 )
              udct++ ;
            continue ;
	  }
          if ( strncmp( buff, "DEL:\tJWD", 8) == 0 ) {
            ret = Delete_JWD_DB( &buff[5] ) ;
            if ( ret >= 0 )
              ddct++ ;
            continue ;
	  }
          if ( strncmp( buff, "ADD:\tJWD", 8) == 0 ) {
            ret = Add_JWD_DB( &buff[5], dbflag ) ;
            if ( ret >= 0 )
              adct++ ;
            continue ;
	  }
          cp = skip_non_sp( buff ) ;
          if ( cp == NULL)
            continue ;
          fprintf(stderr,"ERROR:ϥǡ顼[%s]\n",buff) ;
      }
      fprintf( stderr," UPD: %d   DEL: %d   ADD: %d\n",udct,ddct,adct) ;      

printf("GROUP_DB_Close\n") ;
      GROUP_DB_Close() ;
printf("DB_FileClose\n") ;
      DB_FileClose() ;
printf("WORD_DB_Close\n") ;
      WORD_DB_Close() ;
      return ;
}


/**********************************************************
*   ܸ áʸˡμ    ɲϿ
*   USAGE:	        Add_JWD_DB( unsigned char *buff, int flag )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*                       int     flag   (IN)  ե饰ʹ̵뤹ϣ
*
*   DESCRIPTION:	
*	ܸθáʸˡμɲϿԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Add_JWD_DB( unsigned char *buff, int flag )
{
  unsigned char   buff2[16386] ;
  int    ret ;
  char  work[1024], work1[1024], work0[1024] ;
  char   recid[16] ;
  char   *cary[30], *cp;
  int Rid ;
  int len ;
  int gid, gids[2048] ;
  char  putd[16] ;
  int ii, ct ;
  int bdate, dhash ;

  //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  len = CreateRec( flag, buff, buff2, 16386 ) ;
  if ( len == 0 ) {
    return ( -1 ) ;
  }
  if ( len == -1 ) { /* ʸˡ̤Ͽä顼åϺѤ */
    return( -1 ) ;
  }
  ret = StartPts(buff2,len,cary) ;
  if ( cary[5] == NULL ||
        strcmp( cary[5], "\"\"") == 0 ||
        strcmp( cary[5], "00000004") == 0 ) {
    gids[0] = -1 ;
    ct = 0 ;
  }
  else {
    ct = GetGidsfromCid( cary[5], gids, 2048) ;
    ct = SelectGids( cary, gids, ct) ;
  }
  if ( ChkSameRecord( cary, gids, ct) > 0 ) {
    return( -1 ) ; /* Ʊμ쥳ɤ¸ߤ */
  }

  /* ϿΥ쥳ɣɣĤ */
  if ( ( Rid = GetNewWordRID() ) == -1 )
    return -1 ;
  *(int *)buff2 = Rid ;


  /* Ϣμɽ  */
  AddJWD_report( stderr, cary, gids, ct) ;

  /* ¥쥳ɤϿ */
  ret = Put_IXT(WdRID2Val, buff2, 4, buff2, len) ;

  /*** ɽǥå ***/
  if ( cary[6] != NULL && strcmp( cary[6], "\"\"") != 0 ) {
    ret = GetFirstWd( cary[6] , work1, 1024) ;
    ret = EDR_StrStrip(work, work1) ;
    ret = Conv2Big(work0, work) ;
    if ( ret < 0 ) {
      printf("ERROR(Add_JWD_DB):HDWD:Conv2Big:IN>[%s](%d)\n",buff,strlen(buff)) ;
    }
    put4byte( Rid, &putd[0] ) ; /* 쥳ֹ */
    putd[4] = buff2[4] ;        /* Ϣ */
    putd[5] = buff2[5] ;        /* Ϣ */
    putd[6] = buff2[6] ;        /* ʻ   */
    putd[7] = 0xff ;                 
    ret = Add_IXT_DATA2( Hdwd2WdRID, work0, strlen( work0 ), putd, 8) ;
  }
  /*** ɤߥǥå ***/
  if ( cary[7] != NULL && strcmp( cary[7], "\"\"") != 0 ) { 
    ret = EDR_StrStrip(work, cary[7]) ;
    cp = skip_ptr( '/', work )  ;
    ret = copy_word( work1, 1024 , work, cp ) ;
    ret = Conv2Big(work, work1) ;
    if ( ret < 0 ) {
      printf("ERROR(Update_JWD_DB):YOMI(NEW):Conv2Big:IN>[%s](%d)\n",cary[7],strlen(cary[7])) ;
    }
    put4byte( Rid, &putd[0] ) ; /* 쥳ֹ */
    putd[4] = buff2[4] ;        /* Ϣ */
    putd[5] = buff2[5] ;        /* Ϣ */
    putd[6] = buff2[6] ;        /* ʻ   */
    putd[7] = 0xff ;                 
    ret = Add_IXT_DATA2( Yomi2WdRID, work, strlen( work ), putd, 8) ;
  }
  /*** ǰɣĥǥå ***/
  if ( cary[5] != NULL && strcmp( cary[5], "\"\"") != 0 ) { 
     ret = Add_IXT_DATA2( CID2WdRID, cary[5], strlen( cary[5] ), (char *)&Rid, 4) ;
  }
  /*** Ʊ󹹿 ***/
  if ( ct == 0 )
    gids[0] = GetNewGroup() ;
  /* 쥳ֹ=>롼ףɣĤϿ */
  ret = Put_IXT( RID2GrpID, buff2, 4, (char *)&gids[0], 4) ;
  /* 롼ףɣ=>쥳ֹϿ */
  ret = Add_IXT_DATA2( GrpID2RID, (char *)&gids[0], 4, buff2, 4) ;

  /*** Ͽ ***/
  bdate = PackNowDateI() ;
  dhash = ConvPackDate2B( bdate ) ;
  ret = Add_IXT_DATA2( UpdLogWord, (char *)&dhash, 4, (char *)&Rid, 4) ;

  return 1 ;
}




/**********************************************************
*   ܸñ켭    
*   USAGE:	        Update_JWD_DB( unsigned char *buff, int flag )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*                       int     flag   (IN)  ե饰ʹ̵뤹ϣ
*
*   DESCRIPTION:	
*	ܸñ켭οɲäԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Update_JWD_DB( unsigned char *buff, int flag )
{
  unsigned char   buff2[16386] ;
  unsigned char   old[8192] ;
  int    ret ;
  int    diffflag ;
  char  work[1024], work0[1024], work1[1024] ;
  char   *cary[30], *oary[30], *cp ;
  int   ct, gid, gids[2048] ;
  char  putd[16] ;
  int Rid ;
  int len ;
  int bdate, dhash ;

  //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  len = CreateRec( flag, buff, buff2, 16386 ) ;
  if ( len == 0 ) 
    return ( -1 ) ;
  if ( len == -1 ) {
    fprintf( stderr, "ERROR:Don't update! [%s]\n",buff) ;
    return( -1 ) ;
  }

  Rid = *(int *)buff2 ;
  if ( Rid < 0 ) {
    fprintf( stderr, "ERROR:Don't update! [%s]\n",buff) ;
    return( -1 ) ;
  }
  ret = StartPts(buff2,len,cary) ;
  if ( cary[5] == NULL ||
        strcmp( cary[5], "\"\"") == 0 ||
        strcmp( cary[5], "00000004") == 0 ) {
    gids[0] = -1 ;
    ct = 0 ;
  }
  else {
    ct = GetGidsfromCid( cary[5], gids, 2048) ;
    ct = SelectGids( cary, gids, ct) ;
  }
  if ( ChkSameRecord( cary, gids, ct) > 0 ) {
    return( -1 ) ; /* Ʊμ쥳ɤ¸ߤ */
  }

  diffflag = 0 ;

  /* Υǡʸǡˤ򥲥å */
  ret = Get_IXT( WdRID2Val, buff2, 4, old, 8192 ) ;
  if ( ret <= 0 ) {
    fprintf(stderr,"ERROR(Update_JWD_DB):Υ쥳ɤ¸ߤޤ\n") ;
    fprintf(stderr,"                DATA:[%s]\n",buff) ;
    return ( -1 ) ;
  }
  ret = StartPts(old,ret,oary) ;

  ret = GetFirstWd( cary[6] , work1, 1024) ;
  ret = GetFirstWd( oary[6] , work0 , 1024) ;

  if ( strcmp(work0, work1) != 0 )       /* ɽǥå򹹿 */
    diffflag |= 0x01 ;
  if ( strcmp( cary[7], oary[7]) != 0 )  /* ɤߥǥå򹹿 */
    diffflag |= 0x02 ;
  if ( strcmp( cary[5], oary[5]) != 0 )  /* ǰ̻ҥǥå򹹿 */
    diffflag |= 0x04 ;
  if ( *cary[1] != *oary[1] )            /* Ϣܤ򹹿 */
    diffflag |= 0x08 ;
  if ( *cary[2] != *oary[2] )            /* Ϣܤ򹹿 */
    diffflag |= 0x10 ;
  if ( *cary[3] != *oary[3] )            /* ʻ򹹿 */
    diffflag |= 0x20 ;

  /*** Ʊ ***/
  if ( ( diffflag & 0x27) != 0 ) {
    UpdJWD_report0( stderr, Rid, cary, oary) ;
    //ct = GetGidsfromCid( cary[5], gids, 128) ;
    //ct = SelectGids( cary, gids, ct) ;

    /* Ϣμɽ  */
    gid = UpdJWD_report1( stderr, Rid ) ;
   
    /* Ϣμɽ  */
    if ( ct <= 0 )
      gids[0] = GetNewGroup() ;
    UpdJWD_report2( stderr, gids, ct) ;

    /* 쥳ֹ=>롼ףɣĤϿ */
    ret = Put_IXT( RID2GrpID, (char *)&Rid, 4, (char *)&gids[0], 4) ;
    /* 롼ףɣ=>쥳ֹϿ */
    ret = Rem_IXT_DATA( GrpID2RID, (char *)&gid, 4 , (char *)&Rid, 4)  ;
    ret = Add_IXT_DATA2( GrpID2RID, (char *)&gids[0], 4, buff2, 4) ;
    
  }

  /* Ƥ˹ */
  ret = Put_IXT( WdRID2Val, buff2, 4, buff2, len) ;

  if ( (diffflag & 0x39 ) != 0 ) {    /* ɽǥå򹹿 */
    ret = EDR_StrStrip(work, work0) ;
    ret = Conv2Big(work0, work) ;
    if ( ret < 0 ) {
      printf("ERROR(Update_JWD_DB):HDWD(OLD):Conv2Big:IN>[%s](%d)\n",oary[6],strlen(oary[6])) ;
    }
    /* 쥤ǥå */
    put4byte( Rid, &putd[0] ) ; /* 쥳ֹ */
    putd[4] = *oary[1] ;        /* Ϣ */
    putd[5] = *oary[2] ;        /* Ϣ */
    putd[6] = *oary[3] ;        /* ʻ   */
    putd[7] = 0xff ;                 
    ret = Rem_IXT_DATA( Hdwd2WdRID, work0, strlen( work0 ), putd, 8)  ;
    /* ǥå */
    ret = EDR_StrStrip(work, work1) ;
    ret = Conv2Big(work1, work) ;
    if ( ret < 0 ) {
      printf("ERROR(Update_JWD_DB):HDWD:Conv2Big:IN>[%s](%d)\n",buff,strlen(buff)) ;
    }
    put4byte( Rid, &putd[0] ) ; /* 쥳ֹ */
    putd[4] = *cary[1] ;        /* Ϣ */
    putd[5] = *cary[2] ;        /* Ϣ */
    putd[6] = *cary[3] ;        /* ʻ   */
    putd[7] = 0xff ;                 
    ret = Add_IXT_DATA2( Hdwd2WdRID, work1, strlen( work1 ), putd, 8) ;
  }
  if ( ( diffflag % 0x3a ) != 0 ) {  /* ɤߥǥå򹹿 */
    if ( oary[7] != NULL && strcmp( oary[7], "\"\"") != 0 ) { 
      ret = EDR_StrStrip(work, oary[7]) ;
      cp = skip_ptr( '/', work )  ;
      ret = copy_word( work1, 1024 , work, cp ) ;
      ret = Conv2Big(work, work1) ;
      if ( ret < 0 ) {
        printf("ERROR(Update_JWD_DB):YOMI(OLD):Conv2Big:IN>[%s](%d)\n",oary[7],strlen(oary[7])) ;
      }

      /* 쥤ǥå */
      put4byte( Rid, &putd[0] ) ; /* 쥳ֹ */
      putd[4] = *oary[1] ;        /* Ϣ */
      putd[5] = *oary[2] ;        /* Ϣ */
      putd[6] = *oary[3] ;        /* ʻ   */
      putd[7] = 0xff ;                 
      ret = Rem_IXT_DATA( Yomi2WdRID, work, strlen( work ), putd, 8)  ;
    }
    if ( cary[7] != NULL && strcmp( cary[7], "\"\"") != 0 ) { 
      ret = EDR_StrStrip(work, cary[7]) ;
      cp = skip_ptr( '/', work )  ;
      ret = copy_word( work1, 1024 , work, cp ) ;
      ret = Conv2Big(work, work1) ;
      if ( ret < 0 ) {
        printf("ERROR(Update_JWD_DB):YOMI(NEW):Conv2Big:IN>[%s](%d)\n",cary[7],strlen(cary[7])) ;
      }
      put4byte( Rid, &putd[0] ) ; /* 쥳ֹ */
      putd[4] = *cary[1] ;        /* Ϣ */
      putd[5] = *cary[2] ;        /* Ϣ */
      putd[6] = *cary[3] ;        /* ʻ   */
      putd[7] = 0xff ;                 
      ret = Add_IXT_DATA2( Yomi2WdRID, work, strlen( work ), putd, 8) ;
    }
  }
  if ( (diffflag & 0x04) != 0 ) {  /* ǰ̻ҥǥå򹹿 */
    if ( oary[5] != NULL && strcmp( oary[5], "\"\"") != 0 ) 
      ret = Rem_IXT_DATA( CID2WdRID, oary[5], strlen( oary[5] ), (char *)&Rid, 4)  ;
    if ( cary[5] != NULL && strcmp( cary[5], "\"\"") != 0 )  
       ret = Add_IXT_DATA2( CID2WdRID, cary[5], strlen( cary[5] ), (char *)&Rid, 4) ;
  }
  /*** Ͽ ***/
  bdate = PackNowDateI() ;
  dhash = ConvPackDate2B( bdate ) ;
  ret = Add_IXT_DATA2( UpdLogWord, (char *)&dhash, 4, (char *)&Rid, 4) ;

  return 1 ;
}





/**********************************************************
*   ܸñ켭    
*   USAGE:	        Delete_JWD_DB( CFile  *fpt , CFile *ipt, CFile *ypt, CFile *cpt, CFile *lpt, unsigned char *buff )
*   SYNOPSIS:           char   *buff   (IN)  Ǽ쥳
*
*   DESCRIPTION:	
*	ܸñ켭οɲäԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Delete_JWD_DB( unsigned char *buff )
{
  char dict[8], rnum[12] ;
  int  gid, Rid ;
  unsigned char   buff2[16386] ;
  unsigned char   old[8192] ;
  int    ret ;
  char   work[1024], work0[1024], work1[1024] ;
  char   *cary[30], *oary[30], *cp ;
  char  putd[16] ;
  int len ;
  int bdate, dhash ;

  // printf("(Delete_JWD_DB)IN>[%s](%d)\n",buff,strlen(buff)) ; 
  Rid = GetCode2Wid( buff, dict, rnum) ;
  if ( dict[0] == '\0' && rnum[0] == '\0' ) {
    return ( -1 ) ;
  }
  /* Υǡ */
  ret = Get_IXT( WdRID2Val, (char *)&Rid, 4, old, 8192 ) ;
  if ( ret <= 0 ) {
    fprintf(stderr,"ERROR(Delete_JWD_DB):Υ쥳ɤ¸ߤޤ\n") ;
    fprintf(stderr,"                DATA:[%s]\n",buff) ;
    return ( -1 ) ;
  }
  ret = StartPts(old,ret,oary) ;

  /* Ϣμɽ  */
  UpdJWD_reportDel( stderr, Rid, oary) ;
  gid = UpdJWD_report1( stderr, Rid ) ;

  ret = GetFirstWd( oary[6] , work0 , 1024) ;
  /* ɽΥǥå */
  ret = EDR_StrStrip(work, work0) ;
  ret = Conv2Big(work0, work) ;
  if ( ret < 0 ) {
    printf("ERROR(Delete_JWD_DB):HDWD(OLD):Conv2Big:IN>[%s](%d)\n",buff,strlen(buff)) ;
  }
  put4byte( Rid, &putd[0] ) ; /* 쥳ֹ */
  putd[4] = *oary[1] ;        /* Ϣ */
  putd[5] = *oary[2] ;        /* Ϣ */
  putd[6] = *oary[3] ;        /* ʻ   */
  putd[7] = 0xff ;                 
  ret = Rem_IXT_DATA( Hdwd2WdRID, work0, strlen( work0 ), putd, 8)  ;
  /* ɤߥǥå */
  if ( oary[7] != NULL && strcmp( oary[7], "\"\"") != 0 ) { 
    ret = EDR_StrStrip(work, oary[7]) ;
    cp = skip_ptr( '/', work )  ;
    ret = copy_word( work1, 1024 , work, cp ) ;
    ret = Conv2Big(work, work1) ;
    if ( ret < 0 ) {
      printf("ERROR(Update_JWD_DB):YOMI(OLD):Conv2Big:IN>[%s](%d)\n",oary[7],strlen(oary[7])) ;
    }
    put4byte( Rid, &putd[0] ) ; /* 쥳ֹ */
    putd[4] = *oary[1] ;        /* Ϣ */
    putd[5] = *oary[2] ;        /* Ϣ */
    putd[6] = *oary[3] ;        /* ʻ   */
    putd[7] = 0xff ;                 
    ret = Rem_IXT_DATA( Yomi2WdRID, work, strlen( work ), putd, 8)  ;
  }
  /* ǰ̻ҥǥå */
  if ( oary[5] != NULL && strcmp( oary[5], "\"\"") != 0 ) 
    ret = Rem_IXT_DATA( CID2WdRID, oary[5], strlen( oary[5] ), (char *)&Rid, 4)  ;
  /* 쥳ʬ */
  ret = Rem_IXT( WdRID2Val, (char *)&Rid, 4) ;

  /*** Ͽ ***/
  bdate = PackNowDateI() ;
  dhash = ConvPackDate2B( bdate ) ;
  ret = Add_IXT_DATA2( UpdLogWord, (char *)&dhash, 4, (char *)&Rid, 4) ;

  /* 쥳ֹ=>롼ףɣĤ */
  if ( RID2GrpID != NULL )
    ret = Put_IXT( RID2GrpID, (char *)&Rid, 4, "", 0) ;
  /* 롼ףɣ=>쥳ֹϿ */
  if ( GrpID2RID != NULL )
    ret = Rem_IXT_DATA( GrpID2RID, (char *)&gid, 4 , (char *)&Rid, 4)  ;
  return 1 ;
}




