#include <stdio.h>
#include <stdlib.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "edrcorp.h"
#include "sconst.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/


extern char DATA0[] ;  // 80000
extern int  DATA0CT ;
extern char DATA1[] ;  // 32768
extern int  DATA1CT ;
extern char DATA2[] ;  // 32768
extern int  DATA2CT ;



char *featurept( char *feat, char *data ) ;
char *fvaluept( char *data ) ;
char *get_tag_tei( char *tag_name, char *tags) ;
int   tag_equal( char *tag, char *data) ;
char *gettag_pt( char *tags) ;
char *tag_skip( char *data) ;
int CopyValByTag( char *buff, char *vp) ;


int CatTag( char *out, char *value, int vct )   /* ǡ */
{
  int   ret ;
  int   ii, len ;
  char *cp ;

  cp = out ;
  for( ii = 0 ; ii < vct ; ii += len +1 ) {
    strcpy( cp, value+ii ) ;
    len = strlen( value+ii ) ;
    cp += len ;
  }
  *cp = '\0' ;
  return ( cp - out ) ;
}

/***** FIELD(keywords) => VALUE LIST*****/
int IxHWordList( char *buff, char *value, int vct )   /* ǥåǡ */
{
  char *cp ;
  char *tp, *fp, *vp ;
  int  bct = 0 ;
  int  ii ;
  int  len, wsz ;

  for( ii = 0 ; ii < vct ; ii += len +1 ) {
    cp = value+ii ;
    len = strlen( value+ii ) ;
    while(1) {
      //printf("IxHWordList:cp=[%s]\n",cp) ;
      if ( (tp = gettag_pt( cp ) ) == NULL )    
        break ;
      tp = skip_non_sp( tp+1 ) ;
      if ( tag_equal( "term", tp ) == 1 ) {
        fp = tag_skip(tp) ;
        if ( fp != NULL ) {
          if ( bct == 0 ) {
            wsz = CopyValByTag( buff+bct, fp) ;
            bct += wsz  ;
          }
          else {
            *(buff+bct) = '\t' ; 
            wsz = CopyValByTag( buff+bct+1, fp ) ;
            bct += (wsz + 1 ) ;
          }
        }
      }
      cp = tp ;
    }
  }
  *(buff+bct) = '\0' ;
  //printf("(IxHWordList)out=[%s]\n",buff) ;
  return bct ;
}


int ClearIXTEICorp( int Rid )    /* ǥåĶ(ɣغ */
{
  int   wct ;
  short wid ;
  int   outf = 0 ,ret, ii ;
  char  *bptr[1024] ;
  CData cur ;
  char  fname[64] ;
  char  val[8] ;

  if ( JCORPRecId2Val == NULL)
    return ( -1 ) ;

  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "ti" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( JCORPRecId2Val, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    return 1 ;
  }
  if ( cur.datasize <= 0 ) {
    return 1;
  }
  DATA0[cur.datasize] = '\0' ;
  wct = split1( '\t', DATA0, bptr ) ; /* ǿ */
  if ( wct != 0 ) {
    val[0] = 0xff ;       /* ʻIDTEIƤǡʻʤ */
    put4byte( Rid, &val[1] ) ;
    for( ii = 0 ; ii < wct ; ii++ ) {
      // printf("%d)[%s] remove\n",ii, bptr[ii] ) ;
      ret = Rem_IXT_DATA( HDWD2JCORPRecID, bptr[ii], strlen( bptr[ii] ) ,  &val[0], 5)  ;
    }
  }
  return 1;
}


int SetIXTEICorp( int Rid)      /* ǥåĶ(ɣغ */
{
  int   wct ;
  short wid ;
  int   outf = 0 ,ret, ii ;
  char  *bptr[1024] ;
  CData cur ;
  char  fname[64] ;
  char  val[8] ;

  if ( JCORPRecId2Val == NULL)
    return ( -1 ) ;

  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "ti" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( JCORPRecId2Val, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    return 1 ;
  }
  if ( cur.datasize <= 0 ) {
    return 1;
  }
  DATA0[cur.datasize] = '\0' ;
  wct = split1( '\t', DATA0, bptr ) ; /* ǿ */
  if ( wct != 0 ) {
    val[0] = 0xff ;       /* ʻIDTEIƤǡʻʤ */
    put4byte( Rid, &val[1] ) ;
    for( ii = 0 ; ii < wct ; ii++ ) {
      //printf("%d)[%s] put\n",ii, bptr[ii] ) ;
      ret = Add_IXT_DATA2( HDWD2JCORPRecID, bptr[ii], strlen( bptr[ii] ) , &val[0], 5)  ;
    }
  }
  return 1;
}




char *gettag_pt( char *tags)
{
  char *cp ;

  if ( tags == NULL )
    return NULL ;
  cp = skip_ptr( '<', tags ) ;
  return ( cp ) ;
}



char *get_tag_tei( char *tag_name, char *tags)
{
  char *cp = tags ;
  char *tp ;
  int   ch ;

  if ( cp == NULL )
    return NULL ;
  while( cp != NULL && *cp != '\0' ) {
    if ( *cp == '<' ) {
      tp = skip_non_sp( cp+1 ) ;
      if ( tag_equal( tag_name, tp ) == 1 )
        return ( cp ) ;
    }
    cp = skip_ptr( '<', cp ) ;
  }
  return ( NULL ) ;
}



int tag_equal( char *tag, char *data)
{
  int len ;

    while( *tag != '\0' ) {
      if ( *tag == *data ) {
        tag++ ; data++ ;
        continue ;
      }
      return ( -1 ) ;
    }
    if ( *data <= ' ' || *data == '>' )
      return 1 ;
    return ( -1 ) ;
}



char *tag_skip( char *data)
{
    while( *data != '\0' ) {
      if ( *data == '>' )
        return (data+1) ;
       data++ ;
    }
    return ( NULL ) ;
}




int CopyValByTag( char *buff, char *vp)
{
  int flag = 0 ;
  char *cp, *ep ;
  char *bp ;

  *buff = '\0' ;
  if ( vp == NULL )
    return 0 ;
  cp = vp ;
  ep = skip_ptr( '<', cp ) ;
  for( bp = buff ; cp != ep && *cp != '\0' ; bp++,cp++ ) {
    *bp = *cp ;
  }
  *bp = '\0' ;
  return ( bp - buff ) ;
}







char *featurept( char *feat, char *data )
{
  int  len ;
  char *cp = data ;

  if ( cp == NULL )
    return NULL ;
  len = strlen( feat ) ;
  while( *cp != '\0' ) {
      cp = skip_non_sp( cp ) ;
      if ( cp == NULL || *cp == '>' )
        return NULL ;
      if ( strncmp( cp, feat, len) == 0 &&
           ( *(cp + len) <= ' ' || *(cp + len) == '=' ) )  {
        return cp ;
      }
      cp = skip_a_word( cp+1 ) ;
      if ( cp == NULL)
        return NULL ;
  }
  return cp ;
}



char *fvaluept( char *data )
{
  char *cp ;

  if ( data == NULL )
    return NULL ;
  cp = data ;
  while( *cp != '=' && *cp != '\0' ) {
    if ( *cp <= ' ' ) {
      cp = skip_non_sp( cp ) ;
      if ( *cp == '=' )
        break ;
      return NULL ;
    }
    cp++ ;
  }
  if ( cp == '\0' )
    return NULL ;
  cp++ ;
  cp = skip_non_sp( cp ) ;
  return cp ;
}



int CopyTeiVal( char *buff, char *vp)
{
  int flag = 0 ;
  char *cp, *sp, *ep ;
  char *bp ;

  *buff = '\0' ;
  if ( vp == NULL )
    return 0 ;
  cp = vp ;
  bp = buff ;
  if ( *cp == '\'' ) {
    flag |= 0x01 ;
    cp++ ;
    if ( *cp == '"' ) {
      flag |= 0x02 ;
      cp++ ;
    }
  }
  else if ( *cp == '"' ) {
    flag |= 0x02 ;
    cp++ ;
  }
  if ( (flag & 0x02 ) != 0 ) {
    ep = search_char( '\"', cp ) ;
    for( sp = bp ; cp != ep && *cp != '\0' ; bp++, cp++ ) {
      *bp = *cp ;
    }
    *bp = '\0' ;
    return ( bp - sp ) ;
  }
  if ( (flag & 0x01 ) != 0 ) {
    ep = skip_ptr( '\'', cp ) ;
    for( sp = bp ; cp != ep && *cp != '\0' ;bp++, cp++ ) {
      *bp = *cp ;
    }
    *bp = '\0' ;
    return ( bp - sp ) ;
  }
  ep = skip_ptr( ' ', cp ) ;
  for( sp = bp ; cp != ep && *cp != '\0' ; bp++,cp++ ) {
    *bp = *cp ;
  }
  *bp = '\0' ;
  return ( bp - sp ) ;
}






int print_tag( FILE * fp, char *cp )
{
  char *sp ;
  int   ii = 0 ;
  int   lev = 0 ;
  int   length ;
//char work[20] ;

  while( *cp != '\0' ) {
//printf("lev=%d\n",lev) ;
    ii++ ;
    sp = skip_ptr( '>', cp ) ;
    if ( sp == NULL ) {
      fprintf(fp, " %s\n", cp ) ;
      break ;
    }
    if ( ( *cp == '<' && *(cp+1) == 'm' && *(cp+2) == ' ' ) ||
         strncmp( cp, "<term>", 6) == 0 ) {
      sp++ ;
      sp = skip_ptr( '>', sp ) ;
      if ( sp == NULL ) {
        fprintf(fp, " %s\n", cp ) ;
        break ;
      }
    }
    sp++ ;
    length = sp - cp ;
    print_sp_lev( fp, lev ) ;
    fwrite( cp, sizeof( char ), length, fp);
    fprintf( fp, "\n" ) ;
//strncpy(work, cp, 10 ) ;
//work[10] = '\0' ;
//printf("cp=>[%s......]\n", work) ;
    if ( !( *cp == '<' && *(cp+1) == 'm' && *(cp+2) == ' ' ) &&
         strncmp( cp, "<term>", 6) != 0 ) {
      if ( *cp == '<' && *(cp+1) == '/' )
        lev-- ;
      else
        lev++ ;
    }
    cp = sp ;
  }
  return ii ;
}


int print_sp_lev( FILE *fp,  int lev)
{
  int ii ;
  
  for( ii = 0 ; ii < lev ; ii++ ) {
    fprintf( fp, "  ") ;
  }
  fprintf( fp, " " ) ;
  return ii ;
}



/****************************************************************
*   ԣţɥǡ:쥳ɽʥ쥳ֹ
*   USAGE:		PrnTEIRID( FILE *fp, CFile *jcfp, int Rid )
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ԣţɷģҷܸ쥳ѥʸɽ롣
*       ʲƥեɤˤǼǤ롣
*
*       ʸ              °̾{ bu }
*           | ƥֹ\0 | ŵ\0 | ʸ\0 |
*           |  (n)           | (n)        | (n)  |
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnTEIRID( FILE *fp, CFile *jcfp, int Rid )
{
  fprintf( fp,"%%%%%%쥳ֹ%%%%%%\n") ;
  fprintf( fp," %d\n", Rid) ;
  return Rid ;
}
  


/****************************************************************
*   ԣţɥǡ:TEIHeaderɽ
*   USAGE:		PrnTEIHeader( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ԣţɷΥѥǡΥإåɽ롣
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnTEIHeader( FILE *fp, CFile *jcfp, int Rid)
{
  int   wct ;
  short wid ;
  int   outf = 0 ,ret, ii ;
  int   ct = 0 ;
  char  *bptr[1024] ;
  char  wordlist[2048] ;
  CData cur ;
  char  fname[64] ;
  int   ict = 0 ;

  if ( jcfp == NULL)
    return ( -1 ) ;

  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "th" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    fprintf(fp, "%%%%%%teiHeader%%%%%%\n") ;
    return 0 ;
  }
  if ( cur.datasize <= 0 ) {
    fprintf(fp, "%%%%%%teiHeader%%%%%%\n") ;
  }
  else {
    fprintf(fp, "%%%%%%teiHeader%%%%%%\n") ;
    DATA0[cur.datasize] = '\0' ;
    print_tag(fp, DATA0 ) ;
  }
  if ( cur.subFsize > 0 ) {
    fprintf(fp,"#\n") ;
    outf = 1 ;
    DATA1[cur.subFsize] = '\0' ;
    fprintf(fp," %s\n",DATA1) ;
  }
  return wct ;
}





/****************************************************************
*   ԣţɥǡ:TEITextɽ
*   USAGE:		PrnTEIText( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ԣţɷΥѥǡΥإåɽ롣
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnTEIText( FILE *fp, CFile *jcfp, int Rid)
{
  int   wct ;
  short wid ;
  int   outf = 0 ,ret, ii ;
  int   ct = 0 ;
  char  *bptr[1024] ;
  char  wordlist[2048] ;
  CData cur ;
  char  fname[64] ;
  int   ict = 0 ;

  if ( jcfp == NULL)
    return ( -1 ) ;

  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "tt" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    fprintf(fp, "%%%%%%teiText%%%%%%\n") ;
    return 0 ;
  }
  if ( cur.datasize <= 0 ) {
    fprintf(fp, "%%%%%%teiText%%%%%%\n") ;
  }
  else {
    fprintf(fp, "%%%%%%teiText%%%%%%\n") ;
    DATA0[cur.datasize] = '\0' ;
    print_tag(fp, DATA0 ) ;
  }
  if ( cur.subFsize > 0 ) {
    fprintf(fp,"#\n") ;
    outf = 1 ;
    DATA1[cur.subFsize] = '\0' ;
    fprintf(fp," %s\n",DATA1) ;
  }
  return wct ;
}


int print_hindex( FILE *fp, char  *data ) 
{
  char *cp = data ;
  char *np ;

    fprintf( fp," <keywords>\n" ) ;
    while( *cp != '\0') {
      np = skip_ptr( '\t', cp ) ;
      if ( np != NULL ) {
        *np = '\0' ;
        fprintf( fp," <term>%s</term>\n",cp) ;
        cp = np +1 ;
      }
      else {
        fprintf( fp," <term>%s</term>\n",cp) ;
        break ;
      }
    }
    fprintf( fp," </keywords>\n" ) ;
    return 1 ;
}




/****************************************************************
*   ԣţɥǡ:TEIHIndexɽ
*   USAGE:		PrnTEIHIndex( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ԣţɷΥѥǡΥإåɽ롣
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnTEIHIndex( FILE *fp, CFile *jcfp, int Rid)
{
  int   wct ;
  short wid ;
  int   outf = 0 ,ret, ii ;
  int   ct = 0 ;
  char  *bptr[1024] ;
  char  wordlist[2048] ;
  CData cur ;
  char  fname[64] ;
  int   ict = 0 ;

  if ( jcfp == NULL)
    return ( -1 ) ;

  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "ti" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    fprintf(fp, "%%%%%%keywords%%%%%%\n") ;
    return 0 ;
  }
  if ( cur.datasize <= 0 ) {
    fprintf(fp, "%%%%%%keywords%%%%%%\n") ;
  }
  else {
    fprintf(fp, "%%%%%%keywords%%%%%%\n") ;
    DATA0[cur.datasize] = '\0' ;
    print_hindex(fp, DATA0 ) ;
  }
  if ( cur.subFsize > 0 ) {
    fprintf(fp,"#\n") ;
    outf = 1 ;
    DATA1[cur.subFsize] = '\0' ;
    fprintf(fp," %s\n",DATA1) ;
  }
  return wct ;
}




