#include <stdio.h>
#include <fcntl.h>

#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/

/****************************************************************
    ţģҷγǰҤ˴ؤؿ
****************************************************************/



/****************************************************************
*   Ǽ쥳ɺ
*   USAGE:		CreateCptRec( char *indata, char *outdata, int size, char **ptr)
*   SYNOPSIS:		char  *indata  (IN)   ǰҼʣţģҼ
*                       char  *outdata (OUT)  쥳ɳǼ
*                       int   size            쥳ɳǼΥ
*                       char  **ptr    (OUT)  ƥեɤγǼݥ
*
*   DESCRIPTION:	
*	ţģҷΥǡ顢ģ¤˳Ǽ쥳ɤ롣
*       ʲǼ쥳ɤΥեɹǤ롣
*       ƥեɤΥɥ쥹裴˥åȤ롣
*       裴ϥեɤοʬǤɬס
*       ִطIDפϡͤ򣱡ɽ¾ͤϣˤ
*       ʸǳǼREL=xxxxxˡ
*       ϥǡʣţģҳǰҼ
*        쥳ֹ Ҷʬ 賵ǰID ط 긵ǰID  
*
*       Ǽ쥳ɷ
*        | Rec-ID | FLAG | طID | 긵ǰID\0 |
*        |  (4)   | (1)  | (1)      | (n)            |
*
*        | 賵ǰID\0 | \0 |
*        | (n)            | (n)        |
*
*             FLAG:  Ҷʬ    
*                    FLAG & 0x01 == 0B : Ҷʬ  I
*                    FLAG & 0x01 == 1B : Ҷʬ  E
*                    FLAG & 0x02 == 0B :    
*                    FLAG & 0x02 == 1B :    
*
*   RETURN:		record size
*                       ۾郎äϡ-1֤롣         
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  CreateCptRec( char *str, char *out, int size)      
{
  char buff2[8192] ;
  char dict[8], rnum[12] ;
  char  *bptr[10] ;
  int  ret, tb, len, Rid ;
  char flag, tid ;

  tb = split1( '\t', str, bptr ) ;
  /* طҥơ֥륵 */
  tid = GetCharTableIX( bptr[3], &Concept_Rel[0]  ) ;

  if (tid == -1) {
    tid = 0 ;
    fprintf( stderr, "ǰط[%s]ɣĲơ֥ϿƤޤ\n", bptr[3] ) ;
    /* ˴طҤɲ */
    ret = AddPropertyETCRecord( bptr[6], 8192 - ( bptr[6] - str), "CREL", bptr[3] )  ;
  }
  len = strlen(bptr[2]) + strlen(bptr[4]) + strlen(bptr[6]) + 3+ 6 ;
  if ( size <= len ) {
    return ( -1 ) ;
  }
  Rid = GetCode2Wid( bptr[0], dict, rnum) ;
  /*
  *if ( dict[0] == '\0' && rnum[0] == '\0' ) {
  *  return ( -1 ) ;
  *}
  */
  flag = 0 ;
  if ( *bptr[1] == 'E' )
    flag |= 0x01 ;
  if ( *bptr[5] == '1' )
    flag |= 0x02 ;
  //printf("dict=[%s],rnum=[%s],  Rid=[%d]\n",dict,rnum,Rid);
  put4byte( Rid, out ) ;
  out += 4 ;
  *out = flag ; out++ ;
  *out = tid  ; out++ ;
  strcpy( out, bptr[2] ) ; out += strlen(bptr[2]) + 1 ;
  strcpy( out, bptr[4] ) ; out += strlen(bptr[4]) + 1 ;
  strcpy( out, bptr[6] ) ; out += strlen(bptr[6]) + 1 ;
  return ( len ) ;
}





/****************************************************************
*   Ǽ쥳 եɥݥ
*   USAGE:		StartPtsCPT( char *rec, int len, char **cary)
*   SYNOPSIS:		char  *rec    (IN)   ǰηϳǼ쥳
*                       int   len     (IN)   쥳ɤΥ
*                       char  **cary  (OUT)  ƥեɤγǼݥ
*
*   DESCRIPTION:	
*	γƥեɤƬݥ󥿤ᡢ裳
*       ˥åȤ롣
*       ꥿ͤϤǿ
*
*        | Rec-ID | FLAG | طID | 긵ǰID\0 |
*        |  (4)   | (1)  | (1)      | (n)            |
*
*        | 賵ǰID\0 | \0 |
*        | (n)            | (n)        |
*
*
*   RETURN:		եɿ
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int StartPtsCPT(char *rec, int len, char **cary) 
{
  int   ii ;

  cary[0] = rec ;     /* Rec-ID */
  cary[1] = rec+4 ;   /* FLAG */
  cary[2] = rec+5 ;   /* طҡʥơ֥ID */
  cary[3] = rec+6 ;   /* 賵ǰID */
  rec = rec + 6 + strlen( cary[3] ) +1;
  cary[4] = rec ;     /* 긵ǰID */
  rec = rec + strlen( cary[4] ) +1;
  cary[5] = rec ;     /*    */
  ii = 6 ;
  while(1) {
    rec = skip_ptr( ';', rec ) ;
    if (rec == NULL) {
      break ;
    }
    rec = skip_non_sp( rec +1 ) ;
    if (rec == NULL) {
      break ;
    }
    cary[ii++] = rec ;     /* ݻii */
  }
  return ii ;
}





