/*
#############################################################################
#                                                                           #
#  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1995  #
#                                                                           #
#                    <Dictionary Translator for EDBroW>                     #
#                                                                           #
#  - For details regarding copyright, re-distribution, modification, and    #
#    use of this software see COPYING file.                                 #
#                                                                           #
#  - For UNIX version                                                       #
#    This software was developed on SunOS4.1.3 with the gcc.2.5.8 compiler  #
#    and on Solaris2.3 with the gcc2.5.6 compiler. The compilers supplied   #
#    with SunOS4.1.3 and Solaris2.3 were also used.                         #
#                                                                           #
#  - For Windows version                                                    #
#    This software was developed on Microsoft Windows 3.1 with the          #
#    Microsoft Visual C++ 1.0 compiler.                                     #
#                                                                           #
#############################################################################
*/

/*************************************************************\

  msort.c : ȥ󥹥졼ǥåѴؿ
  Ver.1.1
  95/04/12   by msato@edr8r.edr.co.jp

\*************************************************************/

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "util.h"

#ifdef _WIN32
#include <io.h>
#include <search.h>
#define Close _close
#define Read _read
#define Write _write
#define Lseek _lseek
#else
#include <unistd.h>
#define remove unlink
#define	Close close
#define Read read
#define Write write
#define Lseek lseek
#endif

/*  */
#define MAX_DATANUM	16000	/* Ѻΰ */
#define	OFFSETMEM_SIZE	200	/* 16000 * 200 ԤΥեޤOK */
#define	FBUF_SIZE 	2048	/* Хåե */
#define BUF_SIZE	512		/* Хåե */

/* ޥ */
#define SWAP(a,b)	{tmp=a;a=b;b=tmp;}

/* Хѿ */
static long  OffsetMem[OFFSETMEM_SIZE];	/* ȥեΥեå */
static long  NowOffset[OFFSETMEM_SIZE];	/* ߤΥեå */
static int   OffsetCount;			/* ǡʬ */
static char  WriteBuf[FBUF_SIZE];	/* 񤭹ߥХåե */
static int   WbufOffset = 0;		/* 񤭹ߥХåեΥեå */
static char  *DataBuf[OFFSETMEM_SIZE];

/* ޡѹ¤ */
typedef struct bufflist {
  char 	buff[BUF_SIZE];
  int	num;
  struct bufflist *next;
} BuffList;


/* ؿץȥ */
#ifdef __STDC__
int  cmpData (char *str1, char *str2);
int  mergeAll (int tmpFd, int outFd);
int  getData (BuffList *blist, int tmpFd);
void flush_wbuf (int fd);
int  my_fputs (char *buf, int fd);
void quick_sort (char **base, int count);
char **separate (char **left, char **right, int size);
void insertion_sort (char **left, char **right);
int  insert (BuffList **top, BuffList *new);
#else
int  cmpData ();
int  mergeAll ();
int  getData ();
void flush_wbuf ();
int  my_fputs ();
void quick_sort ();
char **separate ();
void insertion_sort ();
int  insert ();
#endif

/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> msort
 *<>
 *[I ] char *srcFileName	ȸե̾
 *[I ] char *dstFileName	ե̾
 *<꥿>
 *
 *<Хѿ>
 *
 *<>
 *ʤ
 *<ǽ>
 *srcFileName 򥽡Ȥ̤ dstFileName 롥
 *<>
 *ʤ
 */
int msort (srcFileName, dstFileName)
     char *srcFileName;
     char *dstFileName;
{

  char	**sortchar, **top;	/* qsort ѥǡƬ  */
  int	count, i=0;	/*  */
  FILE 	*srcFp;		/* ȸե */
  int	dstFd;		/* ȷ̥ե */
  int	tmpFd;		/* ȥե */
  char	workfile[260];	/* ȥե̾ */
  int	len;		/* ʸĹ */
  char	buf[BUF_SIZE];	/* ɤ߹ߥХåե */
  long	totalDataLen;	/* ǡĹ */
  char  *res;		/* fgets ֤ͤȤ */

  OffsetCount = 0;	

  /* Ѻΰγ */
  top = (char **)malloc (MAX_DATANUM * sizeof(char *));
  if ( top == NULL ) {
    fatal (OUT_OF_MEMORY, __FILE__, __LINE__);
  }
  /* ΰν */
  memset (top, 0, MAX_DATANUM);
  memset (WriteBuf, 0, FBUF_SIZE);

  /* Ѻȥե̾μ */
  make_filename (workfile, SORT_WRK);

  /* ƥեΥץ */
#ifdef _WIN32
  srcFp = fopen (srcFileName, "rb");
  dstFd = _open (dstFileName, _O_WRONLY|_O_BINARY|_O_CREAT|_O_TRUNC,
                 _S_IWRITE);
  tmpFd = _open (workfile, _O_WRONLY|_O_BINARY|_O_CREAT|_O_TRUNC, _S_IWRITE); 
#else
  srcFp = fopen (srcFileName, "r");
  dstFd = open (dstFileName, O_WRONLY|O_CREAT|O_TRUNC, S_IRUSR|S_IWUSR);
  tmpFd = open (workfile, O_WRONLY|O_CREAT|O_TRUNC, S_IRUSR|S_IWUSR);
#endif

  /* եΥץåʤϰ۾ｪλ */
  if ( srcFp == NULL ) {
    fatal (CANNOT_OPEN_FILE_FATAL, srcFileName, 0);
  }
  if ( dstFd < 0 ) {
    fatal (CANNOT_OPEN_FILE_FATAL, dstFileName, 0);
  }
  if ( tmpFd < 0 ) {
    fatal (CANNOT_OPEN_FILE_FATAL, workfile, 0);
  }

  /* ǡν */
  sortchar = top;
  count = 0;
  len = 0;
  totalDataLen = 0L;

  while (1) {

    /* ǡɤ߹ */
    res = fgets (buf, BUF_SIZE, srcFp);

    /* ǡͤۤեνã */
    if ( count >= MAX_DATANUM || res == NULL ) {
      
      /* ɤ߹ʬ򥽡 */
      quick_sort (top, count);
      /* ǡ򹹿 */
      OffsetMem[OffsetCount] = totalDataLen;
      OffsetCount++;

      /* ǡȥե˽񤭽Ф */
      for ( sortchar = top, i = 0 ; i < count ; sortchar++, i++) {
        if ( *sortchar != NULL ) {
          len = my_fputs (*sortchar, tmpFd);
          totalDataLen += len;
          free(*sortchar);
          *sortchar = NULL;
        }
        else {
          fprintf (stderr, "Error : file %d, count %d prev %s", 
                   OffsetCount, i, *(sortchar-1));
          fprintf (stderr, "Execution continue\n");
        }
      }
      /* ȥǡΥꥻå */
      count = 0;
      sortchar = top;

    }
    /* եκǸǤнλ */
    if ( res == NULL ) break;

    /* ХåեĹ */
    for ( len = 0; buf[len] != '\n'; len++); len++;

    /* ХåեĹʬ */
    if ( (*sortchar = (char *)malloc (sizeof(char)*(len+1))) == NULL ) {
      fatal (OUT_OF_MEMORY, __FILE__, __LINE__);
    }
    /* ХåեƤ򥳥ԡ */
    memcpy (*sortchar, buf, len);
    *(*sortchar+len) = '\0';
    sortchar++;
    count++;
  }

  /* ǡɤ߹ߤνλ */
  OffsetMem[OffsetCount] = totalDataLen;
  flush_wbuf (tmpFd); 
  fclose (srcFp);
  Close (tmpFd);
  free (top);

  for ( i = 0 ; i <= OffsetCount; i++ ) {
    NowOffset[i] = OffsetMem[i];
  }

  if ( OffsetCount == 1 ) {
	Close (dstFd);
	remove (dstFileName);
    rename (workfile, dstFileName);
  }
  else {

  /* ȥեΥץ */
#ifdef _WIN32
    tmpFd = _open (workfile, _O_RDONLY|_O_BINARY);
#else
    tmpFd = open (workfile, O_RDONLY);
#endif
    /* ץ˼Ԥ顤۾ｪλ */
    if (tmpFd < 0 ) {
      fatal (CANNOT_OPEN_FILE_FATAL, workfile, 0);
    }

    /* ȥեޡ */
    mergeAll (tmpFd, dstFd);
    /* ե򥯥 */
    Close (tmpFd);
    Close (dstFd);

    /* ȥեõ */
    remove (workfile);
  }
  return 1;
}

/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> insert
 *<>
 *[IO] BuffList	**top	ꥹȤƬ	
 *[I ] BuffList	*new	ꥹȤ
 *<꥿>
 *int	1	
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *ꥹȤǤ
 *<>
 *ꥹȤüĴ١Ŭڤʽ֤ΰ֤
 *
 */
int insert (top, new)
     BuffList **top;
     BuffList *new;
{

  BuffList *prev, *crr;
  
  /* ꥹȤǤƬǤˤ */
  if ( *top == NULL ) {
    *top = new;
    return 1;
  }

  prev = NULL;

  /* ꥹȤƬĴ٤Ƥ */
  for ( crr = *top; crr != NULL; crr = crr->next ) {

    /* ǤߤǤ꾮ä顤Ȥδ֤ */
    if ( cmpData (new->buff, crr->buff) < 0 ) {
      
      /* ̵ˤƬ */
      if ( prev == NULL ) {
        new->next = *top;
        *top = new;
      }
      else {
        /* Ǥθ */
        prev->next = new;
        new->next = crr;
      }
      return 1;
    }
    prev = crr;
  }

  /* ΤϡǸ */
  prev->next = new;
  new->next = NULL;

  return 1;

}
    

/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> mergeAll
 *<>
 *[I ] 	int	tmpFd	ȥեΥե뵭һ
 *[I ] 	int	outFd	ϥեΥե뵭һ
 *<꥿>
 *int	1	
 *<Хѿ>
 *int	OffsetCount	եʬο
 *char	*DataBuf[]	ǡǼХåե
 *<>
 *ʤ
 *<ǽ>
 *ʬʬ䤵Ƥե򡤽֤ˤʤ֤褦ˤޤȤᤢ
 *<>
 *
 *
 */
int mergeAll (tmpFd, outFd)
     int tmpFd;
     int outFd;
{
  int i;
  int	endCount = 0;
  BuffList *new, *top;

  top = NULL;

  /* Хåեν */
  for ( i = 0 ; i < OFFSETMEM_SIZE ; i++ )
    DataBuf[i] = NULL;

  for ( i = 0; i < OffsetCount ; i++ ){
    /* Хåեΰݤƽ */
    new = (BuffList *)malloc (sizeof (BuffList));
    new->num = i;
    new->next = NULL;
    /* ʬΰƬǡ */
    getData (new, tmpFd);
    /* ƬǡꥹȤ */
    insert (&top, new);
  }


  /* ꥹȤǤʤʤޤ */
  while (top) {

    /* ꥹȤƬǤե˽񤭽Ф */
    my_fputs (top->buff, outFd);

    /* ꥹȤμǤƬ˻äƤ */
    new = top;
    top = new->next;
    new->next = NULL;

    /* ʬΰμΥǡ */
    if ( getData(new, tmpFd) != 0 ) {
      /* ǡСꥹȤ */
      insert (&top, new);
    }
    else {
      /* ǡ̵ʤäΤǡΰ */
      free (new);
    }
  }
  /* 񤭹ߥХåեեå */
  flush_wbuf(outFd);

  return 1;
}

/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> my_fputs
 *<>
 *[I ] char	*buf	񤭹ǡ
 *[ O] int	fd	ե뵭һ
 *<꥿>
 *
 *<Хѿ>
 *char	WriteBuf	񤭹ߥХåե
 *<>
 *ʤ
 *<ǽ>
 *fputs ΤѤ롤ե񤭹ߴؿ
 *<>
 *WriteBuf դˤʤä顤եؽ񤭽Ф
 */

int my_fputs (buf, fd)
     char *buf;
     int fd;
{

  int len=0;

  while ( *buf != '\0' ){

    if ( WbufOffset == FBUF_SIZE ) {
      flush_wbuf (fd);
    }
    WriteBuf[WbufOffset] = *buf;
    buf++;
    WbufOffset++;
    len++;
  }

  return len;

}
  
/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> flus_wbuf
 *<>
 *[I ] int	fd	ϥե뵭һ
 *<꥿>
 *ʤ
 *<Хѿ>
 *ʤ
 *<>
 *WriteBuf Ƥõ
 *<ǽ>
 *WriteBuf Ƥե˽񤭽Ф
 *<>
 *
 */
void flush_wbuf (fd)
     int fd;
{
  if (Write (fd, WriteBuf, WbufOffset) < 0) {
    fatal (CANNOT_WRITE, NULL, 0);
  }
  memset (WriteBuf, 0, FBUF_SIZE);
  WbufOffset = 0;
}


/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> getData
 *<>
 *[I ] 	BuffList	*blist		Хåե
 *[ O] 	int		tmpFd		ե뼱̻
 *<꥿>
 *int	1	
 *	0	ǡλ
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *ʬΰΥǡ򡤥Ȥ줿֤
 *<>
 *
 *
 */
int getData (blist, tmpFd) 
     BuffList *blist;
     int tmpFd;
{

  int	i;
  static int crrOffset[OFFSETMEM_SIZE];
  static int readSize[OFFSETMEM_SIZE];

  for ( i = 0 ; i < OffsetCount; i++ ) {
    if ( DataBuf[i] == NULL ) {
      if ( (DataBuf[i] = (char *)malloc (sizeof(char)*FBUF_SIZE)) == NULL ) {
        fatal (OUT_OF_MEMORY, __FILE__, __LINE__);
      }
      crrOffset[i] = FBUF_SIZE;
    }
  }

  if ( NowOffset[blist->num] - readSize[blist->num] + crrOffset[blist->num] 
      >= OffsetMem[blist->num+1] ) {
    free ( DataBuf[blist->num] );
    DataBuf[blist->num] = NULL;
    return 0;
  }

  i = 0;
  while ( DataBuf[blist->num][crrOffset[blist->num]] != '\n' ) {

    if ( crrOffset[blist->num] >= readSize[blist->num] ) {

      Lseek (tmpFd, NowOffset[blist->num], SEEK_SET);

      if ( (readSize[blist->num] = 
            Read ( tmpFd, DataBuf[blist->num], FBUF_SIZE )) <= 0 )
        return 0;

      NowOffset[blist->num] += readSize[blist->num];
      crrOffset[blist->num] = 0;
      continue;
    }

    blist->buff[i] = DataBuf[blist->num][crrOffset[blist->num]];
    i++;
    crrOffset[blist->num]++;
  }
  crrOffset[blist->num]++;
  blist->buff[i++] = '\n';
  blist->buff[i] = '\0';

  return 1;

}


/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> cmpData
 *<>
 *[I ] char	*str1	ʸ
 *[I ] char	*str2	ʸ
 *<꥿>
 *int	> 0	str1 > str2 ξ
 *	< 0	str1 < str2 ξ
 *	0	str1 == str2 ξ
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *str1  str2 Ӥ羮ط˱ޤο֤
 *<>
 *quick_sort()  insert() ƤФ
 *
 */
int cmpData (str1, str2)
     char *str1;
     char *str2; 
{
  while ( *str1 != '\0' && *str2 != '\0') {

    if ( *str1 != *str2 ) 
      break;

    str1++;
    str2++;
  }

  return (int)(*(unsigned char *)str1 - *(unsigned char *)str2);

}


/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> separate
 *<>
 *[IO] char	**left		ꥹȤκü
 *[IO] char	**right		ꥹȤαü
 *[I ] int	size		ꥹȤǿ
 *<꥿>
 *char	**	PIVOT Υɥ쥹
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *ꥹȤǤPIVOT Ȥ羮ˤդ櫓PIVOT Υɥ쥹
 *֤
 *<>
 *
 *
 */
char **separate (left, right, size)
     char  **left;
     char  **right;
     int   size;
{

  char  **mid;
  char	*tmp;
  register char	**pivot;	

  /*  */
  mid = left + (size/2+1);

  /* ֤ȱü촹 */
  SWAP (*right, *mid);
  pivot = right;

  for (;;){
    /* ü PIVOT ۤޤ */
    while ( cmpData (*left, *pivot) < 0 ) {
      left++;
    }
    /* ü PIVOT ۤ뤫left ۤޤ */
    while ( left < right-- && cmpData (*pivot, *right) < 0 );

    if ( left < right ) {
      SWAP (*right, *left);
      left++;
    }
    if ( left >= right )	break;

  }
  /* Ǹˡü PIVOT 촹 */
  SWAP (*left, *pivot);

  return left;

}
    

/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> quick_sort
 *<>
 *[IO] char	**base	Ȥ
 *[I ] int	count	ǿ
 *<꥿>
 *ʤ
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *򥯥åȤ
 *<>
 *Visual C++  qsort ؿν٤Τǡ˺ä
 *
 */
void quick_sort (base, count)
     char **base;
     int  count;
{

  char	***low;
  char	***high;
  int	stackNum;
  char	**pivot;
  char	**left, **right;
  int	size;

  /* åΰγݡʤʤˤʤ */
  if ( (low = (char ***)malloc(sizeof(char **) * MAX_DATANUM)) == NULL ||
       (high = (char ***)malloc(sizeof(char **) * MAX_DATANUM)) == NULL ) {
    fatal (OUT_OF_MEMORY, __FILE__, __LINE__);
  }

  /* åν */
  low[0] = base;
  high[0] = base + count -1;
  stackNum = 1;

  /* å̵ʤޤ */
  while ( stackNum > 0 ) {

    stackNum--;
    left = low[stackNum];
    right = high[stackNum];

    /* left  right 顤ǿ */
    size = (int)(((long)right - (long)left)/sizeof(char **)); 

    if ( size < 5  ) {
      /* ǿʤʤä顤Ȥˤ꤫ */
      insertion_sort (left, right);
    }
    else if ( size > 0 ) {

      /* ʬ */
      pivot = separate (left, right, size);

      /* PIVOT ΰ֤ˤäơåѤ֤򤫤 */
      if ( pivot == left ) {
        low[stackNum] = pivot+1;
        high[stackNum] = right;
        stackNum++;
      }
      else if ( pivot == right ) {
        low[stackNum] = left;
        high[stackNum] = pivot-1;
        stackNum++;
      }	
      else if ( pivot - left < right - pivot ) {
        low[stackNum] = pivot+1;
        high[stackNum] = right;
        stackNum++;
        low[stackNum] = left;
        high[stackNum] = pivot-1;
        stackNum++;
      }
      else {
        low[stackNum] = left;
        high[stackNum] = pivot-1;
        stackNum++;
        low[stackNum] = pivot+1;
        high[stackNum] = right;
        stackNum++;
      }
    }
  }
  /* å */
  free(low);
  free(high);
}
    
    
/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> insersion_sort
 *<>
 *[IO] char	left	κü
 *[IO] char	right	αü
 *<꥿>
 *ʤ
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *left  right δ֤Ȥˤ¤Ӥ
 *<>
 *
 *
 */
void insertion_sort (left, right)
     char **left;
     char **right;
{
  char **point, **crr;
  char *tmp;

  point = left+1;

  while ( point <= right ) {

    crr = point;
    while ( left < crr && cmpData (*crr, *(crr-1)) < 0 ) {
      SWAP (*crr, *(crr-1));
      crr--;
    }
    point++;
  }
}
      

        
