/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include <stdlib.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "stemp.h"

int DB_FileOpen()
{
  GRAM_DB_Open() ;
  CONC_DB_Open() ;
  TCONC_DB_Open() ;
  CONT_DB_Open() ;
}


GRAM_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len ;

  wdenv = getenv( "GRAM_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "GDB_ID2INF" ) ;
  GramId2Val = Open_IXT( file, 'b' ) ;

  strcpy( &file[len], "GDB_INF2ID" ) ;
  GramVal2ID = Open_IXT( file, 's') ;


}




CONC_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len ;

  wdenv = getenv( "CONC_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "CPH_DB" ) ;         /*** ConceptRecordID ==> record ***/
  CPHRecId2Val = Open_IXT( file, 'b' ) ;

  strcpy( &file[len], "CPH_IX" ) ;         /*** ConceptID ==> ConceptRecordID ***/
  CHID2CPRecID = Open_IXT( file, 's') ;

  strcpy( &file[len], "CPC_DB" ) ;         /*** ClassificatonRecordID ==> record ***/
  CPCRecId2Val = Open_IXT( file, 'b' ) ;

  strcpy( &file[len], "CPC_IX" ) ;         /*** ConceptID ==> ClassificationRecordID ***/
  CCID2CPRecID = Open_IXT( file, 's') ;

  strcpy( &file[len], "CPT_DB" ) ;         /*** ConceptDescriptionRecordID ==> record ***/
  CPTRecId2Val = Open_IXT( file, 'b' ) ;

  strcpy( &file[len], "CPT_IX" ) ;         /*** ConceptID ==> ConceptDescriptionRecordID ***/
  CTID2CPRecID = Open_IXT( file, 's') ;

  strcpy( &file[len], "CP_LOG" ) ;
  UpdLogConc = Open_IXT( file, 'b') ;
  if ( UpdLogConc == NULL ) 
    UpdLogConc = Create_IXT( file, 'b', 384 , -1, 64) ;


}





TCONC_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len ;

  wdenv = getenv( "TECH_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    return ;
  }
  strcpy( &file[len], "TCPH_DB" ) ;         /*** ConceptRecordID ==> record ***/
  TCPHRecId2Val = Open_IXT( file, 'b' ) ;

  strcpy( &file[len], "TCPH_IX" ) ;         /*** ConceptID ==> ConceptRecordID ***/
  TCHID2CPRecID = Open_IXT( file, 's') ;

  strcpy( &file[len], "TCPC_DB" ) ;         /*** ClassificatonRecordID ==> record ***/
  TCPCRecId2Val = Open_IXT( file, 'b' ) ;

  strcpy( &file[len], "TCPC_IX" ) ;         /*** ConceptID ==> ClassificationRecordID ***/
  TCCID2CPRecID = Open_IXT( file, 's') ;

}



USER_CPDB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len ;

  wdenv = getenv( "CONC_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "USER_CP_DB" ) ;         /*** pid => User environment ***/
  USERVal = Open_IXT( file, 'b' ) ;
  if (USERVal == NULL )
    USERVal = Create_IXT( file, 'b', 100 , -1, 64) ;
}



int CONT_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len ;

  wdenv = getenv( "CONT_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "CONT_DB" ) ;         /*** ControlDB ***/
  ControlDB = Open_IXT( file, 's' ) ;
  if ( ControlDB == NULL ) {
    fprintf( stderr,"ERROR: ѥեControlDBˤץǤޤǤ\n") ;
    fprintf( stderr,"ERROR: 񤭹߸Ϳ뤫CreCONTޥɤǺƤ\n") ;
    return -1 ;
  }
  return 1 ;
}




GROUP_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len ;

  wdenv = getenv( "WORD_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  /* 쥳ֹ椫饰롼ףɣĤ򸡺 */
  strcpy( &file[len], "R2G_DB" ) ;
  RID2GrpID = Open_IXT( file, 'b' ) ;

  /* 롼ףɣĤ쥳ֹΥꥹȤ򸡺 */
  strcpy( &file[len], "G2R_IX" ) ;
  GrpID2RID = Open_IXT( file, 'b' ) ;
}




WORD_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len ;

  wdenv = getenv( "WORD_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "HDWD_IX" ) ;
  Hdwd2WdRID = Open_IXT( file, 's') ;
  strcpy( &file[len], "YOMI_IX" ) ;
  Yomi2WdRID = Open_IXT( file , 's') ;
  strcpy( &file[len], "CP2W_IX" ) ;
  CID2WdRID = Open_IXT( file , 's') ;
  strcpy( &file[len], "JWD" ) ;
  WdRID2Val = Open_IXT( file, 'b' ) ;

  strcpy( &file[len], "WD_LOG" ) ;
  UpdLogWord = Open_IXT( file, 'b') ;
  if ( UpdLogWord == NULL ) 
    UpdLogWord = Create_IXT( file, 'b', 384 , -1, 64) ;
}




TWORD_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len ;

  wdenv = (char *)getenv( "TECH_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else 
    return ;
  strcpy( &file[len], "TCP2W_IX" ) ;
  TCID2WdRID = Open_IXT( file, 's') ;
  strcpy( &file[len], "THDWD_IX" ) ;
  THdwd2WdRID = Open_IXT( file, 's') ;
  strcpy( &file[len], "TYOMI_IX" ) ;
  TYomi2WdRID = Open_IXT( file, 's') ;
  strcpy( &file[len], "TJWD" ) ;
  TWdRID2Val = Open_IXT( file, 'b' ) ;
}



MSLR_WORD_DB_Open()
{

  MSLR_BWORD_DB_Open() ;
  MSLR_TWORD_DB_Open() ;
}


MSLR_BWORD_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len ;

  wdenv = getenv( "WORD_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "HDWD_IX" ) ;
  Hdwd2WdRID = Open_IXT( file, 's') ;
  strcpy( &file[len], "YOMI_IX" ) ;
  Yomi2WdRID = Open_IXT( file , 's') ;
}


MSLR_TWORD_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len ;

  wdenv = (char *)getenv( "TECH_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else 
    len = 0 ;
  strcpy( &file[len], "THDWD_IX" ) ;
  THdwd2WdRID = Open_IXT( file, 's') ;
  strcpy( &file[len], "TYOMI_IX" ) ;
  TYomi2WdRID = Open_IXT( file, 's') ;
}


MSLR_WORD_DB_Close()
{
  MSLR_BWORD_DB_Close() ;
  MSLR_TWORD_DB_Close() ;
}



MSLR_BWORD_DB_Close()
{
  if ( Hdwd2WdRID != NULL ) Close_IXT( Hdwd2WdRID ) ;
  if ( Yomi2WdRID != NULL ) Close_IXT( Yomi2WdRID ) ;
}



MSLR_TWORD_DB_Close()
{
  if ( THdwd2WdRID != NULL ) Close_IXT( THdwd2WdRID ) ;
  if ( TYomi2WdRID != NULL ) Close_IXT( TYomi2WdRID ) ;
}



int DB_FileClose()
{

  GRAM_DB_Close() ;
  CONC_DB_Close() ;
  TCONC_DB_Close() ;
  CONT_DB_Close() ;

}



GRAM_DB_Close()
{
  if ( GramId2Val != NULL) Close_IXT( GramId2Val ) ;
  if ( GramVal2ID != NULL ) Close_IXT( GramVal2ID ) ;
}



CONC_DB_Close()
{
  if ( CPHRecId2Val != NULL ) Close_IXT( CPHRecId2Val ) ;
  if ( CHID2CPRecID != NULL ) Close_IXT( CHID2CPRecID ) ;

  if ( CPCRecId2Val != NULL ) Close_IXT( CPCRecId2Val ) ;
  if ( CCID2CPRecID != NULL ) Close_IXT( CCID2CPRecID ) ;

  if ( CPTRecId2Val != NULL ) Close_IXT( CPTRecId2Val ) ;
  if ( CTID2CPRecID != NULL ) Close_IXT( CTID2CPRecID ) ;

}


USER_CPDB_Close()
{
  if ( USERVal != NULL) Close_IXT( USERVal ) ;
}



TCONC_DB_Close()
{
  if ( TCPHRecId2Val != NULL ) Close_IXT( TCPHRecId2Val ) ;
  if ( TCHID2CPRecID != NULL ) Close_IXT( TCHID2CPRecID ) ;

  if ( TCPCRecId2Val != NULL ) Close_IXT( TCPCRecId2Val ) ;
  if ( TCCID2CPRecID != NULL ) Close_IXT( TCCID2CPRecID ) ;
}


CONT_DB_Close()
{

  if ( ControlDB != NULL ) Close_IXT( ControlDB ) ;

}


GROUP_DB_Close()
{
  if ( RID2GrpID != NULL ) Close_IXT( RID2GrpID ) ;
  if ( GrpID2RID != NULL ) Close_IXT( GrpID2RID ) ;
}



WORD_DB_Close()
{
  if ( Hdwd2WdRID != NULL ) Close_IXT( Hdwd2WdRID ) ;
  if ( Yomi2WdRID != NULL ) Close_IXT( Yomi2WdRID ) ;
  if ( CID2WdRID != NULL )  Close_IXT( CID2WdRID ) ;
  if ( WdRID2Val != NULL )  Close_IXT( WdRID2Val ) ;
  if ( UpdLogWord != NULL ) Close_IXT( UpdLogWord ) ;
}


TWORD_DB_Close()
{
  if ( THdwd2WdRID != NULL ) Close_IXT( THdwd2WdRID ) ;
  if ( TYomi2WdRID != NULL ) Close_IXT( TYomi2WdRID ) ;
  if ( TCID2WdRID != NULL )  Close_IXT( TCID2WdRID ) ;
  if ( TWdRID2Val != NULL )  Close_IXT( TWdRID2Val ) ;
}



/************************** CORPUS ************************/

int JCorpus_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len, ret ;

  wdenv = getenv( "CORP_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "JCORP_DB" ) ;         /*** RecordID ==> record ***/
  JCORPRecId2Val = OpenBSYSFile( file ) ;
  if ( JCORPRecId2Val == NULL ) {
    return -1 ;
  }

  strcpy( &file[len], "CPJC_IX" ) ;         /*** ConceptID ==> JCorpusRecordID ***/
  CHID2JCORPRecID = Open_IXT( file, 's') ;
  /***
  if ( CHID2JCORPRecID == NULL ) {
    JCorpus_DB_Close() ;
    return -1 ;
  }****/

  strcpy( &file[len], "HWJC_IX" ) ;         /*** Headword ==> JCorpusRecordID ***/
  HDWD2JCORPRecID = Open_IXT( file, 's') ;
  /*****
  if ( HDWD2JCORPRecID == NULL ) {
    JCorpus_DB_Close() ;
    return -1 ;
  }*****/

  strcpy( &file[len], "TID_IX" ) ;         /*** TextID ==> JCorpusRecordID ***/
  TID2JCORPRecID = Open_IXT( file, 's') ;
  /*****
  if ( TID2JCORPRecID == NULL ) {
    JCorpus_DB_Close() ;
    return -1 ;
  }*****/
  strcpy( &file[len], "CORP_LOG" ) ;
  UpdLogCorp = Open_IXT( file, 'b') ;
  if ( UpdLogCorp == NULL )
    UpdLogCorp = Create_IXT( file, 'b', 384 , -1, 64) ;

  return 3 ;
}



JCorpus_DB_Close()
{
  if ( JCORPRecId2Val != NULL ) CLoseBSYSFile( JCORPRecId2Val ) ;
  if ( CHID2JCORPRecID != NULL ) CLoseBSYSFile( CHID2JCORPRecID ) ;
  if ( HDWD2JCORPRecID != NULL ) CLoseBSYSFile( HDWD2JCORPRecID ) ;
  if ( TID2JCORPRecID != NULL ) CLoseBSYSFile( TID2JCORPRecID ) ;
  if ( UpdLogCorp != NULL ) CLoseBSYSFile( UpdLogCorp ) ;
}



int JCorpus_DB_Create()
{
  char *wdenv ;
  char file[512] ;
  int  len, ret ;

  wdenv = getenv( "CORP_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "JCORP_DB" ) ;         /*** RecordID ==> record ***/
  JCORPRecId2Val = CreateBSYSFile( file ) ;
  if ( JCORPRecId2Val == NULL ) {
    return -1 ;
  }

  strcpy( &file[len], "CPJC_IX" ) ;         /*** ConceptID ==> JCorpusRecordID ***/
  CHID2JCORPRecID = Create_IXT( file, 's', 10000 , 10, 64) ;
  if ( CHID2JCORPRecID == NULL ) {
    JCorpus_DB_Close() ;
    return -1 ;
  }

  strcpy( &file[len], "HWJC_IX" ) ;         /*** Headword ==> JCorpusRecordID ***/
  HDWD2JCORPRecID = Create_IXT( file, 's', 10000 , 4, 64) ;
  if ( HDWD2JCORPRecID == NULL ) {
    JCorpus_DB_Close() ;
    return -1 ;
  }

  strcpy( &file[len], "TID_IX" ) ;         /*** TextID ==> JCorpusRecordID ***/
  TID2JCORPRecID = Create_IXT( file, 's', 10000 , -1, 32) ;
  if ( TID2JCORPRecID == NULL ) {
    JCorpus_DB_Close() ;
    return -1 ;
  }
  return 3 ;
}



int JCorpus_IX_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len, ret ;

  wdenv = getenv( "CORP_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "CPJC_IX" ) ;         /*** ConceptID ==> JCorpusRecordID ***/
  CHID2JCORPRecID = Open_IXT( file, 's') ;
  if ( CHID2JCORPRecID == NULL ) {
    JCorpus_DB_Close() ;
    return -1 ;
  }

  strcpy( &file[len], "HWJC_IX" ) ;         /*** Headword ==> JCorpusRecordID ***/
  HDWD2JCORPRecID = Open_IXT( file, 's') ;
  if ( HDWD2JCORPRecID == NULL ) {
    JCorpus_DB_Close() ;
    return -1 ;
  }

  strcpy( &file[len], "TID_IX" ) ;         /*** TextID ==> JCorpusRecordID ***/
  TID2JCORPRecID = Open_IXT( file, 's') ;
  if ( TID2JCORPRecID == NULL ) {
    TID2JCORPRecID = Create_IXT( file, 's', 10000 , -1, 32) ;
    if ( TID2JCORPRecID == NULL ) {
      JCorpus_DB_Close() ;
      return -1 ;
    }

    //JCorpus_DB_Close() ;
    // return -1 ;
  }
  return 2 ;
}



JCorpus_IX_Close()
{
  if ( CHID2JCORPRecID != NULL ) Close_IXT( CHID2JCORPRecID ) ;
  if ( HDWD2JCORPRecID != NULL ) Close_IXT( HDWD2JCORPRecID ) ;
  if ( TID2JCORPRecID != NULL ) Close_IXT( TID2JCORPRecID ) ;
}



/************************** COOCCURENCE (CORPUS INDEX) ***************/


int JCooc_DB_Open()
{
  char *wdenv ;
  char file[512] ;
  int  len, ret ;

  wdenv = getenv( "COOC_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "JCOOC_DB" ) ;         /*** RecordID ==> record ***/
  JCOOCRecId2Val = Open_IXT( file, 'b' ) ;
  if ( JCOOCRecId2Val == NULL ) {
    JCOOCRecId2Val = Create_IXT( file, 'b', 500000 , -1, 128) ;
    if ( JCOOCRecId2Val == NULL ) 
      return -1 ;
  }

  strcpy( &file[len], "SYNDEP_IX" ) ;         /*** ¦ɽCID ==> JCooc(sub)RecordID ***/
  KHDWD2JCOOCRecID = Open_IXT( file, 's') ;
  if ( KHDWD2JCOOCRecID == NULL ) {
    KHDWD2JCOOCRecID = Create_IXT( file, 's', 10000 , 10, 64) ;
    if ( KHDWD2JCOOCRecID == NULL ) {
      JCooc_DB_Close() ;
      return -1 ;
    }
  }

  strcpy( &file[len], "SYNHED_IX" ) ;         /*** ¦ɽCID ==> JCooc(sub)RecordID ***/
  UHDWD2JCOOCRecID = Open_IXT( file, 's') ;
  if ( UHDWD2JCOOCRecID == NULL ) {
    UHDWD2JCOOCRecID = Create_IXT( file, 's', 10000 , 10, 64) ;
    if ( UHDWD2JCOOCRecID == NULL ) {
      JCooc_DB_Close() ;
      return -1 ;
    }
  }

  strcpy( &file[len], "HREL_IX" ) ;         /*** طҡID ***/
  HrelVal2ID = Open_IXT( file, 's') ;
  if ( HrelVal2ID == NULL ) {
    HrelVal2ID = Create_IXT( file, 's', 100 , 4, 32) ;
    if ( HrelVal2ID == NULL ) {
      JCooc_DB_Close() ;
      return -1 ;
    }
  }
  strcpy( &file[len], "HRID_IX" ) ;         /*** ID ==> ط ***/
  ID2HrelVal = Open_IXT( file, 'b') ;
  if ( ID2HrelVal == NULL ) {
    ID2HrelVal = Create_IXT( file, 'b', 100 , -1, 32) ;
    if ( ID2HrelVal == NULL ) {
      JCooc_DB_Close() ;
      return -1 ;
    }
  }
  return 3 ;
}



JCooc_DB_Close()
{
  if ( JCOOCRecId2Val != NULL ) Close_IXT( JCOOCRecId2Val ) ;
  if ( UHDWD2JCOOCRecID != NULL ) Close_IXT( UHDWD2JCOOCRecID ) ;
  if ( KHDWD2JCOOCRecID != NULL ) Close_IXT( KHDWD2JCOOCRecID ) ;
  if ( HrelVal2ID != NULL ) Close_IXT( HrelVal2ID ) ;
  if ( ID2HrelVal != NULL ) Close_IXT( ID2HrelVal ) ;
}



int JCooc_DB_Create()
{
  char *wdenv ;
  char file[512] ;
  int  len, ret ;

  wdenv = getenv( "COOC_DB" ) ;
  if ( wdenv != NULL ) {
    len = strlen(wdenv) ;
    strcpy(file,wdenv) ;
    file[len++] = '/' ;
  }
  else {
    len = 0 ;
  }
  strcpy( &file[len], "JCOOC_DB" ) ;         /*** RecordID ==> record ***/
  JCOOCRecId2Val = Create_IXT( file, 'b', 500000 , -1, 128) ;
  if ( JCOOCRecId2Val == NULL ) {
    return -1 ;
  }

  strcpy( &file[len], "SYNDEP_IX" ) ;         /*** ¦ɽCID ==> JCooc(sub)RecordID ***/
  KHDWD2JCOOCRecID = Create_IXT( file, 's', 10000 , 10, 64) ;
  if ( KHDWD2JCOOCRecID == NULL ) {
    JCooc_DB_Close() ;
    return -1 ;
  }

  strcpy( &file[len], "SYNHED_IX" ) ;         /*** ¦ɽCID ==> JCooc(sub)RecordID ***/
  UHDWD2JCOOCRecID = Create_IXT( file, 's', 10000 , 10, 64) ;
  if ( UHDWD2JCOOCRecID == NULL ) {
    JCooc_DB_Close() ;
    return -1 ;
  }

  strcpy( &file[len], "HREL_IX" ) ;         /*** طҡID ***/
  HrelVal2ID = Create_IXT( file, 's', 100 , 4, 32) ;
  if ( HrelVal2ID == NULL ) {
    JCooc_DB_Close() ;
    return -1 ;
  }

  strcpy( &file[len], "HRID_IX" ) ;         /*** ID ==> ط ***/
  ID2HrelVal = Create_IXT( file, 'b', 100 , -1, 32) ;
  if ( ID2HrelVal == NULL ) {
    JCooc_DB_Close() ;
    return -1 ;
  }
  return 3 ;
}



