/*
#############################################################################
#                                                                           #
#  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1995  #
#                                                                           #
#                    <Dictionary Translator for EDBroW>                     #
#                                                                           #
#  - For details regarding copyright, re-distribution, modification, and    #
#    use of this software see COPYING file.                                 #
#                                                                           #
#  - For UNIX version                                                       #
#    This software was developed on SunOS4.1.3 with the gcc.2.5.8 compiler  #
#    and on Solaris2.3 with the gcc2.5.6 compiler. The compilers supplied   #
#    with SunOS4.1.3 and Solaris2.3 were also used.                         #
#                                                                           #
#  - For Windows version                                                    #
#    This software was developed on Microsoft Windows 3.1 with the          #
#    Microsoft Visual C++ 1.0 compiler.                                     #
#                                                                           #
#############################################################################
*/

/*************************************************************\

  util.c : ȥ󥹥졼桼ƥƥؿ
  Ver.1.1
  95/04/12   by msato@edr8r.edr.co.jp

\*************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "util.h"

#ifdef _WIN32
#include <process.h>
#include <conio.h>
/* #include <jctype.h> */
#include <mbctype.h>
#define GetPID _getpid
#else
#include <sys/types.h>
#define	GetPID getpid
#define _ismbblead(key)    (((0x81 <= key) && (key <= 0x9F) || (0xE0 <= key) && (key <= 0xFC)) ? 1 : 0)
#define _ismbbtrail(key)    (((0x40 <= key) && (key <= 0x7E) || (0x80 <= key) && (key <= 0xFC)) ? 1 : 0)
#endif

/*----------------*/
/* Хѿ */
/*----------------*/

/* ǰ̻Ѵơ֥ */
static LongCIDList longCidList[] = {
  "000103e8",		"a00001",
  "00012710",		"a00002",
  "00010f4240",		"a00003",
  "000105f5e100",	"a00004",
  "0001e8d4a51000",	"a00005",
  "00012386f26fc10000",	"a00006",
};

/* 顼å */
static char * FatalMsg[] = 
{
  "Usage : dtrans [-WD|-BI|-CC|-CI|-CH|-CR]",
  "\n[FATAL_ERROR!] γݤ˼Ԥޤ",
  "\n[FATAL_ERROR!] ե򥪡ץǤޤ",
  "\n[FATAL_ERROR!] ե˽񤭹ळȤǤޤ",
  "\n[FATAL_ERROR!] 顼ȯޤ",
};

static char * ErrMsg[] =
{
  "ǡ۾...쥳ID :",
  "ե뤬ץǤޤ :",
  "λ˸꤬ޤ :",
  "ꤵ줿ƥȼηǤ",
  "Ѵ˼Ԥޤ",
};


/* եĥ */
static char *FileSfx[] = { "fdc", "idx", "idx", "idx", "idx", "srt"};
static char *FileExt[] = { "tmp", "tm1", "tm2", "tm3", "srt", "tmp"};

/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> streuctosjis
 *<>
 *[I ] unsigned char *srcPtr   Ѵʸʣţգá
 *[ O] unsigned char *dstPtr   ѴʸʥեȣʣɣӡˤγǼΰ
 *<꥿>
 *int                          Ѵʸ
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *ţգåɤʸͿơб륷եȣʣɣʸ
 *ɤʸ֤ASCII 򤸤ξפʤ褦ˤ롥
 *<>
 *Ѵ§ euctosjis ˽
 *dstPtr ˳ݤ٤ΰ礭ϡsrcPtr λؤʸܣХ
 *  Ǥ롣ʡܣХȤϽü'\0'ѡ
 *srcPtr ѴǤʤɤޤޤϡѴǤ롣
 */

int streuctosjis (srcPtr, dstPtr)
     unsigned char *srcPtr;
     unsigned char *dstPtr;
{
  int            count = 0;	/* Ѵʸ	*/
  unsigned short sjis;		/* jistosjis() η	*/
  unsigned char  sjis1;		/* sjis 裱Х	*/
  unsigned char  sjis2;		/* sjis 裲Х	*/

  /** ͤˤȤѴ **/

  /*----------------------------------------------------*/
  /* ţգʸ򥷥եȣʣɣʸѴ */
  /*----------------------------------------------------*/
  /*================================================*/
  /* ţգâեȣʣɣѴʤ̤Ǽ */
  /*================================================*/

  while ( *srcPtr ){
    /* srcPtr  '\0' ؤޤǷ֤ */

    if ( *srcPtr > 127 ) {	/* ţգäξ */
      /*--------------------------*/
      /* ţգâեȣʣɣѴ */
      /*--------------------------*/
      sjis = euctosjis( *srcPtr, *(srcPtr +1 ));
      sjis1 = sjis >> 8;
      sjis2 = sjis & 0xff;
      /*----------------*/
      /* Ѵ̤Ǽ */
      /*----------------*/
      *dstPtr = sjis1;
      *(dstPtr + 1 ) = sjis2;
      if ( sjis1 == 0 ){
        /*----------------------------------------------*/
        /* jistosjis() ѴǤʤɤʤѴλ */
        /*----------------------------------------------*/
        break;
      }
      else{
        /*----------------------------------------------------*/
        /* jistosjis() ѴǤ顢ʸȤ䤹 */
        /*----------------------------------------------------*/
        count += 2;
      }
      /*----------------------------------------*/
      /* ʣɣӡţգåɤΥݥ󥿤ʤ */
      /*----------------------------------------*/
      srcPtr += 2;
      /*--------------------------------------*/
      /* եȣʣɣӥɤΥݥ󥿤ʤ */
      /*--------------------------------------*/
      dstPtr += 2;
    }
    else{	/* ASCIIʸξ */

      /* Τޤ޳Ǽ */
      *dstPtr = *srcPtr;

      /* ݥ󥿤ʤ */
      srcPtr++;
      dstPtr++;
      count++;
      
    }
  }

  /*==============================*/
  /* Ѵʸ̥뽪ü */
  /*==============================*/
  *dstPtr = '\0';
  /*----------------------*/
  /* Ѵʸ֤ */
  /*----------------------*/
  return count;
}


/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> euctosjis
 *<>
 *[I ] unsigned int jis    ʣɣӥ
 *<꥿>
 *unsigned int             jis б륷եȣʣɣӥ
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *ʣɣӥɤͿơб륷եȣʣɣӥɤ֤
 *<>
 *(unsigned int)jis 裱ӥåȤʣɣӥɤ裱Хȡ
 *                        ӥåȤʣɣӥɤ裲ХȤ
 *  ߤʤSPARCǤintХȤǤ뤳Ȥա
 */

unsigned short euctosjis (euc1, euc2)
     unsigned char	euc1;
     unsigned char	euc2;
{
  unsigned char  jis1;		/* jis裱Х		*/
  unsigned char  jis2;		/* jis裲Х		*/
  unsigned char  sjis1;		/* shift jis裱Х	*/
  unsigned char  sjis2;		/* shift jis裲Х	*/

  /** ͤˤȤѴ **/

  jis1 = euc1 & 0x7f;
  jis2 = euc2 & 0x7f;

  if ( !(jis1 % 2) ){
    sjis2 = jis2 + 0x7d;
  }
  else{
    sjis2 = jis2 + 0x1f;
  }
  if ( sjis2 >= 0x7f ){
    sjis2++;
  }
  sjis1 = (char)(((short)jis1 - 0x21) / 2 + 0x81);
  if ( sjis1 > 0x9f ){
    sjis1 += 0x40;
  }

  return (sjis1 << 8) + sjis2;
}


/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO + Esaki(JSA)
 *<ơ> ȥ󥹥졼
 *<ؿ̾> makeCID
 *<>
 *[I ] char  *cidStr     ǰ̻ʸ
 *<꥿>
 *unsigned long 	1 ʾ		ǰ̻
 * 			0 		顼
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *ǰ̻ʸ򡤼˳Ǽunsigned longˤѴ롥
 *<>
 *cidStr ʸʲǤ뤳Ȥå롥
 *  Ǥʤϥơ֥˽äѴ롥
 *ѴǤʤˤϡ0 ֤
 */
unsigned long makeCID (cidStr)
     char  *cidStr;
{

  char	buffer[10];
  unsigned long	cid = 0x0L;

  if ( strlen (cidStr) >= 8 ) {	/* ʸʾξ */

    if ( strncmp (cidStr, "0001", 4) == 0 ) {	/* ǰξ */

      if ( transCID(cidStr,buffer) == 0 ){
        /* ѴǤʤä cid  0 ˤ */
        cid = 0x0L;
      }
      else{
        /* ǰ̻Ҥ */
        sscanf(buffer,"%lx",&cid);
      }
    }
    else {
      sscanf(cidStr,"%lx",&cid);
      // cid = 0x0L;
    }
  }
  else {
    /* ǰ̻Ҥ */
    sscanf(cidStr,"%lx",&cid);
  }

  /* ǰ̻Ҥ֤ */
  return cid;

}


/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> transCID
 *<>
 *[I ] char  *longStr     ǰ̻ʸ
 *[ O] char  *shortStr    ǰ̻ʸ
 *<꥿>
 *int     0      顼
 *        1      
 *<Хѿ>
 * LongCIDList	longCidList	Ѵơ֥
 *<>
 *ʤ
 *<ǽ>
 * ʸʾγǰ̻Ҥ򡤥ơ֥˽äƣʸʲѴ롥
 *<>
 *ʤ
 */
int transCID (longStr, shortStr)
     char	*longStr;
     char	*shortStr;
{

  int	i;		/*  */
  int	flag = 0;	/* ե饰 */

  /* Ѵơ֥򸡺 */
  for ( i = 0; i < LCID_LIST_SIZE ; i++ ){

    if ( strcmp(longCidList[i].longcid,longStr) == 0 ){
      /* ơ֥ˤУϣ */
      strcpy(shortStr,longCidList[i].shortcid);
      flag = 1;
      break;

    }
  }
  /* ե饰֤ͤ */
  return flag;

}

/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> get_field
 *<>
 *[I ] char	*input_str	ʸʰԡ
 *[ O] cahr	*field[]	ʬʸ
 *[I ] int	max		եɿ
 *<꥿>
 *int	եɿ(>1)	
 *	0			۾
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 * '\t' եɤζڤȤʤʸФơʲ¹
 *	'\t', '\n'  '\0' (NULLʸ)ִ
 *	field[] ˡƥեɤƬսʥݥ󥿡ˤǼ
 *<>
 *եɿ max ۤ顤0 ֤
 *
 */
int
get_field (input_str, field, max)
     char	*input_str;
     char	*field[];
     int	max;
{
  int	fieldnum = 0;	/* եɿ */

  /* ʸƬݥ󥿤򥳥ԡ */
  field[fieldnum] = input_str;
  fieldnum++;

  /* '\n' ޤǡʸå */
  while ( *input_str != '\n' ){

    /* ͤ礭ʤä顤0 ֤ */
    if ( fieldnum > max ) 
      return 0;

    /* '\t' ǤСեɤ򣱤ĥե */
    if ( *input_str == '\t' ){
      /* ʸκǸ '\t' äƤ礬  */
      if ( *(input_str+1) != '\n' ) {
        field[fieldnum] =  input_str+1;
        fieldnum++;
      }
      *input_str = '\0';
    }
    input_str++;
  }

  *input_str = '\0';
  
  return fieldnum;

}

/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> make_filename
 *<>
 *[ O] char	*filename	ե̾ʽϡ
 *[I ] int	num		̻
 *<꥿>
 *int	1	
 *	0	۾
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *̻Ҥͤ˱ơץIDθե̾
 *filename 롥
 *<>
 *
 */
int make_filename (filename, num)
     char	*filename;
     int	num;
{
  short	pid;	/* ץID */
  char	*workDir;

  /* ץIDμ */
  pid = (short)GetPID();
  /* ȥǥ쥯ȥμ */
  workDir = getenv ("DTRANS_TMP");

  if ( workDir != NULL ) {
    sprintf (filename, "%s/%s%05d.%s", 
             workDir, FileSfx[num], pid, FileExt[num]); 
  }
  else {
    sprintf (filename, "%s%05d.%s", FileSfx[num], pid, FileExt[num]); 
  }
  return 1;

}


/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> msato
 *<ơ> ȥ󥹥졼
 *<ؿ̾> fatal
 *<>
 *[I ] char *message	̿Ū顼ȯɽå
 *[I ] char *filename	ե̾
 *[I ] int  line	եˤԿ
 *<꥿>
 *ʤ
 *<Хѿ>
 * char *FatalMsg[]	顼å
 *<>
 *ץμ¹Ԥλ롣
 *<ǽ>
 *̿Ū顼äˡåɽƤץλ롣
 *<>
 *ʤ
 */

void
fatal (Num, filename, line)
     int    Num;
     char  *filename;
     int   line;
{

  if ( line == 0 ) {

    if ( filename == NULL ) {
      fprintf (stderr, "%s\n", FatalMsg[Num]);
    }
    else {
      fprintf (stderr, "%s (%s)\n", FatalMsg[Num], filename);
    }
  }
  else {
    fprintf(stderr, "%s (%s,%d)\n", FatalMsg[Num], filename, line);
  }

  /** ץΰ۾ｪλ **/
#ifdef  _WIN32
  fputs("\nɤ줫򲡤Ƥ...", stderr);
  _getch();
#endif
  exit(1);

}

/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> msato
 *<ơ> ȥ󥹥졼
 *<ؿ̾> print_err
 *<>
 *[I ] int num		顼ֹ
 *[I ] char *message	顼ȯɽå
 *<꥿>
 *ʤ
 *<Хѿ>
 * char *ErrMsg[]	顼å
 *<>
 *ʤ
 *<ǽ>
 *顼äˡåɽ롥
 *<>
 *ʤ
 */

void 
print_err (num, message)
     int	num;
     char	*message;
{

  fprintf (stderr, "\n[ERROR!] %s %s\n\n", ErrMsg[num], message);

}

/***
 *<TITLE>	ؿͽ
 *<footer> ʳŻҲ񸦵
 *<> MSATO
 *<ơ> ȥ󥹥졼
 *<ؿ̾> get_txtDicFp (mode)
 *<>
 *[I ] int mode    ե꡿ɸϤ򼨤⡼
 *<꥿>
 *FILE *fp   եݥ
 *     NULL  ۾
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 *stdin Ϥ줿̾Υե򥪡ץ󤹤
 *<>
 *mode == STDIN_MODE ξϡ stdin ֤
 *
 */

FILE *get_txtDicFp (mode)
     int	mode;
{

  static int	stdinFlag = 0;
  char	filename[FILENAME_SIZE];
  FILE	*fp;

  /* ɸϥ⡼ɤξ */
  if ( mode == STDIN_MODE ) {
    /* ܤ stdin ܰʹߤ NULL ֤ */
    if ( stdinFlag == 0 ) {
      stdinFlag = 1;
      return stdin;
    }
    else {
      return NULL;
    }
  }

  /* ե⡼ɤξ */
  fprintf (stderr, "ƥȼΥѥ̾ϤƲ (q:꽪λ)\n");

  /* ե̾ */
  if ( prompt (filename, FILENAME_SIZE) == END_COMMAND )
    return NULL;

  if ( (fp = fopen (filename, RDOPN_FLAG)) == NULL ) {
    /* 顼å */
    print_err (CANNOT_OPEN_FILE, filename);
    /* Ϥ׵᤹ */
    return get_txtDicFp (mode);
  }

  /* ץ󤷤եݥ󥿤֤ */
  return fp;
}


/***
 *<TITLE>	ܺٻͽ
 *<footer> ()ŻҲ񸦵
 *<> msato
 *<ơ> ȥ󥹥졼
 *<ؿ̾> mystrchr
 *<>
 *[I ] 	char 	*string		ʸ
 *[I ] 	char	index		ʸʣʸΤߡ
 *<꥿>
 * char * 		ʸΡʸ֤Υɥ쥹
 *		۾	NULL (ʸ̵)
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 * ʸΡʸ֤Υɥ쥹֤
 *<>
 *  SJIS ʸˡASCII ʸˤ븡ʸˤ⡤
 *  ư strchr 	
 */
char *mystrchr (string, index)
  char *string;
  char index;

{
  while ( *string != '\0' ){

    /* ХʸǤСĿʤ */
    if ( _ismbblead ( (unsigned char )*string ) == 1 &&
         _ismbbtrail ( (unsigned char)*(string+1) ) == 1 ) {
      string += 2;
      continue;
    }
    if ( *string == index ){    /* index ʸդä */
      return string;
    }
    string ++;
  }

  /* Ĥʤ */
  return NULL;

}


/***
 *<TITLE>	ܺٻͽ
 *<footer> ()ŻҲ񸦵
 *<> msato
 *<ơ> ȥ󥹥졼
 *<ؿ̾> prompt
 *<>
 *[I ] 	char 	*buf		ʸ
 *[I ] 	int	size		
 *<꥿>
 *int	1		
 *	END_COMMAND	λ
 *<Хѿ>
 *ʤ
 *<>
 *ʤ
 *<ǽ>
 * "[] >>" ץץȤɽϤ줿ʸ buf ˳Ǽ
 *<>
 *üβԥɤϺ롥
 * "q" Ϥ줿ˤϡEND_COMMAND ֤
 */
int prompt (buf, size)
     char 	*buf;
     int	size;
{

  fprintf (stderr, "[] >> ");

  if ( fgets (buf, size, stdin) == NULL ) 
    return END_COMMAND;

  if ( buf[1] == '\n' && ( buf[0] == 'q' || buf[0] == 'Q' ) )
    return END_COMMAND;

  buf[strlen(buf)-1] = '\0';

  return 1;

}

