/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  E_rcon[]= {
	{ "ERB1",	 "	Blank" },
	{ "ERR1",	 "괧 a	Indefinite article 'a'" },
	{ "ERR2",	 "괧 an	Indefinite article 'an'" },
	{ "ERR3",	 "괧	Definite article 'the'" },
	{ "ERPF",	 "Ƭ	Prefix" },
	{ "ECN1",	 "̾Ѳʬ ( s  )	Noun (inflection pattern s)" },
	{ "ECN2",	 "̾Ѳʬ ( es  )	Noun (inflection pattern es)" },
	{ "ECN3",	 "̾Ѳʬ ( y/ies  )	Noun (inflection pattern y)" },
	{ "ECN4",	 "̾Ѳʬ ( fe/ves  )	Noun (inflection pattern fe)" },
	{ "ECN5",	 "̾Ѳʬ ( f/ves  )	Noun (inflection pattern f)" },
	{ "ECN6",	 "̾Ѳʬ ( s/es  )	Noun (inflection pattern s&es)" },
	{ "ECN7",	 "̾Ѳʬ ( 's  )	Noun (inflection pattern 's)" },
	{ "ECN8",	 "̾Ѳʬ ( s/'s  )	Noun (inflection pattern s&'s)" },
	{ "ERN1",	 "̾ñ	Singular form of noun (final letter not 's')" },
	{ "ERN2",	 "̾ʣ	Plural form of noun (final letter 's')" },
	{ "ERN3",	 "̾ñʣƱ	Noun with common singular and plural forms (final letter not 's')" },
	{ "ERN4",	 "̾ͭ	Possessive form of noun" },
	{ "ERN5",	 "̾ñ s	Singular form of noun (final letter 's')" },
	{ "ERN6",	 "̾ʣ s ʳ	Plural form of noun (final letter not 's')" },
	{ "ERN7",	 "̾ñʣƱ s	Noun with common singular and plural forms (final letter 's')" },
	{ "ERP1",	 ";̾ʰ;ñ	Personal pronoun (nominative, 1st person singular)" },
	{ "ERP2",	 ";̾;ʣ	Personal pronoun (nominative, 2nd person singular/plural and plural)" },
	{ "ERP3",	 ";̾ʻ;ñ	Personal pronoun (nominative, 3rd person singular)" },
	{ "ERP4",	 ";̾ͭ	Personal pronoun (determinative possessive)" },
	{ "ERP5",	 ";̾Ū	Personal pronoun (objective)" },
	{ "ERP7",	 ";̾Ωͭ	Personal pronoun (independent possessive)" },
	{ "ERP8",	 "Ƶ̾	Personal pronoun (reflexive)" },
	{ "ERP9",	 "ؼ̾ñ	Demonstrative pronoun (singular form)" },
	{ "ERPA",	 "ؼ̾ʣ	Demonstrative pronoun (plural form)" },
	{ "ERPB",	 "ؼñ	Demonstrative determiner (singular form)" },
	{ "ERPC",	 "ؼʣ	Demonstrative determiner (plural form)" },
	{ "ERPD",	 "̾ (ñ)	Indefinite pronoun (singular form)" },
	{ "ERPE",	 "̾ (ʣ)	Indefinite pronoun (plural form)" },
	{ "ERL1",	 "ط̾	Relative pronoun (nominative)" },
	{ "ERL2",	 "ط̾ͭ	Relative pronoun (possessive)" },
	{ "ERL3",	 "ط̾Ū	Relative pronoun (objective)" },
	{ "ERL4",	 "ط̾ what	Relative pronoun (what)" },
	{ "ERL5",	 "ط	Relative adverb" },
	{ "ERQ1",	 "̾	Iterrogative pronoun (nominative)" },
	{ "ERQ2",	 "̾ͭ	Interrogative pronoun (possessive)" },
	{ "ERQ3",	 "̾Ū	Interrogative pronoun (objective)" },
	{ "ERQ4",	 "	Interrogative determiner" },
	{ "ERQ6",	 "	Interrogative adverb" },
	{ "ERM1",	 "	Cardinal number" },
	{ "ERM2",	 "	Ordinal number" },
	{ "ERE1",	 "be	Be-verb (be)" },
	{ "ERE2",	 "am	Be-verb (am)" },
	{ "ERE3",	 "are	Be-verb (are)" },
	{ "ERE4",	 "is	Be-verb (is)" },
	{ "ERE5",	 "was	Be-verb (was)" },
	{ "ERE6",	 "were	Be-verb (were)" },
	{ "ERE7",	 "been	Be-verb (been)" },
	{ "ERE8",	 "being	Be-verb (being)" },
	{ "ERH1",	 "ư have	Auxiliary verb have" },
	{ "ERH2",	 "ư has	Auxiliary verb has" },
	{ "ERH3",	 "ư had	Auxiliary verb had" },
	{ "ERH4",	 "ư having	Auxiliary verb having" },
	{ "ERX1",	 "ư	Other auxiliary verb" },
	{ "ERC1",	 "³	Coordinate conjunction" },
	{ "ERC2",	 "°³	Subordinate conjunction" },
	{ "ECV1",	 "s-d ѲưѲʬ	Verb (inflection pattern s-d)" },
	{ "ECV2",	 "s-ed ѲưѲʬ	Verb (inflection pattern s-ed)" },
	{ "ECV3",	 "es-edѲưѲʬ	Verb (inflection pattern es-ed)" },
	{ "ECV4",	 "e ѲưѲʬ	Verb (inflection pattern e)" },
	{ "ECV5",	 "y ѲưѲʬ	Verb (inflection pattern y)" },
	{ "ECV6",	 "ie ѲưѲʬ	Verb (inflection pattern ie)" },
	{ "EPVB",	 "s-bb ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVD",	 "s-dd ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVF",	 "s-ff ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVG",	 "s-gg ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVL",	 "s-ll ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVN",	 "s-nn ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVR",	 "s-rr ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVT",	 "s-tt ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVV",	 "s-vv ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "ECV7",	 "s-ing ѲưѲʬ	Verb (inflection pattern s-ing)" },
	{ "ECV8",	 "es-ing ѲưѲʬ	Verb (inflection pattern es-ing)" },
	{ "ECV9",	 "e-ing ѲưѲʬ	Verb (inflection pattern e-ing)" },
	{ "ECVA",	 "y-ying ѲưѲʬ	Verb (inflection pattern y-ying)" },
	{ "ECVB",	 "s Ե§Ѳư	Verb (inflection pattern s-irreg.)" },
	{ "ERV1",	 "ܤʤư츶	Verb (infinitive form not followed by verb ending)" },
	{ "ERV2",	 "ư컰ñ	Verb (third person singular form)" },
	{ "ERV3",	 "ư	Verb (past form)" },
	{ "ERV4",	 "ưʬ	Verb (past participle form)" },
	{ "ERV5",	 "ư츽ʬ	Verb (present participle form)" },
	{ "ECA1",	 "er Ѳƻ	Adjective (inflection pattern er)" },
	{ "ECA2",	 "r Ѳƻ	Adjective (inflection pattern r)" },
	{ "ECA3",	 "ier Ѳƻ	Adjective (inflection pattern ier)" },
	{ "ECAB",	 "bbѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAD",	 "ddѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAF",	 "ffѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAG",	 "ggѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAK",	 "kkѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAL",	 "llѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAM",	 "mmѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAN",	 "nnѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAP",	 "ppѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAR",	 "rrѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAS",	 "ssѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAT",	 "ttѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAV",	 "vvѲƻ	Adjective (inflection pattern C+er)" },
	{ "ECAZ",	 "zzѲƻ	Adjective (inflection pattern C+er)" },
	{ "ERA1",	 "ܤʤư츶	Adjective (positive degree form not followed by adjective ending)" },
	{ "ERA2",	 "ƻӵ	Comparative degree form of adjective" },
	{ "ERA3",	 "ƻǾ	Superlative degree form of adjective" },
	{ "ECD1",	 "erѲ	Adverb (inflection pattern er)" },
	{ "ECD2",	 "rѲ	Adverb (inflection pattern r)" },
	{ "ECD3",	 "Ѳ ier/iestst	Adverb (inflection pattern ier)" },
	{ "ECDB",	 "bbѲ	Adverb (inflection pattern C+er)" },
	{ "ECDD",	 "ddѲ	Adverb (inflection pattern C+er)" },
	{ "ECDF",	 "ffѲ	Adverb (inflection pattern C+er)" },
	{ "ECDG",	 "ggѲ	Adverb (inflection pattern C+er)" },
	{ "ECDK",	 "kkѲ	Adverb (inflection pattern C+er)" },
	{ "ECDL",	 "llѲ	Adverb (inflection pattern C+er)" },
	{ "ECDM",	 "mmѲ	Adverb (inflection pattern C+er)" },
	{ "ECDN",	 "nnѲ	Adverb (inflection pattern C+er)" },
	{ "ECDP",	 "ppѲ	Adverb (inflection pattern C+er)" },
	{ "ECDR",	 "rrѲ	Adverb (inflection pattern C+er)" },
	{ "ECDS",	 "ssѲ	Adverb (inflection pattern C+er)" },
	{ "ECDT",	 "ttѲ	Adverb (inflection pattern C+er)" },
	{ "ECDV",	 "vvѲ	Adverb (inflection pattern C+er)" },
	{ "ECDZ",	 "zzѲ	Adverb (inflection pattern C+er)" },
	{ "ERD1",	 "ܤʤ츶	Adverb (positive degree form not followed by adverb ending)" },
	{ "ERD2",	 "ӵ	Comparative degree form of adverb" },
	{ "ERD3",	 "Ǿ	Superlative degree form of adverb" },
	{ "ERD5",	 "쾮	Adverbial particle" },
	{ "ERIT",	 "	Interjection" },
	{ "ERPP",	 "ֻ	Preposition" },
	{ "ERS1",	 "Ѿʸ	Uncapitalized roman letter" },
	{ "ERS2",	 "ʸ	Capitalized roman letter" },
	{ "ERS3",	 "άޡ	Abbreviation mark" },
	{ "ERS4",	 "Ϣ뵭	Connection symbol" },
	{ "ERS5",	 "	Decimal point" },
	{ "ERS6",	 "ʸ	SI-prefix" },
	{ "ERS7",	 "ñ	 Unit of measure" },
	{ "ERS8",	 "	Numeral" },
	{ "ERS9",	 "ڤ국	Punctuation mark of separation" },
	{ "ERSA",	 "ԥꥪ	Fullstop punctuation mark" },
	{ "ERSB",	 "	Special symbol" },

	{ "EPVK",	  "s-kk ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVM",	  "s-mm ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVP",	  "s-pp ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "ER01",	  "ư do	Auxiliary verb do" },
	{ "ER02",	  "ư does	Auxiliary verb does" },
	{ "ER03",	  "ư did	Auxiliary verb did" },
	{ "ERPF",	  "?Ƭ" },
	{ "ERSC",	  "޿	Roman numeral" },
	{ "ERTO",	  "to	to-infinitive" },
        { NULL,  NULL }} ;




