/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  E_style[]= {
	{ "ENCTOCL",	 "Ƥ򼨤 to- ˽	Modified by to - infinitive" },
	{ "ENCTHCL",	 "Ƥ򼨤 that- ˽	Modified by non - relative that - clause" },
	{ "ENCPP",	 "ֻȤ	Modified by specific preposition phrase(s)" },
	{ "ENITTH",	 "Ȥʤꡢit-that ʸȤ	Appears in the context, `it is NOUN that...`" },
	{ "EAUITTH",	 "it-that ʸȤ	Appears in the context, `it is ADJECTIVE that ...`" },
	{ "EACTOCL",	 "Ƥ򼨤 to-˽	Followed by to-infinitive" },
	{ "EACTHCL",	 "Ƥ򼨤 that-˽	Followed by non-relative that-clause" },
	{ "EACPP",	 "ֻȤ	Modified by specific preposition phrase(s)" },
	{ "EVSC0",	 " (SC) ɬȤư	Takes a subjective complement (SC): S+V+SC" },
	{ "EVIT0",	 "ư졢ޤϼɬȤư	Takes neither direct nor indirect object: S+V / S+V+C" },
	{ "EVIO0",	 "Ū (IO) ɬȤư	Takes an indirect object (IO): S+V+IO+DO" },
	{ "EVIO1",	 "Ū (IO) + ľŪ (DO) ˡľŪ (DO) + to + ̾ȤäƤ褤	[Indirect Object (IO) + Direct Object (DO)] is replaceable with [Direct Object (DO) + 'to' + noun phrase]." },
	{ "EVIO2",	 "Ū (IO) + ľŪ (DO) ˡľŪ (DO) + for + ̾ȤäƤ褤	[Indirect Object (IO) + Direct Object (DO)] is replaceable with [Direct Object (DO) + 'for' + noun phrase]." },
	{ "EVDO0",	 "ľŪ (DO) ɬȤư	Takes a direct object (DO): S+V+DO / S+V+IO+DO / S+V+DO+OC" },
	{ "EVDO1",	 "DO = ̾ (ͭ̾졢̾ޤ)	DO = noun phrase ( including proper nouns and pronouns)" },
	{ "EVDO2",	 "DO = that-	DO = that - clause" },
	{ "EVDO3",	 "DO =  wh/if-	DO = subordinate wh / if - clause" },
	{ "EVDO4",	 "DO =  wh-to 	DO = wh - to - infinitive phrase" },
	{ "EVDO5",	 "DO = 	DO = bare infinitive" },
	{ "EVDO6",	 "DO = to-	DO = to - infinitive" },
	{ "EVDO7",	 "DO = ing  	DO = -ing form" },
	{ "EVOC0",	 "Ū (OC) ɬȤư	Takes an objective complement (OC): S+V+DO+OC" },
	{ "EVC10",	 "C = ̾ (̾)	SC/OC = noun phrase (including proper nouns and pronouns)" },
	{ "EVC20",	 "C = ƻ	SC/OC = adjective phrase " },
	{ "EVC30",	 "C = to be + ̾	SC/OC = 'to be' + noun phrase" },
	{ "EVC40",	 "C = to be + ƻ	SC/OC = 'to be' + adjective phrase" },
	{ "EVC50",	 "C = 	SC/OC = bare infinitive" },
	{ "EVC60",	 "C = to-	SC/OC = to - infinitive" },
	{ "EVC70",	 "C = ʬ	SC/OC = past participle " },
	{ "EVC80",	 "C = ing 	SC/OC = -ing form" },

	{ "EVC91",	 "C = like + ̾	C = like + noun phrase"},
	{ "EVC92",	 "C = as + ̾	C = as + noun phrase"},
	{ "EVC93",	 "C = for + ̾	C = for + noun phrase"},


	{ "EVSA0",	 "ɬȤ	Takes specific adverbial phrase (ADP)" },
	{ "EVSA1",	 "ADP = there : ΰ֤ there ȼʸ (thereʸ) Ѥ	ADP = there: requires `there` in canonical subject position in generic existential expression (e.g. go, seem, appear)" },
	{ "EVSA2",	 "ADP = ֻ + ̾	ADP = preposition phrase(s)" },
	{ "EVSA4",	 "ADV = ꡢ֤򼨤줢뤤ֻ	ADP = adverb or prepositional phrase indicating space, time, direction or manner"},
	{ "EVSA5",	 "ADV = to-	ADP = to - infinitive" },
	{ "EVSA6",	 "ADV = ing 	ADP = -ing form " },
	{ "EVSI1",	 " it ʸ	Requires `it` with no referent in subject position (e.g. it rains.)" },
	{ "EVSI2",	 "it = that-ṽʸ	`It` in subject position refers to the following that-clause " },
	{ "EVSI3",	 "it = as if ʸ	`It` in subject position refers to the following as-if-clause" },
	{ "EVSI4",	 "it = whether ʸ	`It` in subject position refers to the following whether-clause " },
	{ "EVTH2",	 "that- Τ so ֤	That - clause following the verb is replaceable with `so`" },
	{ "EVTH3",	 "that- Τ not ֤	That - clause following the verb is replaceable with `not`" },

	{ "+EABOUT",	 "ֻؼabout	about" },
	{ "+EABOVE",	 "ֻؼabove	above" },
	{ "+EACROSS",	 "ֻؼacross	across" },
	{ "+EAFTER",	 "ֻؼafter	after" },
	{ "+EAGAINST",	 "ֻؼagainst	against" },
	{ "+EALONG",	 "ֻؼalong	along" },
	{ "+EAMONG",	 "ֻؼamong	among" },
	{ "+EAROUND",	 "ֻؼaround	around" },
	{ "+EAS",	 "ֻؼas	as" },
	{ "+EAT",	 "ֻؼat	at" },
	{ "+EAWAY",	 "ֻؼaway	away" },
	{ "+EBEFORE",	 "ֻؼbefore	before" },
	{ "+EBEHIND",	 "ֻؼbehind	behind" },
	{ "+EBELOW",	 "ֻؼbelow	below" },
	{ "+EBESIDE",	 "ֻؼbeside	beside" },
	{ "+EBETWEEN",	 "ֻؼbetween	between" },
	{ "+EBEYOND",	 "ֻؼbeyond	beyond" },
	{ "+EBY",	 "ֻؼby	by" },
	{ "+EDOWN",	 "ֻؼdown	down" },
	{ "+EDURING",	 "ֻؼduring	during" },
	{ "+EEXCEPT",	 "ֻؼexcept	except" },
	{ "+EFOR",	 "ֻؼfor	for" },
	{ "+EFROM",	 "ֻؼfrom	from" },
	{ "+EIN",	 "ֻؼin	in" },
	{ "+EINTO",	 "ֻؼinto	into" },
	{ "+ELIKE",	 "ֻؼlike	like" },
	{ "+ENEAR",	 "ֻؼnear	near" },
	{ "+ENEXT",	 "ֻؼnext	next" },
	{ "+EOF",	 "ֻؼof	of" },
	{ "+EOFF",	 "ֻؼoff	off" },
	{ "+EON",	 "ֻؼon	on" },
	{ "+EONTO",	 "ֻؼonto	onto" },
	{ "+EOUT",	 "ֻؼout	out" },
	{ "+EOVER",	 "ֻؼover	over" },
	{ "+EPAST",	 "ֻؼpast	past" },
	{ "+EPER",	 "ֻؼper	per" },
	{ "+EROUND",	 "ֻؼround	round" },
	{ "+ESINCE",	 "ֻؼsince	since" },
	{ "+ETHAN",	 "ֻؼthan	than" },
	{ "+ETHROUGH",	 "ֻؼthrough	through" },
	{ "+ETILL",	 "ֻؼtill	till" },
	{ "+ETO",	 "ֻؼto	to" },
	{ "+ETOWARD",	 "ֻؼtoward	toward" },
	{ "+EUNDER",	 "ֻؼunder	under" },
	{ "+EUNTIL",	 "ֻؼuntil	until" },
	{ "+EUP",	 "ֻؼup	up" },
	{ "+EUPON",	 "ֻؼupon	upon" },
	{ "+EWHILE",	 "ֻؼwhile	while" },
	{ "+EWITH",	 "ֻؼwith	with" },
	{ "+EWITHIN",	 "ֻؼwithin	within" },
	{ "+EWITHOUT",	 "ֻؼwithout	without" },
	{ "+EAS-TO",	 "ֻؼas to	as to" },
	{ "+EDOWN-TO",	 "ֻؼdown to	down to" },
	{ "+EIN-FRONT-OF",	 "ֻؼin front of	in front of" },
	{ "+EOUT-OF",	 "ֻؼout of	out of" },
	{ "+EUP-TO",	 "ֻؼup to	up to" },
        { NULL,  NULL }} ;



