/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  J_lcon[]= {
	{ "*",	 "*	*" },
	{ "JLN1",	 "̾	Common nouns" },
	{ "JLN2",	 "ͭ̾	Proper nouns" },
	{ "JLN3",	 "̾	Verbal nouns (`Suru'-verb stem) " },
	{ "JLN4",	 "̾	Pronouns " },
	{ "JLN5",	 "̾	Formal nouns" },
	{ "JLN6",	 "	Numerals" },
	{ "JLN7",	 "	Temporal nouns" },
	{ "JLN8",	 "	Symbols" },
	{ "JLV1",	 "ư	Verbs" },
	{ "JLA1",	 "ƻ	Adjectives (`I'-adjectives)" },
	{ "JLM1",	 "ư	Adjectival nouns (`Na'-adjectives)" },
	{ "JLD2",	 "	Adverbs" },
	{ "JLR1",	 "Ϣλ	Adnouns" },
	{ "JLC1",	 "ʸиǽ³	Conjunctions  that can appear in the middle of a sentence" },
	{ "JLC3",	 "ʸƬ³	Conjunctions that can appear at the head of a sentence " },
	{ "JLT1",	 "ư	Exclamations " },
	{ "JSF1",	 "̾	Nominal suffixes" },
	{ "JLJ6",	 "̾	Verbal noun suffixes" },
	{ "JSF4",	 "ͭ̾	Proper noun suffixes" },
	{ "JSF5",	 ";̾	Personal noun suffixes" },
	{ "JSF7",	 "ñֽ̡	Units and counter  suffixes" },
	{ "JSF8",	 "	Temporal noun suffixes" },
	{ "JSF9",	 "ñ	Units" },
	{ "JSFA",	 "ֽ졦ӣƬ	Counter suffixes and SI-prefixes " },
	{ "JLS1",	 "	Commas" },
	{ "JLS2",	 "	Periods" },
	{ "JLJ1",	 "θܽ	Particles 1" },
	{ "JLJ2",	 "ưϢѷܽ	Particles 2" },
	{ "JLJ3",	 "ưϢѷءظܽ	Particles 3" },
	{ "JLJ4",	 "ư콪߷ܽ	Particles 4 " },
	{ "JLJ5",	 "θư̿ܽ	Particles 5 " },
	{ "JLJ7",	 "̾졦ưϢ߷ܽ	Particles 7 " },
	{ "JLJ8",	 "̾졦ư콪߷ܽ	Particles 8 " },
	{ "JLJ9",	 "ƻϢѷưϢѷǸܽ	Particles 9" },
	{ "JLJA",	 "ƻϢѷưϢѷ˸ܽ	Particles A" },
	{ "JLJB",	 "ưϢѷ¥ءƻϢѷܽ	Particles B" },
	{ "JLWA",	 "ư줿	Particles W" },
	{ "JLJD",	 "Ѹ߷ܽ	Particles D" },
	{ "JLJE",	 "ưϢηƻϢηưϢηʸܽ	Particles E" },
	{ "JLJF",	 "Ѹܽ	Particles F" },
	{ "JLJG",	 "ѸܡΩԲĽ	Particles G" },
	{ "JLJH",	 "θưϢѷƻ콪߷ư촴ܽ	Particles H" },
	{ "JLJI",	 "θ	Particles I" },
	{ "JLJJ",	 "θư콪Ϣηƻ콪ϢηưϢηܽ	Particles J " },
	{ "JLJK",	 "θư콪Ϣηƻ콪Ϣηư촴ܽ	Particles K" },
	{ "JLJL",	 "̾졦ʸܽ	Particles L" },
	{ "JLJM",	 "ʸνꡦʸڤܸܽ	Particles M" },
	{ "JLJN",	 "ʽܽ	Particles N" },
	{ "JSD1",	 "ܽ	Particle  that follows adverbs" },
	{ "JSD2",	 "ܽ	Particle that follows adverbs " },
	{ "JSD4",	 "ܽ	Particle  that follows adverbs" },
	{ "JLW1",	 "̤̤ư촴ܽư	Aux. verb" },
	{ "JLW2",	 "̤̤ư촴ܽư	Aux. verb" },
	{ "JLW3",	 "̤̤̤̤ܽư	Aux.verb" },
	{ "JLW4",	 "ư̤ƻϢѷưϢѷܽư	Aux. verbʤ" },
	{ "JLW5",	 "ư췿̤ܽư	Aux. verb " },
	{ "JLW6",	 "̤ܽư	Aux. verb" },
	{ "JLW7",	 "ʰʳ̤ܽư	Aux. verb 褦" },
	{ "JLW8",	 "ư콪߷ưޤ߷̤ϢηʳϢηܽư	Aux. verb ޤ" },
	{ "JLW9",	 "ư췿Ϣѷܽư	Aux. verb ޤ" },
	{ "JLWA",	 "ư줿	Aux. verb  " },
	{ "JLWB",	 "ư(λ)	Aux. verb  marking perfect tense" },
	{ "JLWC",	 "ֽư줽	Aux. verb  to convey manner" },
	{ "JLWD",	 "ư줿	Aux. verb " },
	{ "JLWE",	 "ʹư줽	Aux. verb  for reported speech " },
	{ "JLWF",	 "ư餷	Aux. verb 餷" },
	{ "JLWG",	 "ư()	Aux. verb  marking the speaker's conclusion" },
	{ "JLWH",	 "ư()	Aux. verb " },
	{ "JLWI",	 "ưǤ	Aux. verb Ǥ" },
	{ "JLWJ",	 "ưǤ礦	Aux. verb Ǥ礦" },
	{ "JLWK",	 "ư褦	Aux. verb 褦" },
	{ "JSVK",	 "ԸʳѸ	K-consonant `go-dan' conjugation endings" },
	{ "JSVG",	 "ԸʳѸ	G-consonant `go-dan' conjugation endings" },
	{ "JSVS",	 "ԸʳѸ	S-consonant `go-dan' conjugation endings " },
	{ "JSVT",	 "ԸʳѸ	T-consonant `go-dan' conjugation endings" },
	{ "JSVN",	 "ʹԸʳѸ	N-consonant `go-dan' conjugation endings" },
	{ "JSVB",	 "йԸʳѸ	B-consonant `go-dan' conjugation endings" },
	{ "JSVM",	 "޹ԸʳѸ	M-consonant `go-dan' conjugation endings" },
	{ "JSVR",	 "ԸʳѸ	R-consonant `go-dan' conjugation endings" },
	{ "JSVW",	 "ԸʳѸ	W-consonant `go-dan'  conjugation endings" },
	{ "JSV1",	 "ưѸ	`Ichi-dan' conjugation endings" },
	{ "JSV2",	 "ѳʳѸ	S-consonant irregular conjugation endings" },
	{ "JSV3",	 "ѳʳѸ	Z-consonant  irregular conjugation endings" },
	{ "JSV4",	 "ѳʳѸ	K-consonant  irregular conjugation endings " },
	{ "JSV5",	 "Ѹ	`Iku' conjugation endings" },
	{ "JSV6",	 "Ѹ	`Aru' conjugation  endings " },
	{ "JSV7",	 "åѸ	`Ossharu' conjugation endings" },
	{ "JSA0",	 "ƻ촴ܸ	Words that follow adjective stems" },
	{ "JSA1",	 "ƻѸ	Adjective  conjugation endings 1 " },
	{ "JSA2",	 "ʽ߷ƻ촴ܸ	Adjective  conjugation endings 2 " },
	{ "JSA3",	 "ưʥѸ	Aux.verb ʤ conjugation endings" },
	{ "JSM0",	 "ư촴ܸ	Words that follow  adjectival noun stems" },
	{ "JSM1",	 "ѷưѸ	Adjectival noun  d-consonant conjugation endings" },
	{ "JSM2",	 "ѷưѸϢѡ֤ˡפʤ	Adjectival noun d-consonant  conjugation endings 2" },
	{ "JSM3",	 "ѷưѸϢΡ֤Ρפ	Adjectival noun d-consonant conjugation endings 3" },
	{ "JSM4",	 "ѷưѸϢѡ֤ˡפʤϢΡ֤Ρפ	Adjectival noun d-consonant conjugation endings 4" },
	{ "JSMA",	 "ѷưѸϢΡ֤ΡפꡦϢΡ֤ʡפʤ	Adjectival noun d-consonant conjugation endings A" },
	{ "JSM5",	 "ľϢνǽѷưѸϢΡ֤ʡפʤ	Adjectival noun d-consonant conjugation endings 5" },
	{ "JSM7",	 "ȳѷưѸ	Adjectival noun `taruto' conjugation endings 7" },
	{ "JSM8",	 "ȳѷưѸϢΡ֤Ρפʤ	Adjectival noun `taruto' conjugation endings 8" },
        { NULL,  NULL }} ;


