/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  J_rcon[]= {
	{ "*",	 "*	*" },
	{ "JRN1",	 "̾	Common nouns" },
	{ "JRN2",	 "ͭ̾	Proper nouns" },
	{ "JRN3",	 ";̾	Personal nouns" },
	{ "JRN4",	 "̾	Verbal nouns" },
	{ "JRN5",	 ";̾	Personal pronouns" },
	{ "JRN6",	 "ؼ̾	Demonstrative pronouns" },
	{ "JRN7",	 "̾	Formal nouns" },
	{ "JRN8",	 "	Numerals" },
	{ "JRN9",	 "	Temporal nouns" },
	{ "JRNA",	 "	Symbols" },
	{ "JRNB",	 "ñֽ̡	Units" },
	{ "JRND",	 "	Base ten unit place figures in the decimal system" },
	{ "JRNE",	 "ֽ	Counter suffixes" },
	{ "JRNF",	 "ӣƬ	SI-prefixes" },
	{ "JRVK",	 "Ըư촴	K-consonant `go-dan' conjugation verb stems" },
	{ "JRVG",	 "Ըư촴	G-consonant `go-dan' conjugation verb stems" },
	{ "JRVS",	 "Ըư촴	S-consonant `go-dan' conjugation verb stem" },
	{ "JRVT",	 "Ըư촴	T-consonant `go-dan' conjugation verb stems" },
	{ "JRVN",	 "ʹԸư촴	N-consonant `go-dan' conjugation verb stems" },
	{ "JRVB",	 "йԸư촴	B-consonant `go-dan' conjugation verb stems" },
	{ "JRVM",	 "޹Ըư촴	M-consonant `go-dan' conjugation verb stems" },
	{ "JRVR",	 "Ըư촴	R-consonant `go-dan' conjugation verb stems" },
	{ "JRVW",	 "Ըư촴	W-consonant `go-dan' conjugation verb stems" },
	{ "JRV1",	 "ư촴	`Ichi-dan' conjugation verb stems " },
	{ "JRV2",	 "ư촴	S-consonant irregular conjugation verb stems" },
	{ "JRV3",	 "ư촴	Z-consonant irregular conjugation verb stems" },
	{ "JRV4",	 "ư촴	K-consonant irregular conjugation verb stems" },
	{ "JRV5",	 "Ѹ촴	`Iku' conjugation verb stems" },
	{ "JRV6",	 "Ѹ촴	`Aru' conjugation verb stems" },
	{ "JRV7",	 "åѸ촴	`Ossharu ' conjugation verb stems" },
	{ "JRA1",	 "ƻ촴	Adjective stems" },
	{ "JRA2",	 "촴ʤǽƻ촴	Adjective stems endingin the `i'-vowel" },
	{ "JRA3",	 "ưʥ촴	Stems of the Aux. verbʤ" },
	{ "JRM1",	 "ѷư촴	D-consonant conjugation adjectival noun stems 1" },
	{ "JRM2",	 "ѷư촴Ϣѡ֤ˡפʤ	D-consonant conjugation adjectival noun stems 2 " },
	{ "JRM3",	 "ѷư촴ϢΡ֤Ρפ	D-consonant conjugation  adjectival noun stems 3" },
	{ "JRM4",	 "ѷư촴Ϣѡ֤ˡפʤϢΡ֤Ρפ	D-consonant conjugation  adjectival noun stems 4" },
	{ "JRMA",	 "ѷư촴ϢΡ֤ΡפꡦϢΡ֤ʡפʤ	D-consonant conjugation  adjectival noun stems A" },
	{ "JRM5",	 "ľϢνǽѷư촴ϢΡ֤ʡפʤ	D-consonant conjugation  adjectival noun stems 5" },
	{ "JRM9",	 "ľϢνǽѷư촴θܡ֤ʡײǽ	D-consonant conjugation adjectival noun stems 9" },
	{ "JRM7",	 "ȳ	`Taruto' conjugation adjectival noun stems" },
	{ "JRM8",	 "ȳѷư촴ϢΡ֤Ρפʤ	`Taruto' conjugation adjectival noun stems 8 ending in " },
	{ "JRD2",	 "Բ	Adverbs that do not precede any particles" },
	{ "JRD3",	 "ȸ	Adverbs that can precede the particle " },
	{ "JRD4",	 "˸	Adverbs that can precede the particle " },
	{ "JRD5",	 "ȡ˸	Adverbs that can precede the particle  or " },
	{ "JRD6",	 "θ	Adverbs that can precede the particle " },
	{ "JRD7",	 "Ρȸ	Adverbs that can precede the particle  or " },
	{ "JRD8",	 "Ρ	Adverbs that can precede the particle  or " },
	{ "JRD9",	 "Ρȡ˸	Adverbs that can precede the particle , , or " },
	{ "JRDA",	 "ư	Adverbs that can precede the auxiliary verb  " },
	{ "JRDB",	 "ưȸ	Adverbs that can precede the auxiliary verb  or the particle  " },
	{ "JRDC",	 "ư˸	Adverbs that can precede the auxiliary verb  or the particle " },
	{ "JRDD",	 "ưȡ˸	Adverbs that can precede the auxiliary verb  or the particle  or  " },
	{ "JRDE",	 "ưθ	Adverbs that can precede the auxiliary verb  or the particle " },
	{ "JRDF",	 "ưΡȸ	Adverbs that can precede the auxiliary verb  or the particle  or " },
	{ "JRDG",	 "ưΡ˸	Adverbs that can precede the auxiliary verb  or the particle  or " },
	{ "JRDH",	 "ưΡȡ˸	Adverbs that can precede the auxiliary verb  or the particle , , or   " },
	{ "JRR1",	 "Ϣλ	Adnouns" },
	{ "JRC1",	 "³	Conjunctions 1" },
	{ "JRC2",	 "ܤˤ³	Conjunctions 2" },
	{ "JRT1",	 "ư	Exclamations" },
	{ "JRP1",	 "θƬ	Prefixes preceding nominals" },
	{ "JRP2",	 "ưƬ	Prefixes preceding verbs" },
	{ "JRP3",	 "ֽ	Counter prefixes" },
	{ "JRP4",	 "ƻ졦ưƬ	Prefixes preceding both adjectives and adjectival nouns" },
	{ "JRP5",	 "ƻƬ	Prefixes preceding adjectives" },
	{ "JRP6",	 "ưƬ	Prefixes preceding ajectival nouns" },
	{ "JRP7",	 "̾Ƭ	Prefixes preceding verbal nouns" },
	{ "JRS1",	 "	Commas" },
	{ "JRS2",	 "	Periods" },
	{ "JRJ1",	 "Բĳʽ	Particles 1 (case marker)" },
	{ "JRJ2",	 "ܳʽ	Particles 2 (case marker)" },
	{ "JRJ3",	 "ʽ	Particles 3 (case marker)  " },
	{ "JRJ4",	 "ν	Particles 4 (nominalizer)" },
	{ "JRJ5",	 "Ω	Particles 5 (coordinator)" },
	{ "JRJ6",	 "³	Particles 6 (conjunction)" },
	{ "JRJ7",	 "	Particles 7 (indicatestheme)" },
	{ "JRJ8",	 "	Particles 8 (adverbial)" },
	{ "JRJ9",	 "	Particles 9 (ends a sentence)" },
	{ "JRJA",	 "	Particles A (interjection) " },
	{ "JEM1",	 "̤̤	Subjunctive form  of s-consonant irregular conjugation verbs and  of z-consonant irregular conjugation verbs" },
	{ "JEM2",	 "̤	Subjunctive form  of s-consonant irregular conjugation verbs" },
	{ "JEM3",	 "̤	Subjunctive form  of s-consonant irregular conjugation verbs" },
	{ "JEM4",	 "̤	Subjunctive form of k-consonant irregular conjugation verbs" },
	{ "JEM5",	 "̤	Subjunctive form of `go-dan' conjugation verbs" },
	{ "JEM6",	 "̤	Subjunctive form preceding " },
	{ "JEM7",	 "̤	`Aru' conjugation subjunctive form " },
	{ "JEM8",	 "̤	Subjunctive form  of z-consonant irregular conjugation verbs" },
	{ "JED1",	 "ѡѡϢѷ	Infinitive form of s-, z-, and k-consonant irregular conjugation verbs" },
	{ "JED2",	 "Ϣѷ	Infinitive form of `go-dan' conjugation  verbs" },
	{ "JED3",	 "ƤܤưϢѲط	Euphonic infinitive form of `go-dan' conjugation verbs preceding the particle " },
	{ "JED4",	 "ǤܤưϢѲط	Euphonic infinitive form of `go-dan' conjugation verbs preceding the particle " },
	{ "JED5",	 "ƻϢѷ	Infinitive form  of adjectives" },
	{ "JED6",	 "ưϢѷ	Infinitive form  of adjectival nouns" },
	{ "JED7",	 "ƻ졦ưϢѷ	Infinitive form of adjectives and adjectival nouns" },
	{ "JED8",	 "ưϢѷ	Infinitive form  of adjectival nouns" },
	{ "JED9",	 "üϢѷ	Infinitive form of the irregular conjugation auxiliary verb " },
	{ "JEDA",	 "ưʥüϢѲط	Euphonic infinitive form of the irregular  conjugation  auxiliary verb ʤ" },
	{ "JEE1",	 "ư콪Ϣη	Predicative and adnominal forms of verbs" },
	{ "JEE2",	 "ƻ콪ߡϢηư콪ߡϢη	Predicative and adnominal forms of adjectives, and the auxiliary verbs  and " },
	{ "JEE3",	 "ư콪߷	Predicative form of adjectival nouns" },
	{ "JEE4",	 "ü콪(Ϣη)褦ޤ	Predicative (and adnominal) form of the irregular conjugation auxiliary verbs,, 褦, and ޤ" },
	{ "JEE5",	 "ü콪(Ϣη)Ǥ	Predicative (and adnominal) form the irregular conjugation auxiliary verb, Ǥ" },
	{ "JEE6",	 "ü콪ߡϢηޤ	Predicative and adnominal forms of the irregular conjugation auxiliary verb,ޤ" },
	{ "JEA1",	 "ưϢη	Adnominal form  of  adjectival nouns" },
	{ "JEA2",	 "ưϢη(Τ)	Adnominal form  (Τ) of adjectival nouns " },
	{ "JEC1",	 "	Conditional form" },
	{ "JEC2",	 "Ω	Independent conditional form" },
	{ "JEI1",	 "̿	Imperative form" },
	{ "JEI2",	 "֤פǽ̿	Imperative form ending in " },
        { NULL,  NULL }} ;


