#include <stdio.h>
#include <fcntl.h>

#include "fconst.h"
#include "ftemp.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/

/* */
int SetProperty( char flag, char *etc, int size, char *property, char *val) ;




/**********************************************************
*   ˿쥳ä롣
*   USAGE:	        UpdSubInfo( char *etc , char *upd, int size)
*   SYNOPSIS:           char   *etc  (IN) оݤ
*                       char   *upd (IN) ɲ
*                       int     size (IN) оݤΥ
*
*   DESCRIPTION:	
*	ФơĤο°ͤ򹹿롣
*
*   RETURN:		ｪλ: Υ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  UpdSubInfo( char *etc , char *upd, int size)     /* 쥳 */
{
  char *cpt[512], *npt ;
  int  ci, ni, semiflag, len ;
  char *cp, *wp ;

  //printf("UpdSubInfo:etc=[%s]\n",etc) ;
  //printf("UpdSubInfo:upd=[%s]\n",upd) ;
  //printf("UpdSubInfo:size=[%d]\n",size) ;
  len = strlen(etc) + strlen(upd) ;
  if ( (len + 2) >= size ) {
    fprintf( stderr,"ERROR(UpdSubInfo):Output buffer is too small!\n") ;
    return -1 ;
  }
  /* оݤγƬݥ󥿤 */
  cp = upd ;
  for ( ci = 0 ; ci < 512 && *cp != '\0' ; ) { /* °Ƭ */
    cpt[ci++] = skip_non_sp( cp )  ;
    cp = skip_ptr( ';', cp ) ;
    if ( cp == NULL )
      break ;
    cp++ ;
  }
  if ( ci == 512 ) {
    fprintf( stderr,"ERROR(UpdSubInfo):Work buffer is too small!\n") ;
    return -1 ;
  }
  npt = cp = etc ;
  ni = 0 ;
  semiflag = 0 ;
  while ( ni < 512 && *cp != '\0' ) {

    npt = skip_non_sp( cp )  ;
    if ( npt == NULL ) {
      npt = cp ;
      break ;
    }
    if ( CompETCField( npt, cpt, ci ) >= 0 ){
      cp = skip_ptr( ';', cp ) ;
      if ( cp == NULL ) 
        break ;
      cp++ ;
      wp = npt ;
      while( *cp != '\0' ) {
        *wp = *cp ; wp++; cp++ ;
      }
      *wp = '\0' ;
      cp = npt ;
      continue ;
    }
    ni++ ;
    cp = skip_ptr( ';', cp ) ;
    if ( cp == NULL ) {
      npt += strlen( npt ) ;
      semiflag = 1 ; /* Ǹ˥ߥ̵ǽλ */
      break ;
    }
    cp++ ;      
  }
  if ( upd != NULL && semiflag != 0 ) {
    *npt = ';' ;
    npt++ ;
  }
  for( cp = upd ; *cp != '\0' ; cp++ ) {
    *npt = *cp ; npt++ ;
  }
  *npt = '\0' ;
  //printf("ret:etc=[%s]\n",etc) ;
  return( npt - etc ) ;
}



int CompETCField( char *npt, char **cpt, int ci )
{
  int ii ;
  char *cp1, *cp2 ;

  for ( ii = 0 ; ii < ci ; ii++ ) {
    // cp1 = npt ;
    // cp2 = *(cpt + ii ) ;
    if ( CompProperty( npt, *(cpt +ii ) ) > 0 ) {
      return ii ;
    }
  }
  return ( -1 ) ;
}




/**********************************************************
*   γ°ΰ֤롣
*   USAGE:	        ScanETCFields( char *property , char *etc)
*   SYNOPSIS:           char   *property (IN) ᤿°̾
*                       char   *etc      (IN) 
*
*   DESCRIPTION:	
*	򥹥󤷤ơꤵ줿°̾γǼ֤
*     롣
*
*   RETURN:		°Ǽɥ쥹
*                       °¸ߤʤϡκǽɥ쥹
*                       '\0'ΰ֡ˤ֤
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
char  *ScanETCFields( char *property , char *etc)
{
  char *cp, *wp ;

  if ( etc == NULL )
    return NULL ;

  while ( *etc != '\0' ) {
    cp = skip_non_sp( etc )  ;
    //printf("property=[%s]:[%s]\n",property, cp ) ;
    if ( CompProperty( property, cp ) > 0 ) {
      return cp ;
    }
    etc = skip_ptr( ';', cp ) ;
    if ( etc == NULL ) {
      while( *cp != '\0' )
        cp++ ;
      return cp ;
    }
    etc++ ;
  }
  return etc ; 
}





/**********************************************************
*   °̾γǧ
*   USAGE:	        CompProperty( char *key, char *plp )
*   SYNOPSIS:           char   *key  (IN) °̾
*                       char   *plp  (IN) °̾=°
*
*   DESCRIPTION:	
*	ꤵ줿°̾󤫤ɤå°̾
*     ϣ֤㤦ϣ֤
*
*   RETURN:		°̾λ
*                       㤦°γǼ֤ξ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  CompProperty( char *key, char *plp )
{
  while( *key != '\0' && *key != '=' && *key != ';' && *key != ' ') {
    if ( *plp == '\0' || *plp == '=' || *plp == ';' || *plp == ' ' )
      return 0 ;
    if ( *key != *plp )
      return 0 ;
    key++ ; plp++ ;
  }
  //printf("key=[%s], plp=[%s]\n",key,plp) ;
  if ( ( *key == '\0' || *key == '=' || *key == ';' || *key == ' ') &&
       ( *plp == '\0' || *plp == '=' || *plp == ';' || *plp == ' ') ) {
    return 1 ;
  }
  return 0 ;
}



/**********************************************************
*   ˡץѥƥField="value"ˤɲä롣
*   USAGE:	        AddPropertyETCRecord( char *etc, int bsz,  char *property, char *val )
*   SYNOPSIS:           char   *etc  (IN) ǼꥢƬɥ쥹
*                       int     bsz  (IN) ǼꥢΥ
*                       char   *property  (IN)  °̾
*                       char   *val  (IN) °
*
*   DESCRIPTION:	
*	°̾=°ͤɲä롣
*
*   RETURN:		Ǽ󥵥
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  AddPropertyETCRecord( char *etc, int bsz,  char *property, char *val ) 
{
  char *cp, *cp1, *st ;
  int  sz  ;
  char work[4096] ;
  char *mcp , flag ;

  //printf("(AddPropertyETCRecord):etc=[%s] prop=[%s]:val[%s]\n",etc,property,val) ;

  st = skip_non_sp( etc )  ;
  if ( st == NULL ) {  /* ޤ϶ */
    sz = SetProperty( ' ', etc, bsz, property, val ) ;
    return sz ;
  }
  else {
    cp = ScanETCFields(property, st) ;
    if ( *cp != '\0' ) {
      cp1 = skip_ptr( ';', cp ) ;
      //printf("cp=[%s]\n",cp) ;
      //printf("cp1=[%s]\n",cp1) ;
      if ( cp1 != NULL ) {
        cp1++ ;
        while( *cp1 != '\0' ) {
          *cp = *cp1 ; cp++, cp1++ ;
        }
        *cp = '\0' ;
        flag = ';' ;
      }
      else {
        flag = ' ' ;
      }
      bsz -= ( cp - etc ) ;
      sz = SetProperty( flag, cp, bsz, property, val ) ;
      //printf("(AddPropertyETCRecord)ret:flag=[%c]  etc=[%s]\n",flag,etc) ;
      return sz ;
    }
    if ( cp == st )    /*  ; Τߤ */
      flag = ' ' ;
    else 
      flag = ';' ;
    bsz -= ( cp - etc ) ;
    sz = SetProperty( flag, cp, bsz, property, val ) ;
    return sz ;
  }
}




/**********************************************************
*   󤫤顢ץѥƥField="value"ˤ롣
*   USAGE:	        CutPropertyETCRecord( char *etc, char *property )
*   SYNOPSIS:           char   *etc  (IN) ǼꥢƬɥ쥹
*                       char   *property  (IN)  °̾
*
*   DESCRIPTION:	
*	ꤵ줿°̾󤫤롣
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void  CutPropertyETCRecord( char *etc, char *property ) 
{
  char *cp, *cp1, *st ;
  char *mcp , flag ;

  //printf("(CutPropertyETCRecord):etc=[%s] prop=[%s]\n",etc,property) ;

  st = skip_non_sp( etc )  ;
  if ( st == NULL ) {  /* ޤ϶ */
    *etc = '\0' ;
    return ;
  }

  cp = ScanETCFields(property, st) ;
  if ( cp != NULL && *cp != '\0' ) {
    cp1 = skip_ptr( ';', cp ) ;
    if ( cp1 == NULL ) {
      for(  ; cp != st ; cp--) {
        if ( *cp == ';' )
          break;
      }
      *cp = '\0' ;
      return ;
    } 
    cp1++ ;
    while( *cp1 != '\0' ) {
      *cp = *cp1 ; cp++, cp1++ ;
    }
    *cp = '\0' ;
    return ;
  }
  return  ;

}



/****************************************************************
*   üʸޤʸ " "ǰϤࡣ
*   USAGE:		CommStrCapsule(  char *out, char *str, int osize )
*   SYNOPSIS:           char  *out (OUT)  åդʸ
*  	 	        char  *str (IN)   оʸ
*                       int   osize(IN)   ϰ礭
*                       
*   DESCRIPTION:	
*	Ϳ줿ʸüʸޤ硢" "ǰϤࡣ
*
*   RETURN:		" "ޤΤʸĹ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int CommStrCapsule(char *out, char *str, int osize )
{
  int len , ii;
  char *st = out ;

  len = strlen(str) ;
  if (*str == '"' && *(str+len-1) == '"') {
    if (( len + 1) >= osize ) {
      fprintf( stderr,"ERROR(CommStrCapsule):Output buffer is too small!\n") ;
      *out = '\0' ;
      return 0 ;
    }
    strcpy(out,str) ;
    return len ;
  }
  if ( CommChkStr( str ) == 0 ) {
    if (( len + 1) >= osize ) {
      fprintf( stderr,"ERROR(CommStrCapsule):Output buffer is too small!\n") ;
      *out = '\0' ;
      return 0 ;
    }
    strcpy(out,str) ;
    return len ;
  }
  *out = '"' ;
  ii = 0 ;
  for ( out++ ; *str != '\0' ; str++) {
    if ( (ii + 4) >= osize) {
      fprintf( stderr,"ERROR(CommStrCapsule):Output buffer is too small!\n") ;
      *st = '\0' ;
      return 0 ;
    }
    if ( *str == '\\' ) {
      *out = '\\' ; out++ ;
      *out = '\\' ; out++ ;
      ii += 2 ;
      continue ;
    }
    if ( *str == '"' ) {
      *out = '\\' ; out++ ;
      *out = '"' ; out++ ;
      ii += 2 ;
      continue ;
    }
    *out = *str ; out++ ;
    ii++ ;
  }
  *out = '"' ; out++ ;
  *out = '\0' ;
  return( out - st ) ;
}


/* üʸ return (-1) ;   */
int CommChkStr( char *str )
{
  unsigned short xx ;
  while( *str != '\0' ) {
    if ( (*str & 0x80 ) == 0 ) {
      if( ( *str >= '0' && *str <= '9' ) ||
          ( *str >= 'a' && *str <= 'z' ) ||
          ( *str >= 'A' && *str <= 'Z' ) ) {
        str++ ;
        continue ;
      }
      return ( -1 ) ;
    }
    xx = get2byte( str ) ;
    if ( xx >= 0xa1a1 /*''*/ ) {
      if ( xx == 0xa1bc /*''*/ ||
           xx == 0xa1a6 /*''*/ ||
           xx == 0xa1b9 /*''*/ ) {
        str += 2 ;
	continue ;
      }
      if ( xx < 0xa3b0 /*''*/ || 
           (xx >= 0xa6a1 /*''*/  && xx <= 0xa7f1 /*''*/ ) ) {
	return( -1 ) ;
      }
      str += 2 ;
      continue ;
    }
    return ( -1 ) ;
  }
  return( 0 ) ;
}





int SetProperty( char flag, char *etc, int size, char *property, char *val)
{
  char *start = etc ;
  int  len, sz ;

  len = strlen( property ) ;
  if ( (len + 2) >= size ) {
    fprintf( stderr, "ERROR(SetProperty):Property buffer is too small!\n" );
    return 0 ;
  }
  if ( flag == ';' ) {
    *etc = ';' ;
    etc++ ;
  }
  strcpy( etc, property) ;
  etc += len ;
  *etc = '=' ;
  etc++ ;
  size -= ( etc - start )  ;
  sz = CommStrCapsule( etc, val, size ) ;
  return ( sz ) ;
}







/**********************************************************
*   ηå롣
*   USAGE:	        ChkSubInfo( char *etc )
*   SYNOPSIS:           char   *etc  (IN) 
*
*   DESCRIPTION:	
*	ηå롣
*
*   RETURN:		ｪλ: Υ
*                       ˰۾郎ߤ줿: -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  ChkSubInfo( unsigned char *etc )     /* 쥳 */
{
  unsigned char *cp, *sp ;
  int flag ;

  if ( etc == NULL)
    return 0 ;
  cp = etc ;
  while ( *cp != '\0' ) {
    /* Field_Name */
    //printf("cp=>[%s]\n",cp) ;
    while( cp != NULL ) {
       if ( (cp = skip_non_sp( cp )) == NULL )
          break ;  ;
       if ( *cp != ';' )
         break ;
       cp++ ;
    }
    if ( cp == NULL ) {
      break ;
    }
    sp = cp ;
    while( *cp > ' ' && *cp != '=') {
      cp++ ; 
    }
    if ( cp == sp ) {
      fprintf( stderr,"ERROR(ChkSubInfo):η顼1[%s]\n",sp) ;
      return -1 ;
    }

    /* = */
    cp = skip_non_sp( cp )  ;
    if ( *cp != '=' ) {
      fprintf( stderr,"ERROR(ChkSubInfo):η顼2[%s]\n",sp) ;
      return -1 ;
    }
    cp++ ;
    
    /* Value */
    cp = skip_non_sp( cp )  ;
    if ( cp == NULL ) {
      fprintf( stderr,"ERROR(ChkSubInfo):η顼3[%s]\n",sp) ;
      return -1 ;
    }
    if ( *cp == '"' ) {
      flag = 1 ;
      cp++ ;
    }
    else 
      flag = 0 ;
    for( ; *cp != '\0' && *cp != ';' ; cp++ ) {
      if ( flag == 0 ) {
        if ( *cp <= ' ' )
          break ;
        if ( *cp == '=') {
          fprintf( stderr,"ERROR(ChkSubInfo):η顼4[%s]\n",sp) ;
          return -1 ;
        }
        continue ;
      }
      if ( *cp == '\\' ) {
        cp++ ;
        continue ;
      }
      if ( *cp == '"' ) {
        flag = 0 ;
        if (*(cp+1) > ' ' && *(cp+1) != ';' ) {
          fprintf( stderr,"ERROR(ChkSubInfo):η顼5[%s]\n",sp) ;
          return -1 ;
        }
      }
    }
    if ( flag != 0 ) {
      fprintf( stderr,"ERROR(ChkSubInfo):η顼6[%s]\n",sp) ;
      return -1 ;
    }
    for( ; *cp != '\0' && *cp != ';' ; cp++ )  {
      if ( *cp > ' ' ) {
        fprintf( stderr,"ERROR(ChkSubInfo):η顼7[%s]\n",sp) ;
        return -1 ;
      }
    }
    if ( *cp == '\0' )
      break ;
    if ( *cp == ';') 
      cp++ ;
  }
  return( cp - etc ) ;
}


