#include <stdio.h>
#include <fcntl.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/


/****************************************************************
*   ꤵ줿ʸʸʬ䤹롣
*   USAGE:		split1( char sep, char *str, char **ary)
*   SYNOPSIS:		char  sep     ڤʸ
*                       char  *str    оʸ
*                       char  **ary   ڤ줿ʸƬݥ
*   DESCRIPTION:	
*	Ϳ줿ʸڤʸʬ䤷ʬ䤵줿ʸ
*       Ƭݥ󥿤֤
*       Ϥ줿оʸ϶ڤʸʬ'\0'֤롣
*       ڤʸ̥륹ȥ󥰡""ˤǧʤʻ separate1ˡ
*
*   RETURN:		ʬʸ
*
*   SEE ALSO:	        separate1
*   ERRORS:
****************************************************************/
int  split1( char sep, char *str, char **ary)
{
  int    i = 1 ;

  if ( sep == '\0' ) {
    return 0 ;
  }
  *ary = str ;
  ary++ ;
  while( *str != '\0' ) {
    if ( *str == sep ) {
        *str = '\0' ;
        str++ ;
        *ary = str ;
        ary++ ; i++ ;
        continue ;
    }
    str++ ;
  }
  return i ;
}




/****************************************************************
*   ꤵ줿ʸΣʸȤ˶ڤʸ롣
*   USAGE:		separate1( char sep, char *str, char *ansy, int size)
*   SYNOPSIS:		char  sep   (IN)   ڤʸ
*                       char  *str  (IN)   оʸ
*                       char  *ans  (OUT)  ڤ줿ʸγǼ
*                       int   size  (IN)   襨ꥢ(ans)ΥХȿ
*   DESCRIPTION:	
*	Ϳ줿ʸʸŤĶڤꡢ˶ڤʸ
*       롣
*
*   RETURN:		ｪλ:   ʸ󥵥
*                       ʾ彪λ:   -1
*
*   SEE ALSO:	        separate1
*   ERRORS:
****************************************************************/
int  separate1( char sep, char *str, char *ans, int sz)
{
  int    i = 0 ;

  while( *str != '\0' ) {
    if ( ( *str & 0x80 ) == 0 ) {
        if ( (i+2) >= sz ) {
            return( -1 ) ;
	}
        *ans = *str ; ans++ ; str++ ;
        *ans = sep  ; ans++ ;
        i += 2 ;
        continue ;
    }
    else {
        if ( (i+3) >= sz ) {
            return( -1 ) ;
	}
        *ans = *str ; ans++ ; str++ ;
        *ans = *str ; ans++ ; str++ ;
        *ans = sep  ; ans++ ;
        i += 3 ;
     }
  }
  if ( i != 0 ) {
    ans-- ; i-- ;
  }
  *ans = '\0' ;
  return i ;
}



/****************************************************************
*   ꤵ줿ʸ̤ʸؤ롣
*   USAGE:		rep1( char sep1, char *str, char sep2, char *ansy)
*   SYNOPSIS:		char  sep   (IN)   ڤʸ
*                       char  *str  (IN)   оʸ
*                       char  *ans  (IN)   ڤʸ
*                       int   size  (OUT)   ʶڤʸˤʸ
*   DESCRIPTION:	
*	Ϳ줿ʸʸŤĴ١ڤʸ򿷶ڤʸ
*       ѴΤ롣ǡϤΤޤޡ
*
*   RETURN:		ｪλ:   ʸ󥵥
*                       ʾ彪λ:   -1
*
*   SEE ALSO:	        separate1
*   ERRORS:
****************************************************************/
int  rep1( char sep1, char *str, char sep2, char *ans)
{
  int    i = 0 ;

  while( *str != '\0' ) {
    if ( ( *str & 0x80 ) == 0 ) {
        if ( *str == '\\' ) {
          *ans = *str ; ans++ ; str++ ;
          *ans = *str ; ans++ ; str++ ;
          i += 2 ;
          continue ;
        }
        if ( *str == sep1 ) {
          *ans = sep2 ; ans++ ; str++ ;
        } else {
          *ans = *str ; ans++ ; str++ ;
        }
        i++ ;
        continue ;
    }
    else {
        *ans = *str ; ans++ ; str++ ;
        *ans = *str ; ans++ ; str++ ;
     }
  }
  *ans = '\0' ;
  return i ;
}




/****************************************************************
*   ꤵ줿ʸ̤ʸؤ롣
*   USAGE:		repstr( char *sep1, char *str, char *sep2, char *ans)
*   SYNOPSIS:		char  sep   (IN)   ʸ
*                       char  *str  (IN)   оʸ
*                       char  *sep2 (IN)   ʸ
*                       char  *ans  (OUT)  Ѵ줿ʸ
*   DESCRIPTION:	
*	Ϳ줿ʸƬĴ١ʸʬʸ
*       ѴΤ롣ǡϤΤޤޡ
*
*   RETURN:		ｪλ:   ʸ󥵥
*                       ʾ彪λ:   -1
*
*   SEE ALSO:	        rep1
*   ERRORS:
****************************************************************/
int  repstr( char *sep1, char *str, char *sep2, char *ans)
{
  int    i = 0 ;
  int    l1, l2 ;

  l1 = strlen(sep1) ;
  l2 = strlen(sep2) ;

  while( *str != '\0' ) {
    if ( strncmp( str, sep1, l1) == 0 ) {
      strcpy( ans, sep2 ) ;
      i += l2 ;
      str += l1 ;
      ans += l2 ;
      continue ;
    }
    if ( (*str & 0x80 ) == 0 ) {
        if ( *str == '\\' ) {
          *ans = *str ; ans++ ; str++ ;
          *ans = *str ; ans++ ; str++ ;
          i += 2 ;
          continue ;
        }
        *ans = *str ; ans++ ; str++ ;
        i++ ;
        continue ;
    }
    else {
        *ans = *str ; ans++ ; str++ ;
        *ans = *str ; ans++ ; str++ ;
     }
  }
  *ans = '\0' ;
  return i ;
}



/****************************************************************
*   ꤵ줿ʸ֤˶ʸ롣
*   USAGE:		join1( char sep, char **ary, int ct, char *str)
*   SYNOPSIS:		char  sep    (IN)  ڤʸ
*                       char  **ary  (IN)  ³ʸƬݥ
*                       int   ct     (IN)  ³ʸο
*                       char  *str   (OUT) ³ʸ
*   DESCRIPTION:	
*	Ĥʸڤʸ򶴤³롣
*
*   RETURN:		non
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
void join1( char sep, char **ary, int ct, char *str)
{
  int    i ;
  char   *cp ;

  if ( ct == 0 ) {
      *str = '\0' ;
      return ;
  }
  for( i = 0 ; i < ct  ; i++) {
    for( cp = *ary ; *cp != '\0' ; cp++) {
      *str = *cp ;str++ ;
    }
    *str = sep ; str++ ; ary++ ;
  }
  str-- ;
  *str = '\0' ;
  return  ;
}



/****************************************************************
*   ʸκǸϿ롣
*   USAGE:		append1( char *str, char **ary, int ct)
*   SYNOPSIS:		char  *str   (IN)  Ͽʸ
*                       char  **ary  (IN)  ʸ
*                       int   ct     (IN)  ǿ
*   DESCRIPTION:	
*	ʸ˻ꤵ줿ʸϿ롣
*
*   RETURN:		ǿ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  append1( char *str, char **ary, int ct)
{
  *(ary + ct) = str ;
  return ( ct + 1 ) ;
}




/****************************************************************
*   ʸɲϿ롣
*   USAGE:		add_strary1( char *str, char **ary, int ct)
*   SYNOPSIS:		char  *str   (IN)  Ͽʸ
*                       char  **ary  (IN)  ʸ
*                       int   ct     (IN)  ǿ
*   DESCRIPTION:	
*	ʸ˻ꤵ줿ʸɲä롣
*
*   RETURN:		ǿ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  add_strary1( char *str, char **ary, int ct)
{
  int  ii ;

  for( ii = 0 ; ii < ct ; ii++ ) {
    if ( **(ary + ii) == *str && strcmp( *(ary+ii), str ) == 0 )
      return ct ;
  }
  *(ary + ct) = str ;
  return ( ct + 1 ) ;
}



/****************************************************************
*   ʣʸ򥽡Ȥ¤Ѥ롣
*   USAGE:		sort1( char **ary, int ct, char **ret)
*   SYNOPSIS:		char  **ary  (IN)  ȤʸƬݥ
*                       int   ct     (IN)  Ȥʸο
*                       char  **ret  (OUT) Ȥ
*   DESCRIPTION:	
*	Ϥ줿ʸ򥳡ɽ¤ѤΤ֤
*
*   RETURN:		non
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  sort1( char **ary, int ct, char **ret)
{
  int    i, j, st;
  char   *cp, *ss, *s1 ;
  char   *ptr[1024] ;

  if (ct > 1024) {
    fprintf(stderr,"SortWorkArea is too small!\n") ;
    //sortx( char **ary, int ct, char **ret)
    return ;
  }
  for( i = 0 ; i < ct  ; i++, ary++) {
    for( j = 0 ; j < i  ; j++) {
      st = strcmp( *ary,ptr[j] ) ;
      if ( st < 0 )
        break ;
    }
    ss = *ary ;
    for(  ; j < i  ; j++) {
      s1 = ptr[j] ;
      ptr[j] = ss ;
      ss = s1 ;
    }
    ptr[j] = ss ;
  }
  for( i = 0 ; i < ct  ; i++) {
    ret[i] = ptr[i] ;
  }
  return  ;
}






/****************************************************************
*   ʣʸˡȤ¤Ѥ롣
*   USAGE:		unq_sort1( char **ary, int ct, char **ret)
*   SYNOPSIS:		char  **ary  (IN)  ȤʸƬݥ
*                       int   ct     (IN)  Ȥʸο
*                       char  **ret  (OUT) Ȥ
*
*   DESCRIPTION:	
*	Ϥ줿ʸ򥳡ɽ¤ѤΤ֤
*       Ʊͤʣ¸ߤƤ⡢ĤΤ߳Ǽ롣
*
*   RETURN:		ˡʥХ塼
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int   unq_sort1( char **ary, int ct, char **ret)
{
  int    i, j, st, vc;
  char   *cp, *ss, *s1 ;
  char   *ptr[1024] ;

  if (ct > 1024) {
    fprintf(stderr,"SortWorkArea is too small!\n") ;
    //sortx( char **ary, int ct, char **ret)
    return 0 ;
  }
  vc = 0 ;
  for( i = 0 ; i < ct  ; i++, ary++) {
    for( j = 0 ; j < vc  ; j++) {
      st = strcmp( *ary,ptr[j] ) ;
      if ( st == 0 )
        break ;
      if ( st < 0 )
        break ;
    }
    if ( i != 0 && st == 0 ) {
      continue ;
    }
    ss = *ary ;
    for(  ; j < vc  ; j++) {
      s1 = ptr[j] ;
      ptr[j] = ss ;
      ss = s1 ;
    }
    ptr[j] = ss ;
    vc++ ;
  }
  for( i = 0 ; i < vc  ; i++) {
    ret[i] = ptr[i] ;
  }
  return vc ;
}







/****************************************************************
*   ХʥΥХȤ֤ͤϢ³ƤХ塼ꥹȤͤɲä롣
*   USAGE:		add_binn( char *val, int vsz, char *ary, int len)
*   SYNOPSIS:		char  *val   (IN)  ɲä
*                       int    vsz   (IN)  ɲäͤΥХȿ
*                       char  *ary   (IN)  ХʥΥХȥꥹȤƬݥ
*                       int   len    (IN)  ХʥΥХȥꥹȤĹ
*
*   DESCRIPTION:	
*	Ϥ줿ͤꥹ¸ߤʤ硢ͤǸ
*       ɲä롣
*
*   RETURN:		ɲä:
*                       ¸ߤ:
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  add_binn( char *val, int vsz, char *ary, int len) 
{
  int  ii ;
  char *vp ;
  int dlen = len ;

  while( dlen != 0 ) {  
    vp = val ;
    for( ii = 0 ; ii < vsz  ; ii++ ) {
      if ( *vp != *(ary + ii) )
        break ;
      vp++ ;
    }
    if ( ii == vsz ) {  /* ǡꡪ */
      return 1 ;
    }
    dlen -= vsz ;
    ary  += vsz ;
  }
  memcpy(ary, val, vsz ) ;
  return 2 ;
}



/****************************************************************
*   ХʥΥХȤ֤ͤϢ³ƤХ塼ꥹȤ飱Ĥͤ롣
*   USAGE:		rem_binn( char *val, int vsz, char *ary, int len)
*   SYNOPSIS:		char  *val   (IN)  
*                       int    vsz   (IN)  ͤΥХȿ
*                       char  *ary   (IN)  ХʥΥХȥꥹȤƬݥ
*                       int   len    (IN)  ХʥΥХȥꥹȤĹ
*
*   DESCRIPTION:	
*	Ϥ줿ͤꥹ¸ߤʤ硢Τޤ֤
*
*   RETURN:		:
*                       ͤ¸ߤʤä:
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  rem_binn( char *val, int vsz, char *ary, int len) 
{
  int  ii ;
  char *vp ;
  int  dlen = len ;

  while( dlen != 0 ) {  
    vp = val ;
    for( ii = 0 ; ii < vsz  ; ii++ ) {
      if ( *vp != *(ary + ii) )
        break ;
      vp++ ;
    }
    if ( ii == vsz ) {  /* ǡꡪ */
      dlen -= vsz ;
      vp = ary + vsz ;
      while( dlen != 0 ) {
        *ary = *vp ;
        ary++ ; vp++ ;
        dlen-- ;
      }
      return 1 ;
    }
    ary  += vsz ;
    dlen -= vsz ;
  }
  return 2 ;
}



/****************************************************************
*   ХʥꣴХȤοͤϢ³ƤꥹȤ˿ͤɲä롣
*   USAGE:		add_bin4( int  addv, char *ary, int len)
*   SYNOPSIS:		int   addv   (IN)  ɲä
*                       char  *ary   (IN)  ХʥꣴХȥꥹȤƬݥ
*                       int   len    (IN)  ХʥꣴХȥꥹȤĹ
*
*   DESCRIPTION:	
*	Ϥ줿ͤꥹ¸ߤʤ硢ͤǸ
*       ɲä롣
*       ؿϳͤɲäƤ⡢ʤƤ⥵֤
*
*   RETURN:		ꥹȤΥХĹ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int   add_bin4( int  addv, char *ary, int len)
{
  int    i ;

  for( i = 0 ; i < len  ; i += 4 ) {
    if ( addv == *(int *)ary ) {
      return( len ) ;
    }
    ary += 4 ;
  }
  *(int *)ary = addv ;
  return( len + 4 ) ;
}



/****************************************************************
*   ХʥꣴХȤοͤϢ³ƤꥹȤ鳺Х塼롣
*   USAGE:		del_bin4( int  addv, char *ary, int len)
*   SYNOPSIS:		int   addv   (IN)  
*                       char  *ary   (IN)  ХʥꣴХȥꥹȤƬݥ
*                       int   len    (IN)  ХʥꣴХȥꥹȤĹ
*
*   DESCRIPTION:	
*	Ϥ줿ͤꥹ¸ߤʤ硢⤻Τޤ֤
*
*   RETURN:		ꥹȤΥХĹ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int   del_bin4( int  addv, char *ary, int len)
{
  int    i ;

  for( i = 0 ; i < len  ; i += 4 ) {
    if ( addv == *(int *)ary ) {
      for( ; i < len  ; i+= 4 ) {
        *(int *)ary = *(int *)(ary+4) ;
        ary += 4 ;
      }
      return( len - 4 ) ;
    }
    ary += 4 ;
  }
  return( len ) ;
}




/****************************************************************
*   ʸ⤫ꤵ줿ʸǽ˸֤롣
*   USAGE:		skip_ptr( char val, char *cptr)
*   SYNOPSIS:		char  val   (IN)  ʸASCII
*                       char  *cptr (IN)  ʸ
*
*   DESCRIPTION:	
*       Ƭ饵ʸγǼ֤롣
*	ʸ¸ߤʤϡNULL֤
*       ֥륯ȡ"ˤ˶ޤƤ֤Ϥоݤ
*       ʤʤ
*
*   RETURN:		ʸΥݥ󥿡
*                       NULL: ʸĤʤ
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
char *skip_ptr(char val, char *cptr ) 
{
  int flag = 1 ;

  while( *cptr != '\0') {
    if ( flag < 0 ) {
      if ( *cptr == '\\' ) {
        cptr++   ;
        cptr++   ;
        continue ;
      }
      if ( *cptr == '\"' ) 
        flag *= ( -1 ) ;
      cptr++   ;
      continue ;
    }
    if ( *cptr == '\\' ) {
      cptr++   ;
      cptr++   ;
      continue ;
    }
    if ( *cptr == '\"' ) 
      flag *= ( -1 ) ;
    else if  ( *cptr == val ) {
      return cptr ;
    }
    cptr++ ;
  }
  return NULL ;
}




/****************************************************************
*   ʸ⤫ꤵ줿ʸǽ˸֤롣
*   USAGE:		search_char( char val, char *cptr)
*   SYNOPSIS:		char  val   (IN)  ʸASCII
*                       char  *cptr (IN)  ʸ
*
*   DESCRIPTION:	
*       Ƭ饵ʸγǼ֤롣
*	ʸ¸ߤʤϡNULL֤
*       skip_ptr Ȥΰ㤤ϡ֥륯ȡ"ˤ˶ޤ
*       ʬ⸡оݤˤʤ뤳ȤǤ롣
*
*   RETURN:		ʸΥݥ󥿡
*                       NULL: ʸĤʤ
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
char *search_char(char val, char *cptr ) 
{
  int flag = 1 ;

  while( *cptr != '\0') {
    if ( *cptr == '\\' ) {
      cptr++   ;
      cptr++   ;
      continue ;
    }
    if ( *cptr == val ) {
      return cptr ;
    }
    cptr++ ;
  }
  return NULL ;
}



/****************************************************************
*   ץȥ饯ޤǥåפ롣
*   USAGE:		skip_non_sp( char *cptr)
*   SYNOPSIS:		char  *cptr (IN)  ʸ
*
*   DESCRIPTION:	
*       Ϥ줿ʸΥڡ䥿ְʳʸȤ
*       롣
*	ʳʸʤϡNULL֤
*
*   RETURN:		ʸΥݥ󥿡
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
char *skip_non_sp( unsigned char *cptr ) 
{
  if ( cptr == NULL )
    return NULL ;
  while( *cptr != '\0') {
    if  ( *cptr > ' ' ) {
      return cptr ;
    }
    cptr++ ;
  }
  return NULL ;
}



/****************************************************************
*   ʬåפ롣
*   USAGE:		skip_a_word( char *cptr)
*   SYNOPSIS:		char  *cptr (IN)  ʸ
*
*   DESCRIPTION:	
*       ""ǰϤޤ줿ϰϤޤϡʬˤ륹ڡΰ֤
*       롣
*
*   RETURN:		ʸΥݥ󥿡
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
char *skip_a_word( unsigned char *cptr ) 
{
  int flag = 1 ;

  if ( cptr == NULL )
    return NULL ;
  while( *cptr > ' ') {
    if ( *cptr == '\\' ) {
      cptr++ ;
      if ( *cptr <= ' ' )
        break ;
      cptr++ ;
      continue ;
    }
    if ( flag < 0 ) {
      if ( *cptr == '\"' ) 
        flag *= ( -1 ) ;
      cptr++ ;
      continue ;
    }
    if ( *cptr == '\"' ) {
      flag *= ( -1 ) ;
      cptr++ ;
      continue ;
    }
    cptr++ ;
  }
  return cptr ;
}



/****************************************************************
*   ɥԡ롣
*   USAGE:		copy_word( char *cptr, int size , char *start, char *stop )
*   SYNOPSIS:		char  *cptr  (OUT)  ɳǼ륨ꥢ
*                       int   size   (IN)   Ǽꥢ
*                       char  *start (IN)   ԡƬɥ쥹
*                       int   *stop  (IN)   ԡνüɥ쥹ʤޤޤ
*
*   DESCRIPTION:	
*       Ϥ줿ʸΥڡ䥿ְʳʸϰϤ򥳥ԡ롣
*
*   RETURN:		žХȿ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  copy_word( char *out, int size , char *start, char *stop )
{
  int flag = 1 ;
  int ii = 0 ;
  char *sv = out ;

  while( *start != '\0' && (stop == NULL || start < stop)) {
    if ( flag < 0 ) {
      if ( *start == '\\' ) {
        if ( ( ii + 2 ) >= size ) {
          fprintf( stderr,"ERROR(copy_word):Copy buffer is too small\n") ;
          *sv = '\0' ;
          return -1 ;
        }
        *out = *start ; out++ ; start++;
        *out = *start ; out++ ; start++;
        continue ;
      }
      if ( *start == '\"' ) 
        flag *= ( -1 ) ;
      if ( ( ii + 1 ) >= size ) {
        fprintf( stderr,"ERROR(copy_word):Copy buffer is too small\n") ;
        *sv = '\0' ;
        return -1 ;
      }
      *out = *start ; out++ ; start++;
      continue ;
    }
    if ( *start == '\\' ) {
      if ( ( ii + 2 ) >= size ) {
        fprintf( stderr,"ERROR(copy_word):Copy buffer is too small\n") ;
        *sv = '\0' ;
        return -1 ;
      }
      *out = *start ; out++ ; start++;
      *out = *start ; out++ ; start++;
      continue ;
    }
    if ( *start == '\"' ) {
      flag *= ( -1 ) ;
    }
    if  ( (*start & 0x80) == 0 && *start < ' ' ) {
      break ;
    }
    if ( ( ii + 1 ) >= size ) {
      fprintf( stderr,"ERROR(copy_word):Copy buffer is too small\n") ;
      *sv = '\0' ;
      return -1 ;
    }
    *out = *start ; out++ ; start++;
  }
  *out = '\0' ;
  return ( out - sv ) ;
}







/* إɽʸХʥѴ */
int HextoBin(char *indata)
{
  int  ii ;
  int  ret = 0 ;
  char  *cp ;

  cp = indata ;
  while( *cp != '\0') {
    if (*cp >= '0' && *cp <= '9')
       ii = *cp - '0';
    else if (*cp >= 'a' && *cp <= 'f')
       ii = *cp - 'a' + 10;
    else {
       printf("ERROR(HextoBin):Input[%s] is illegal\n",indata ) ;
       return -1 ;
    }
    ret = ret << 4 ;
    ret += ii ;
    cp++ ;
  }
  return ( ret ) ;
}




/* إɽʸ󤫤ɤå */
int ChkHex(char *indata)
{
  int  ii ;
  int  ret = 0 ;
  char  *cp ;

  cp = indata ;
  while( *cp != '\0') {
    if (*cp >= '0' && *cp <= '9')
       ii = *cp - '0';
    else if (*cp >= 'a' && *cp <= 'f')
       ii = *cp - 'a' + 10;
    else {
       return -1 ;
    }
    ret = ret << 4 ;
    ret += ii ;
    cp++ ;
  }
  return ( ret ) ;
}





/* ߥǶڤ줿ʸΤɤ줫Ϳ줿ʸƱ
   ɤĴ٤롣
   ʤ -1 ֤
*/
int memberpstr(char *savehatu,char *hatsuo)
{
  int  ii = 0;

  while(*savehatu != '\0') {
    ii++ ;
    if (strncmp(savehatu,hatsuo,strlen(hatsuo)) == 0 &&
        ( *(savehatu+strlen(hatsuo)) == ';' ||
          *(savehatu+strlen(hatsuo)) == '\0'))
      return ii;
    for ( ;*(savehatu) != '\0' ;savehatu++) {
      if ( *(savehatu) == ';' ) {
        savehatu++ ;
        break ;
      }
    }
  }
  return -1 ;
}



/* ꤵ줿Ĺʬإɽʸˤ */
int BintoHex(int len, char *inbuff, char *outbuff)
{
  int  kk ,oo ;
  unsigned short sh ;

  for ( kk = oo = 0 ; kk < len && oo < 1024; kk++) {
    sh = (unsigned short)inbuff[kk] & 0xff;
    if (sh == 0 && oo == 0) 
	continue ;
    sprintf( outbuff, "%02hx", sh );
    oo += 2;
    outbuff += 2;
  }
  if (oo >= 1024) {
     return (-1) ;
  }
  
  *outbuff = '\0' ;
  return (oo) ;
}





/* إɽʸ򥢥ե٥åȤʸѴ */
int SmallHex(char *indata)
{
  int  ii ;
  int  ret = 0 ;
  char  *cp ;

  cp = indata ;
  while( *cp != '\0') {
    if (*cp >= 'A' && *cp <= 'F')
       *cp = (*cp - 'A') + 'a';
    cp++ ;
  }
  return ( cp - indata ) ;
}






/* ʸ asciiʸʣХʸˤʸѴ */
int  Conv2Big(char *out, char *small)
{
  int  ii ;
  int ret = 1 ;
  char *ss = small ;

  while( *small != '\0' ) {
    if ( (*small & 0x80 ) != 0) {
      *out = *small ; out++ ; small++;
      *out = *small ; out++ ; small++;
      continue ;
    }

    if ( EDR_Henkan[ *(small) ] != NULL ) {
      *out = *(EDR_Henkan[ *(small) ]) ; out++ ; 
      *out = *(EDR_Henkan[ *(small) ] + 1) ; out++ ; 
      small++ ;
    }
    else {
      fprintf(stderr,"(Conv2Big)[%c](%s)\n",*small,ss) ;
      small++ ;
      ret = -1 ;
    }
  }
  *out = '\0' ;
  return ret ;
}





/* ʸ ʣХʸˤasciiʸѴ */
int  Conv2Small(char *out, char *big)
{
  int  ii ;
  int ret = 0 ;
  char *ss = big ;

  while( *big != '\0' ) {
    if ( (*big & 0x80 ) != 0) {
      for( ii = 0 ; ii < 256 ; ii++ ) {
        if ( EDR_Henkan[ii] != NULL &&
             memcmp( big, EDR_Henkan[ii] , 2 ) == 0 ) 
          break ;
      }
      if ( ii == 256 ) {
        *out = *big ; out++ ; big++;
        *out = *big ; out++ ; big++;
        ret += 2 ;
      }
      else {
        *out = ii ; out++ ;
        big += 2 ;
        ret++ ;
      }      
      continue ;
    }
    *out = *big ; out++ ; 
    big++ ;
    ret++ ;
  }
  *out = '\0' ;
  return ret ;
}









/**********************************************************
*   ХȥǡbinɤߤȤä֤ͤ
*   USAGE:	        get2byte( char *work) 
*   SYNOPSIS:		char *work  (IN) ХbinǼ
*
*   DESCRIPTION:	
*	ХȤΥХʥ꡼ǡɤߤȤꡢ֤ͤ
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  get2byte(char *work)
{
  int  rlen ;
  char wk[2] ;

  wk[0] = *work ;
  wk[1] = *(work+1) ;
  
  rlen = *(unsigned short *)wk ;
  return rlen ;
}


/**********************************************************
*   ХȤΥХʥ꡼ǡꤵ줿ɥ쥹˥åȤ롣
*   USAGE:	        put2byte( short val, char *work) 
*   SYNOPSIS:		short  val  (IN) Ǽ
*                       char *work  (IN) ХbinǼ
*
*   DESCRIPTION:	
*	ХȤΥХʥ꡼ǡɤߤȤꡢ֤ͤ
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  put2byte(short val, char *work)
{
  int  rlen ;
  char wk[2] ;

  *(short *)wk = val ;
  *work = wk[0] ;
  *(work+1) = wk[1] ;
  
  return val ;
}




/**********************************************************
*   ХȥǡbinɤߤȤä֤ͤ
*   USAGE:	        get4byte( char *work) 
*   SYNOPSIS:		char *work  (IN) ХbinǼ
*
*   DESCRIPTION:	
*	ХȤΥХʥ꡼ǡɤߤȤꡢ֤ͤ
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  get4byte(char *work)
{
  int  rlen ;
  char wk[4] ;

  wk[0] = *work ;
  wk[1] = *(work+1) ;
  wk[2] = *(work+2) ;
  wk[3] = *(work+3) ;
  
  rlen = *(int *)wk ;
  return rlen ;
}


/**********************************************************
*   ХȤΥХʥ꡼ǡꤵ줿ɥ쥹˥åȤ롣
*   USAGE:	        put4byte( int val, char *work) 
*   SYNOPSIS:		short  val  (IN) Ǽ
*                       char *work  (IN) ХbinǼ
*
*   DESCRIPTION:	
*	ХȤΥХʥ꡼ǡꤵ줿ɥ쥹إåȤ롣
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  put4byte(int val, char *work)
{
  int  rlen ;
  char wk[4] ;

  *(int *)wk = val ;
  *work = wk[0] ;
  *(work+1) = wk[1] ;
  *(work+2) = wk[2] ;
  *(work+3) = wk[3] ;
  
  return val ;
}










